2009-03-31  Adam Jackson  <ajax@redhat.com>

	* src/vteapp.c:
	Add gopher:// to the dingus-click regexes.

2009-03-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (always_selected):
	* src/vtepangocairo.c (_vte_pangocairo_set_background_image):
	* src/vteskel.c (_vte_skel_draw_text):
	Minor fixes from Richard Russon.

2009-03-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 576797 – Double-click sometimes stops working

	* src/vte.c (vte_terminal_extend_selection): Invalidate selection
	if forced.

2009-03-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 573674 – reset resets width to 80 chars

	* src/vteseq.c (vte_sequence_handler_decset_internal): Disable
	resizing on decreset.

2009-03-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 576504 – vte does not pass its testsuite.

	* src/vte.c:
	* src/vtedraw.h:
	Fix "make check".

2009-03-15  Christian Persch  <chpe@gnome.org>

	Bug 574491 – gnome-pty-helper can prevent volumes from being unmounted

	* gnome-pty-helper/gnome-pty-helper.c: (main): chdir to /.

2009-03-15  Christian Persch  <chpe@gnome.org>

	* configure.in: Prepare version 0.20.0.

2009-03-15  Christian Persch  <chpe@gnome.org>

	Bug 575398 – configure warns about term.h under OpenSolaris

	* configure.in: Fix curses detection on solaris. Patch by David	Adam.

2009-03-09  Behdad Esfahbod  <behdad@gnome.org>

	Bug 574616 – "real" transparency not working from python bindings

	* src/vtepangocairo.c (_vte_pangocairo_destroy),
	(_vte_pangocairo_set_background_image): Better handle failure of
	creating pixmap.

	* src/vtebg.c (vte_bg_get_pixmap): Get rid of unused mask parameter.

2009-03-07  Behdad Esfahbod  <behdad@gnome.org>

	Bug 574025 – Crash in _vte_terminal_insert_char

	* src/vte.c (_vte_terminal_insert_char): Don't crash.

2009-03-02  Christian Persch  <chpe@gnome.org>

	* NEWS:
	* configure.in: Updated for version 0.19.5.

2009-03-02  Christian Persch  <chpe@gnome.org>

	* src/vteaccess.c: (vte_terminal_accessible_set_size),
	(vte_terminal_accessible_ref_accessible_at_point):
	* src/vteapp.c: (button_pressed): Correct use of padding returned
        by vte_terminal_get_padding().

2009-03-02  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_refresh_size), (vte_terminal_set_size):
	Use g_strerror() instead of strerror().

2009-02-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 54926 – Should try bold version of font before pseudo-bolding

	Patch from Kees Cook <kees@outflux.net>

	* src/vte.c (_vte_invalidate_cell), (_vte_invalidate_cursor_once),
	(vte_terminal_unichar_is_local_graphic),
	(vte_terminal_draw_graphic), (vte_terminal_draw_cells),
	(vte_terminal_draw_rows), (vte_terminal_paint_cursor):
	* src/vtedraw.c (_vte_draw_get_char_width), (_vte_draw_text),
	(_vte_draw_char), (_vte_draw_has_char):
	* src/vtedraw.h:
	* src/vtepangocairo.c (_vte_pangocairo_set_text_font),
	(_vte_pangocairo_get_char_width), (_vte_pangocairo_has_bold),
	(_vte_pangocairo_draw_text), (_vte_pangocairo_draw_has_char):
	* src/vteskel.c:
	Try bold font before pseudo-bolding.

2009-02-02  Christian Persch  <chpe@gnome.org>

	Bug 570208 – vte fails to build outside source tree

	* python/Makefile.am: Build fix.

2009-02-01  Christian Persch  <chpe@gnome.org>

	* src/marshal.list:
	* src/vte.c: (vte_terminal_class_init):
	* src/vtebg.c: (vte_bg_class_init): Remove marshalers that have stock
	ones in gobject, and use the stock ones instead.

2009-02-01  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in: Require GTK+ >= 2.14, for "gtk-fontconfig-timestamp"
	settings property.

	* src/vte.c (vte_terminal_style_set),
	(vte_terminal_set_font_full_internal), (vte_terminal_init),
	(vte_terminal_class_init):  Use style_set class method instead of
	hooking to style-set signal.  Also, proceed to recreating the font
	even if neither description nor antialias setting changed.  This is
	necessary to pick up fontconfig configuration changes as well as font
	install/uninstallations or GNOME font preferences changes.

	* src/vtepangocairo.c (font_info_destroy),
	(fontconfig_timestamp_quark),
	(vte_pango_cairo_set_fontconfig_timestamp),
	(vte_pango_cairo_get_fontconfig_timestamp), (context_hash),
	(context_equal), (font_info_create_for_context),
	(font_info_create_for_screen):
	Use fontconfig_timestamp in the font object hash, such that we respond
	to fontconfig configuration changes.

2009-01-22  Saleem Abdulrasool <compnerd@compnerd.org>

	* src/vteseq.c (vte_sequence_handler_window_manipulation):
		Tweak output for OSC 13, 14, 18, 19, 20, 21.  Bug #548272.

2009-01-20  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_realize): Use GDK_BLANK_CURSOR for the
	invisible cursor on gtk+ >= 2.15.

2009-01-20  Christian Persch  <chpe@gnome.org>

	* gnome-pty-helper/gnome-pty-helper.c: (init_term_with_defaults),
	(open_ptys), (close_pty_pair): Use ttyname() as recommended in the
	glibc manual. Bug #565688.

2009-01-06  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_parse_color),
	(vte_sequence_handler_change_color),
	(vte_sequence_handler_request_terminal_parameters),
	(vte_sequence_handler_send_primary_device_attributes),
	(vte_sequence_handler_send_secondary_device_attributes),
	(vte_sequence_handler_device_status_report),
	(vte_sequence_handler_dec_device_status_report),
	(vte_sequence_handler_window_manipulation),
	(vte_sequence_handler_change_cursor_color):
	Convert some g_strdup_printf() uses to g_snprintf() when
	the buffer was fixed-size and freed immediately.
	Also fix g_snprintf usage by not using its return value.
	*If* the buffer is short, the returned len is not what we
	are interested in.
	Finally, pass -1 as len to vte_terminal_feed_child() in
	most places.  This means a bit more work for the processor,
	but cleaner code.

2009-01-06  Behdad Esfahbod  <behdad@gnome.org>

	Bug 566795 – VTE fails to build in trunk

	* src/vteseq.c (vte_sequence_handler_change_cursor_color):
	Fix build.

2009-01-06  Saleem Abdulrasool <compnerd@compnerd.org>

	* src/vteseq-n.gperf:
	* src/vteseq.c (vte_ucs4_to_utf8), (vte_parse_color),
	(vte_terminal_emit_deiconify_window), (vte_sequence_handler_change_color),
	(vte_sequence_handler_change_cursor_color):

	Bug #524170 - Pull out ucs4_to_utf8 and use in new functions.  Add support
	for OSC 4 (initc) and OSC 12 (change cursor color).

2009-01-06  Behdad Esfahbod  <behdad@gnome.org>

	Bug 566730 – vte_terminal_set_color_cursor() calls invalidate_all but
	it doesn't have to

	* src/vte.c (vte_terminal_set_color_internal): If color is VTE_CUR_BG,
	invalidate_cursor_once instead of invalidate_all.

2008-12-26  Halton Huo  <halton.huo@sun.com>

	Bug 565679 – alloca is discouraged

	* gnome-pty-helper/gnome-pty-helper.c: use malloc replace alloca.

2008-12-26  Christian Persch  <chpe@gnome.org>

	* configure.in: Fix the same typo also in the libinfo check.

2008-12-26  Halton Huo  <halton.huo@sun.com>

	Bug 565675 – typo in configure.in cause ncurses checking fail

	* configure.in: Fix typo for ncurses. s/ncuses/ncurses

2008-12-25  Behdad Esfahbod  <behdad@gnome.org>

	* src/interpret.c (main):
	* src/slowcat.c (catfile):
	* src/table.c (_vte_table_addi), (_vte_table_add):
	* src/trie.c (_vte_trie_matchx):
	* src/vte.c (_vte_invalidate_cell), (_vte_terminal_insert_char):
	* src/vteaccess.c (offset_from_xy),
	(vte_terminal_accessible_finalize),
	(vte_terminal_accessible_get_text),
	(vte_terminal_accessible_get_text_somewhere):
	* src/vteapp.c (main):
	* src/vtebg.c (vte_bg_cache_item_free), (vte_bg_cache_add):
	Fix warnings.

2008-12-25  Behdad Esfahbod  <behdad@gnome.org>

	Bug 565663 – compile failure because use static function in another .h
	file

	* src/vte.c: Don't mark extern function inline.

2008-12-17  Behdad Esfahbod  <behdad@gnome.org>

	Bug 149631 – gnome-terminal doesn't combine combining chars in utf8

	* src/vteunistr.c:
	Limit to 9 combining marks per unistr, and a total of 100,000 unistrs.
	All to prevent OOM.

2008-12-15  Behdad Esfahbod  <behdad@gnome.org>

	* NEWS:
	* configure.in:
	Released 0.19.4.

2008-12-14  Behdad Esfahbod  <behdad@gnome.org>

	Bug 564535 – check for gperf on build

	* autogen.sh: Check for gperf.

2008-12-12  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/Makefile.am:
	* src/vteunistr.c (unistr_comp_hash), (unistr_comp_equal),
	(_vte_unistr_append_unichar), (_vte_unistr_get_base),
	(_vte_unistr_append_to_string), (_vte_unistr_strlen):
	* src/vteunistr.h:
	Document vteunistr.

2008-12-12  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteunistr.h: Minor cleanup.

2008-12-12  Behdad Esfahbod  <behdad@gnome.org>

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Avoid pointers in the
	const array.

2008-12-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 149631 – gnome-terminal doesn't combine combining chars in utf8

	* src/vteunistr.c:
	* src/vteunistr.h:
	An extended UTF-32 type that assigns numeric values to UTF-8 sequences
	on demand.  Can be used to efficiently store a string, instead of one
	character, at each cell.

	* src/vte-private.h:
	* src/vte.c:
	* src/vtedraw.c:
	* src/vtedraw.h:
	* src/vtepangocairo.c:
	Port to vteunistr instead of gunichar for cell content.
	
	* src/vte.c:
	Handle zerowidth insertions by sticking it on the previous cell.

	* src/iso2022.h:
	* src/iso2022.c:
	Cleanup ambiguous-width handling.  Handle zero-width chars.

2008-12-11  Christian Persch  <chpe@gnome.org>

	Bug 564057 – src/pty.c does not compile with
	--disable-gnome-pty-helper
	
	* src/pty.c: Build with --disable-gnome-pty-helper. Patch by
	yselkowitz at users.sourceforge.net .

2008-12-11  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_class_init): Update set-scroll-adjustement
	docs.

2008-12-10  Paolo Borelli  <pborelli@katamail.com>

	Bug 562695 - ship pkg-config file for python bindings

	* configure.in:
	* python/Makefile.am:
	* python/pyvte.pc.in:

2008-12-08  Behdad Esfahbod  <behdad@gnome.org>

	Bug 563752 – pangocairo backend recreates cairo_surface_t for
	background drawing

	* src/vte.c (vte_terminal_paint),
	(vte_terminal_set_scroll_background),
	(vte_terminal_background_update):
	* src/vtedraw.c (_vte_draw_new), (_vte_draw_set_background_solid),
	(_vte_draw_set_background_image),
	(_vte_draw_set_background_scroll), (_vte_draw_draw_rectangle):
	* src/vtedraw.h:
	* src/vtepangocairo.c (_vte_pangocairo_destroy),
	(_vte_pangocairo_set_background_solid),
	(_vte_pangocairo_set_background_image),
	(_vte_pangocairo_set_background_scroll), (_vte_pangocairo_clear),
	(_vte_pangocairo_clip), (set_source_color_alpha):
	* src/vteskel.c:
	Cleanup vte_draw background API.  Use a cached cairo_pattern_t in
	pangocairo backend.

	Also, queue background update on scroll_background change.

2008-12-07  Behdad Esfahbod  <behdad@gnome.org>

	Bug 163213 – Cursor should remain visible when selected

	* src/vte.c (vte_terminal_paint_cursor): Do a reverse hollow cursor
	if selected but not focused.

2008-12-05  Christian Persch  <chpe@gnome.org>

	* src/vtebg.c: (vte_bg_get_pixmap): Don't modify source_pixbuf. If
	we're going to change the saturation, first make a copy. Fixes
	switching background type between fauxtransparency and image in
	gnome-terminal trunk.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (_vte_pangocairo_clear): Fix scrolling offset.
	Ray Strode reported that background offset was being done incorrectly.
	A negation did it.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* Makefile.am:
	* configure.in:
	Hook up perf/.

	Also adjust svn:ignore props.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* NEWS:
	* configure.in:
	Released 0.19.3.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_new_row_data), (_vte_new_row_data_sized),
	(vte_terminal_match_contents_refresh),
	(vte_terminal_process_incoming), (vte_terminal_init),
	(vte_terminal_set_word_chars):
	Always call g_array_new() with clear flag set.  It incurs no overhead
	but avoids heisenbugs.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_terminal_insert_char):
	* src/vteseq.c (vte_sequence_handler_screen_alignment_test):
	Use structure assignment instead of memcpy().

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_terminal_cleanup_tab_fragments_at_cursor): Remove
	unneeded checks.  They were masking bugs.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	Red Hat Bug 474618 -  gnome-terminal sometime leaves empty begining
	of the line

	* src/vte.c (_vte_terminal_insert_char): Really fix the bug this time.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	Build fixes.

	* NEWS:
	* configure.in:
	Released 0.19.2.

2008-12-05  Behdad Esfahbod  <behdad@gnome.org>

	Red Hat Bug 474618 -  gnome-terminal sometime leaves empty begining
	of the line

	* src/vte.c (_vte_terminal_cleanup_tab_fragments_at_cursor): continue
	instead of break'ing out of the loop.

2008-12-04  Behdad Esfahbod  <behdad@gnome.org>

	Bug 563274 – Misspelled word in src code

	* src/vte.c (vte_terminal_process_incoming): Fix typo.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 563024 – In alternate-screen, selection can copy out of screen
	boundaries

	* src/vte.c (vte_terminal_extend_selection_expand),
	(vte_terminal_extend_selection): Make sure current selection row is in the
	visible screen.

	I have a deja vu of fixing this bug like two years ago...

2008-12-02  Christian Persch  <chpe@gnome.org>

	Bug 552096 – Detect tgetent if provided by libtinfo

	* configure.in: Rewrote tgetent checks to be more readable. Also check
	for tgetent in libtinfo.
	* src/keymap.c: (_vte_keymap_map), (_vte_keymap_key_is_modifier):
	* src/ssfe.c: Adjust includes accordingly.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_start_selection),
	(vte_terminal_extend_selection): Don't do fancy rounding for row
	selection, only for column.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_invalidate_selection),
	(vte_terminal_start_selection): Call function instead of open coding.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtedraw.h:
	* src/vtepangocairo.c (font_info_cache_ascii):
	Cache the full ASCII range if Latin uses the default language.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (context_hash), (context_equal),
	(font_info_create_for_context), (font_info_create_for_screen),
	(font_info_create_for_widget): Respect PangoLanguage set on a widget's
	PangoContext.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_measure_font): Remove CJK fullwidth
	measurement hacks.  Pango doesn't need these.  We're down to one
	FcFontSort() instead of two during initialization.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 559818 – redundant selection-changed signal on deselection

	* src/vte.c (vte_terminal_start_selection),
	(vte_terminal_extend_selection): Fix all redundant selection-changed
	signals.  Including those on double-click.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c:
	Rewrite text selection.  In particular, fix block_mode.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* HACKING: Update.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_set_pointer_visible),
	(vte_terminal_get_mouse_tracking_info),
	(vte_terminal_send_mouse_button_internal),
	(vte_terminal_maybe_send_mouse_button),
	(vte_terminal_maybe_send_mouse_drag), (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release),
	(vte_terminal_scroll), (vte_terminal_reset):
	* src/vteseq.c (vte_sequence_handler_decset_internal):
	Mouse tracking cleanup.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in: Add -Wno-switch-enum warning flag as we are not
	-Wswitch-enum clean.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_extend_selection_on_type),
	(vte_terminal_extend_selection):
	Cut one third of the 400-line function out into a function of its own.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_extend_selection): Revert previous change.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_extend_selection):  Add a shortcircuit
	check.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_send_mouse_button_internal),
	(vte_terminal_maybe_send_mouse_drag), (cursor_inside_match),
	(vte_terminal_match_hilite_show),
	(vte_terminal_match_hilite_update), (vte_terminal_match_hilite),
	(vte_terminal_extend_selection), (vte_terminal_autoscroll),
	(vte_terminal_motion_notify), (vte_terminal_button_press),
	(vte_terminal_button_release):
	Change mouse coordinates type from double to long.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_start_selection),
	(vte_terminal_extend_selection):
	Cleanup selection code a bit more.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_start_selection),
	(vte_terminal_extend_selection):
	Merge selection_origin and selection_restart_origin as only one was
	being used at a time.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 471480 – select single character
	Bug 110371 – Cannot select newline at end of full line

	* src/vte-private.h:
	* src/vte.c (find_start_column), (find_end_column),
	(vte_terminal_start_selection), (math_div),
	(vte_terminal_extend_selection):
	Make selection work more I-beam-like.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_class_init): Show the correct version in
	Since: and Deprecated: annotations.

2008-12-02  Christian Persch  <chpe@gnome.org>

	Bug 112172 – Get rid of VteReaper

	* src/reaper.h: Deprecate.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* configure.in: Enable maintainer mode by default. Define more
	deprecation defines, and define the *_DISABLE_SINGLE_INCLUDES defines.
	Enable deprecations by default in maintainer mode.
	* src/vteapp.c: Undef VTE_DISABLE_DEPRECATED here.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* configure.in:
	* src/vte-private.h: Move VTE_UTF8_BPC definition from configure to
	vte-private.h.
	* src/vteconv.c: Include vte-private.h here.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* src/vte-private.h:
	* src/vte.c: (mark_input_source_invalid),
	(_vte_terminal_connect_pty_read), (mark_output_source_invalid),
	(_vte_terminal_connect_pty_write),
	(_vte_terminal_disconnect_pty_read),
	(_vte_terminal_disconnect_pty_write),
	(_vte_terminal_enable_input_source), (remove_cursor_timeout),
	(vte_terminal_key_press), (vte_terminal_focus_in),
	(vte_terminal_focus_out), (vte_terminal_init),
	(vte_terminal_unrealize), (vte_terminal_expose),
	(vte_terminal_background_update), (add_update_timeout),
	(remove_from_active_list), (vte_terminal_add_process_timeout),
	(process_timeout), (update_repeat_timeout), (update_timeout): Remove
	VTE_INVALID_SOURCE definition and just use 0 directly.

2008-12-02  Christian Persch  <chpe@gnome.org>

	Bug 560667 – invalid definition of VTE_INVALID_SOURCE

	* src/vte-private.h: Fix VTE_INVALID_SOURCE define to use 0 instead of
	-1.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* configure.in: Remove two AC_DEFINEs from here.
	* src/vte-private.h: Define VTE_INVALID_SOURCE here for now.

2008-12-02  Christian Persch  <chpe@gnome.org>

	Bug 112172 – Get rid of VteReaper

	* src/reaper.c: (vte_reaper_child_watch_cb),
	(vte_reaper_add_child), (vte_reaper_init),
	(vte_reaper_constructor), (vte_reaper_finalize),
	(vte_reaper_class_init), (vte_reaper_get), (child_exited), (main):
	* src/reaper.h: Prepare for removal of Reaper in vte1.0 by removing
	the unused pre-glib-2.4 code from Reaper.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* src/vteapp.c: (main): Catch the child-exited signal to the child's
	exit code.

2008-12-02  Christian Persch  <chpe@gnome.org>

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_class_init): Intern the signal names.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_motion_notify): Do not discard motion notify
	events with coordinates out of our allocation, or when the cell under
	the cursor didn't change.  These are useful for extending selection
	and for sub-cell selection details, as well as app-requested all
	motion tracking.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 541441 – Dehighlight links on visibility notify?

	* src/vte.c (vte_terminal_focus_in), (vte_terminal_enter):  Move match
	highlight enabling into "enter" event instead of "focus in".

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_set_pointer_visible),
	(vte_terminal_maybe_send_mouse_button),
	(vte_terminal_maybe_send_mouse_drag), (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release),
	(vte_terminal_scroll), (vte_terminal_reset):
	* src/vteseq.c (vte_sequence_handler_decset_internal):
	Simplify mouse event tracking by using a single int instead of five
	booleans.

2008-12-02  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_deselect_all),
	(vte_terminal_process_incoming), (vte_cell_is_selected),
	(vte_terminal_copy), (vte_terminal_start_selection),
	(vte_terminal_extend_selection), (vte_terminal_select_all),
	(vte_terminal_paint), (_vte_terminal_get_start_selection),
	(_vte_terminal_get_end_selection), (_vte_terminal_select_text):
	Rename struct selection_cell_coords members from x,y to col,row for
	clarity.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* NEWS:
	* configure.in:
	Released 0.19.1.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/Makefile.am:
	* doc/reference/check-doc-syntax.sh:
	* src/Makefile.am:
	* src/check-doc-syntax.sh:
	* src/vte.c (vte_terminal_catch_child_exited),
	(vte_terminal_class_init):
	* src/vte.h:
	* src/vtepangocairo.c:
	Copy check-doc-syntax.sh tests from cairo and fix doc bugs.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/tmpl/vte-unused.sgml:
	* doc/reference/vte-sections.txt:
	Remove reaper docs.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	Bug 562806 – crash in Terminal: Typing "cd " just after ...

	* src/vte.c (_vte_terminal_cleanup_tab_fragments_at_cursor):
	Fix possible NULL dereference.

	* src/vteseq.c (vte_sequence_handler_ta):
	Fix tab fragments to have \t as c.

2008-12-01  Christian Persch  <chpe@gnome.org>

	* NEWS:
	* configure.in: Prepare 0.19.0.

2008-12-01  Christian Persch  <chpe@gnome.org>

	Bug 562511 – scrollbar doesn't sit at the bottom

	* src/vte.c: (vte_terminal_init),
	(vte_terminal_set_scrollback_lines): Always update the scrollback
	lines, even if the setting hasn't changed. Work-around to fix bug
	#562511.

2008-12-01  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_class_init): Fix visible-bell property.

2008-12-01  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_set_font_full_internal),
	(vte_terminal_class_init): Rename font property to "font-desc" to be
	more in line with other properties of this type in gtk.

2008-12-01  Christian Persch  <chpe@gnome.org>

	* src/vteapp.c: (main): Add gobject notification debugging.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_terminal_termcap_string_same_as_for),
	(vte_sequence_handler_se), (vte_sequence_handler_so):
	Simplify standout handling code.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Rip out VTE_SEQUENCE_HANDLER_PROTO.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Rip out vte_sequence_handler_invoke.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Rip out VTE_SEQUENCE_HANDLER_INVOKE.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Rip out VTE_SEQUENCE_HANDLER_REFERENCE.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (_vte_terminal_handle_sequence): Rip out the gcc label
	vtable code.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (display_control_sequence),
	(_vte_terminal_handle_sequence):
	Some cleanup of the gcc label vtable code before I rip it out.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_sequence_handler_set_title_internal),
	(vte_sequence_handler_set_mode_internal),
	(vte_sequence_handler_invoke_internal):
	Move some code around.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteskel.c: Remove excess initializer.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/buffer.c:
	* src/caps.c:
	* src/dumpkeys.c:
	* src/interpret.c:
	* src/iso2022.c:
	* src/keymap.c:
	* src/matcher.c:
	* src/mev.c:
	* src/pty.c:
	* src/reaper.c:
	* src/reflect.c:
	* src/ring.c:
	* src/slowcat.c:
	* src/ssfe.c:
	* src/table.c:
	* src/trie.c:
	* src/vteaccess.c:
	* src/vtebg.c:
	* src/vteconv.c:
	* src/vtedraw.c:
	* src/vteseq.c:
	* src/vteskel.c:
	* src/xticker.c:
	#include <config.h> instead of "../config.h".

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Some wild crack to build the vtable using gcc
	extension for labels as values.  The advantage is that we get down to
	an empty .data for vteseq.o but .text grows considerably.  And we have
	to use nested functions, and #define static auto.  It's really ugly.
	I'm going to remove it in the next commit or the one after.  Just
	wanted to record it here for posterity.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_sequence_handler_invoke),
	(vte_sequence_handler_offset), (vte_sequence_handler_multiple),
	(vte_sequence_handler_decset_internal),
	(VTE_SEQUENCE_HANDLER_PROTO), (_vte_terminal_handle_sequence):
	Almost there.  Towards a .data-free vtable.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Finish decoupling handle type from function type.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vteseq.c (vte_sequence_handler_offset),
	(vte_sequence_handler_multiple),
	(vte_sequence_handler_decset_internal),
	(vte_sequence_handler_set_mode_internal),
	(VTE_SEQUENCE_HANDLER_PROTO), (_vte_terminal_handle_sequence):
	Make sequence handlers return void instead of gboolean.  The return
	value was unused.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_sequence_handler_offset),
	(vte_sequence_handler_multiple),
	(vte_sequence_handler_decset_internal),
	(VTE_SEQUENCE_HANDLER_PROTO), (_vte_terminal_handle_sequence):
	Switch to calling other handlers using two macros.
	Get rid of match and match_quark arguments to sequence handlers.
	They were unused.

2008-12-01  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_sequence_handler_set_title_internal):
	Cleanup vte_sequence_handler_set_title_internal.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (VTE_SEQUENCE_HANDLER_PROTO): Use a macro to define
	type of sequence handlers.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-2.c:
	* src/vteseq-n.c:
	Remove gperf-generated files from SVN, but still distribute them in
	the tarball.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c:
	* src/vteseq.c (_vte_terminal_scroll_text),
	(vte_sequence_handler_scroll_down),
	(vte_sequence_handler_scroll_up):
	More code shufflling.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-list.h:
	Remove vteseq-list.h from SVN, but still distribute it in the tarball.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-list.h:
	Autogenerate vteseq-list.h.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-list.h:
	* src/vteseq.c (_vte_terminal_home_cursor),
	(_vte_terminal_clear_screen), (_vte_terminal_clear_current_line),
	(_vte_terminal_clear_above_current),
	(vte_sequence_handler_decset_internal), (vte_sequence_handler_cl),
	(vte_sequence_handler_ho), (vte_sequence_handler_erase_in_display),
	(vte_sequence_handler_erase_in_line):
	Sync vteseql-list.h with actual handlers used in gperf files.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-list.h:
	* src/vteseq.c (vte_sequence_handler_scroll_down),
	(vte_sequence_handler_scroll_up):
	Implement these calling vte_terminal_scroll() directly instead of
	multiple'ing.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_scroll), (_vte_terminal_scroll_region):
	* src/vteseq.c (vte_sequence_handler_scroll_down_one),
	(vte_sequence_handler_scroll_up_one):
	Move vte_terminal_scroll to vte.c

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-2.c (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-2.gperf:
	* src/vteseq-list.h:
	* src/vteseq.c:
	Remove vte_sequence_handler_complain_key.  The idea was to warn about
	receiving control-sequence handling request for escape sequences that
	actually belong to a key stroke.  Kinda like a debugging feature.
	Remove it as the number of sequences being handle that way was
	greater than the number of sequences handled in the real sense.
	Saves 2k .data!

	The actual list is still in vteseq-2.gperf, but commented out.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (_vte_sequence_get_handler),
	(display_control_sequence):
	Remove stale comment.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vte-private.h:
	* src/vte.c (vte_terminal_process_incoming):
	* src/vteseq.c (display_control_sequence),
	(_vte_terminal_handle_sequence):
	* src/vteseq.h:
	Move _vte_terminal_handle_sequence() into vteseq.c

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_insert_line_internal), (vte_remove_line_internal),
	(_vte_terminal_cursor_down), (_vte_terminal_insert_char),
	(_vte_terminal_audible_beep), (_vte_terminal_visible_beep),
	(_vte_terminal_beep), (vte_terminal_key_press):
	* src/vteseq.c (vte_insert_line_internal),
	(vte_remove_line_internal), (vte_unichar_strlen),
	(vte_sequence_handler_bl), (vte_sequence_handler_sf),
	(vte_sequence_handler_SF), (vte_sequence_handler_vb):
	* src/vteseq.h:
	Some code reshuffling to remove vte.c calls to vteseq.c functions.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-2.gperf:
	* src/vteseq.c:
	Minor.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (vte_terminal_beep): Move helper function out of the
	way.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-2.c (vteseq_2_lookup):
	* src/vteseq-2.gperf:
	* src/vteseq-n.c (vteseq_n_lookup):
	* src/vteseq-n.gperf:
	* src/vteseq.c:
	Add a macro around sequence handler citations, for future table
	tricks.

2008-11-30  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-n.gperf:
	* src/vteseq-n.c (vteseq_n_hash), (vteseq_n_lookup):
	Remove bogus entry that accidentally made it into the gperf list.

2008-11-30  Christian Persch  <chpe@gnome.org>

	* acinclude.m4: Remove more crufty macros.

2008-11-30  Christian Persch  <chpe@gnome.org>

	* acinclude.m4: Remove FT2 check macro.

2008-11-30  Christian Persch  <chpe@gnome.org>

	Bug 540951 – The gnome-pty-helper is spawn when its not needed
	
	* src/pty.c: (_vte_pty_open): Don't use the pty helper when we don't
	need to update any of utmp, wtmp, lastlog. Patch by Alex Cornejo.

2008-11-30  Christian Persch  <chpe@gnome.org>

	Bug 465036 – gnome-pty-helper locks /var/run/utmp

	* gnome-pty-helper/gnome-utmp.c: (update_utmp): Close the utmp
	database after updating it. Patch by Kevin W. Rudd.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	Bug 127870 – terminal garbled and needs 'reset' after cat'ing file

	* src/iso2022.c (_vte_iso2022_state_new): Initialize all four maps
	(G0, G1, G2, G3) in USASCII mode, like xterm does.

2008-11-29  Christian Persch  <chpe@gnome.org>

	* python/vtemodule.c: (initvte): Register the constants too!

2008-11-29  Christian Persch  <chpe@gnome.org>

	* src/debug.c: (_vte_debug_init):
	* src/debug.h:
	* src/vte.c: (vte_terminal_size_request),
	(vte_terminal_size_allocate): Add a specific debug flag for widget
	size-request/size-allocation.

2008-11-29  Christian Persch  <chpe@gnome.org>

	* src/vteapp.c: (main): Add options to use a GtkScrolledWindow as the
	terminal's container, and to set its vertical scrollbar policy, to
	allow testing VteTerminal in a scrolled window.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	Bug 317236 – vte resynchrones too late on invalid UTF-8

	* src/vteconv.c (_vte_conv_utf8_utf8): In our UTF-8 to UTF-8 converter
	differentiate between an incomplete sequence and an ill sequence at
	the end of the buffer.  Also cleanup some minor inaccuracies (return
	value).

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	Bug 107031 – device-control-string error

	* src/table.c (_vte_table_addi):
	* src/vte.c (vte_terminal_handle_sequence):
	* src/vteseq.c (vte_sequence_handler_decset_internal):
	Replace some g_warning's with vte debug output.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	Bug 521420 – vte closes connection to child before all output is read
	Patch from Thomas Leonard

	* src/reaper.c (vte_reaper_add_child): Install child watch at low
	priority instead of high.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in: Require glib >= 2.18.0 as earlier glib versions
	had a totally bogus g_unichar_iswide_cjk().

	* perf/vim.sh: Don't use builting time command.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_emit_char_size_changed),
	(_vte_terminal_emit_status_line_changed), (vte_terminal_init),
	(vte_terminal_background_update):
	Remove C++-style comment markers.

2008-11-29  Behdad Esfahbod  <behdad@gnome.org>

	Bug 514632 – Problem with cursor in emacs in gnome-terminal

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_cleanup_tab_fragments_at_cursor),
	(_vte_terminal_insert_char):
	* src/vteseq.c (vte_sequence_handler_ch),
	(vte_sequence_handler_cm), (vte_sequence_handler_le),
	(vte_sequence_handler_cursor_character_absolute):
	Break "smart tabs" into multiple empty cells when cursor moves
	into them or inserting character there.

2008-11-28  Behdad Esfahbod  <behdad@gnome.org>

	* src/debug.c (_vte_debug_init):
	* src/debug.h:
	* src/vtepangocairo.c (font_info_cache_ascii),
	(font_info_allocate), (font_info_free),
	(font_info_find_for_context), (font_info_get_unichar_info):
	Port vtepangocairo profiling and lifecycle logging to vtedebug
	facilities under debug domain "pangocairo".

2008-11-28  Behdad Esfahbod  <behdad@gnome.org>

	* src/debug.c (_vte_debug_init): Rename debug env var from
	VTE_DEBUG_FLAGS to VTE_DEBUG.

2008-11-28  Behdad Esfahbod  <behdad@gnome.org>

	* src/debug.c (_vte_debug_init):
	* src/debug.h:
	Make _vte_debug_on() inline.

2008-11-28  Christian Persch  <chpe@gnome.org>

	* src/vte.c: Remove backward compat define for gtk 2.0, since we
	already depend on a much higher version.

2008-11-28  Christian Persch  <chpe@gnome.org>

	* src/debug.c: (_vte_debug_on): Revert behaviour change of
	_vte_debug_on() from last commit.

2008-11-28  Behdad Esfahbod  <behdad@gnome.org>

	Bug 459553 – gnome-terminal cannot shows circled digits with the
	correct width on ja_JP.PCK
	Patch from Takao Fujiwara

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Recognize Shift_JIS
	as East Asian locale for width considerations.

2008-11-28  Christian Persch  <chpe@gnome.org>

	* src/debug.c: (_vte_debug_init), (_vte_debug_on):
	* src/debug.h:
	* src/interpret.c: (main):
	* src/pty.c: (main):
	* src/reaper.c: (main):
	* src/trie.c: (main):
	* src/vte.c: (vte_terminal_new), (vte_terminal_class_init): Use
	g_parse_debug_string to parse the debug flags.

2008-11-28  Christian Persch  <chpe@gnome.org>

	* src/vteregex.c: (compare_matches), (_vte_regex_compile),
	(_vte_regex_free), (_vte_regex_exec): Remove the unused GNU regex
	code too.

2008-11-28  Christian Persch  <chpe@gnome.org>

	* src/vteregex.c: (_vte_regex_compile), (_vte_regex_free),
	(_vte_regex_exec): Remove unused PCRE code. If you want PCRE regexes,
	use the new APIs that take GRegex.

2008-11-28  Christian Persch  <chpe@gnome.org>

	Bug 562385 – gnome-pty-helper goes to 100% cpu usage

	* gnome-pty-helper/gnome-pty-helper.c: (pass_fd), (pty_free),
	(main): Make sure data structures are correctly aligned and of the
	right size. 

2008-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in:
	* src/Makefile.am:
	More cleanup.

2008-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	Run some of the utilities in "make check", and build the others.

	* src/nativeecho.c:
	* src/utf8echo.c:
	Remove more useless trivial utilities.

2008-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/iso8859mode.c:
	* src/utf8mode.c:
	Remove useless trivial utilities.

2008-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am: Update EXTRA_DIST.

2008-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* HACKING: Update :P.

2008-11-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c (_vte_sequence_get_handler): Safely handle input of
	length 1.

2008-11-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-2.c (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-2.gperf:
	* src/vteseq-n.c (vteseq_n_lookup):
	* src/vteseq-n.gperf:
	Don't use switch in gperf-generated code.  This increases .data by 1k
	but decreases .text by 6k AND the lookup code is MUCH faster.  It used
	to do tens of compares before.

2008-11-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-2.c (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-n.c (vteseq_n_lookup):
	* src/vteseq.c (_vte_sequence_get_handler):
	Revert previous commit, fix NULL dereference that it was trying to
	fix, and make lookup functions inline.

2008-11-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/Makefile.am:
	* src/vteseq-2.c (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-n.c (vteseq_n_lookup):
	* src/vteseq.c (_vte_sequence_get_handler):
	Manually modify (and record those modifications in the Makefile)
	the autogenerated gperf source code so that we return the sequence
	handler directly from the lookup function, or NULL on failure.
	So is this pain worth it?

2008-11-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_get_unichar_info):
	Free internal layout resources.

2008-11-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 562332 – cleanup font infos on exit?

	* src/vtepangocairo.c
	(cleanup_delayed_font_info_destroys_predicate),
	(cleanup_delayed_font_info_destroys), (ensure_quit_handler),
	(font_info_register), (font_info_reference),
	(font_info_destroy_delayed), (font_info_destroy):
	Use gtk_quit_add() to complete delayed font_info destroys.

2008-11-26  Christian Persch  <chpe@gnome.org>

	Bug 562338 – don't need to connect to bunch of xft settings

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_style_changed), (add_cursor_timeout),
	(vte_terminal_init), (vte_terminal_size_allocate),
	(vte_terminal_finalize), (vte_terminal_realize): Don't listen to
	changes on the gtk-xft-* GtkSettings properties. Just calling
	vte_terminal_set_font_full in the style-set handler works fine.

2008-11-26  Christian Persch  <chpe@gnome.org>

	Bug 488960 – gnome-terminal on Solaris 10 does not clean up utmpx on
	exit (intermittent)

	* gnome-pty-helper/gnome-pty-helper.c: (main):
	* gnome-pty-helper/gnome-pty.h:
	* src/pty.c: (_vte_pty_close): Add new GNOME_PTY_SYNCH operation to
	gnome-pty-helper. Patch from Behdad.

2008-11-26  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_style_changed),
	(vte_terminal_ensure_font), (vte_terminal_set_font_full),
	(vte_terminal_set_font_from_string_full_internal),
	(vte_terminal_set_font_from_string_full),
	(vte_terminal_reset_rowdata), (vte_terminal_set_property): Add
	vte_terminal_set_font_*full_internal so we don't use deprecated
	symbols internally.

2008-11-26  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_sync_settings),
	(vte_terminal_screen_changed): Remove gtk 2.12 version checks, since
	we already depend on 2.12.

2008-11-26  Christian Persch  <chpe@gnome.org>

	Bug 561366 – remove antialias setting for 1.0
	
	* src/vte.c: (vte_terminal_set_font_full),
	(vte_terminal_get_property), (vte_terminal_class_init):
	* src/vte.h: Deprecate the font antialias setting, and remove the
	(existing only on trunk) font-antialias property already.

2008-11-25  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am:
	* src/vteseq-2.c (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-2.gperf:
	* src/vteseq-n.c (vteseq_n_hash), (vteseq_n_lookup):
	* src/vteseq-n.gperf:
	* src/vteseq.c (_vte_sequence_get_handler):
	Cleanup gperf stuff.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 562187 – Add make rules for calling gperf

	* src/Makefile.am: Add a "gperf" target to be run manually.

	* src/vteseq-2.gperf:
	* src/vteseq-n.gperf:
	Add comment about "make gperf".

	* src/vteseq-2.c:
	* src/vteseq-n.c:
	Regenerate using newer gperf.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 416518 – Do something about uniwidths

	* src/iso2022.c (_vte_iso2022_is_ambiguous):
	Call into glib to determine ambiguous-width chars.

	* src/genwidths.py:
	* src/uniwidths:
	Remove.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 500191 – Remove vteseq-table.h?

	* src/Makefile.am:
	* src/vteseq-gen.c:
	* src/vteseq-table.h:
	Remove the old table implementation.  We use gperf-generated tables
	now.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 514457 – Use g_strv_length()

	* src/vte.c (_vte_terminal_fork_basic): Do it.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_create_for_widget): No need to check
	widget font desc here as vte.c does that for us already.

2008-11-24  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_destroy): Modify GTK_CHECK_VERSION
	handling to make my vim syntax highlighter happy.

2008-11-23  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_ensure_cursor): Refactor duplicate code.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/vte.h: Move all the deprecated stuff into one place.

2008-11-22  Christian Persch  <chpe@gnome.org>

	Bug 542561 – Doesn't build when disabling gnome-pty-helper

	* src/pty.c: Always include sys/socket.h. Patch by Loïc Minier.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/vteapp.c: (main): Fix --blink; the flag is inverted.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/vteapp.c: (main): Use vte_terminal_set_cursor_blink_mode instead
	of the deprecated set_cursor_blinks here.

2008-11-22  Christian Persch  <chpe@gnome.org>

	Bug 560766 – Deprecate and remove vte_terminal_get_using_xft()

	* src/vte.c: (vte_terminal_get_using_xft):
	* src/vte.h:
	* src/vtedraw.c: (_vte_draw_text):
	* src/vtedraw.h:
	* src/vtepangocairo.c: Deprecate vte_terminal_get_using_xft() as preparation for
	bug #560766. Remove the internal vtedraw method already.

2008-11-22  Christian Persch  <chpe@gnome.org>

	Bug 536894 – Confusing use of "free" as variable-name in ring
	functions

	* src/ring.c: (_vte_ring_new), (_vte_ring_new_with_delta),
	(_vte_ring_remove):
	* src/ring.h: Don't shadow global declarations. Patch by dmacks at 
	netspace.org. 

2008-11-22  Christian Persch  <chpe@gnome.org>

	* python/vte.override: Fix missing-prototypes warnings.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/vtepangocairo.c: No need to include gi18n-lib.h here.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* configure.in:
	* vte-uninstalled.pc.in:
	* vte.pc.in: Clean up the pkgs declared for use in the .pc files.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* configure.in: Depend on gtk 2.12. Bug #398862.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/table.c: (print_array): Fix the build (broken since r1622).

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/reaper.c: Don't include gtk.h here, it's unneeded.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/iso2022.c: (main): Make iso2022 programme build again; it was
	broken since r1612.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/Makefile.am: Separate CFLAGS and CPPFLAGS.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* src/Makefile.am: Don't add LDFLAGS to *_LDADD, that's wrong and
	broken.

2008-11-22  Christian Persch  <chpe@gnome.org>

	* configure.in:
	* src/Makefile.am:
	* vte-uninstalled.pc.in:
	* vte.pc.in: Remove more configure cruft: OTHERCFLAGS, OTHERLIBS,
	X_CFLAGS and X_LIBS.

2008-11-21  Christian Persch  <chpe@gnome.org>

        * src/vtepangocairo.c: (font_info_destroy_delayed),
        (font_info_destroy): Use gdk_threads_add_timeout_seconds() for
        complete threadsafety.

2008-11-21  Chris Wilson  <chris@chris-wilson.co.uk>

	* vte.pc.in: Remove FT2_LIBS and FT2_CFLAGS

2008-11-21  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/iso2022.c (_vte_iso2022_is_ambiguous): Break out of interval
	search as early as possible. Exploit the strict ordering of the 
	ambiguous/unambiguous ranges to break out of the for loop as soon
	as the character is less than a range start. (As the arrays only
	contain 2/3 elements, it is not worth adding the overhead of calling
	bsearch()).

2008-11-21  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/iso2022.c (process_cdata): Copy the gunichars directly to the
	array from the incoming chunk.

2008-11-20  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/Makefile.am: Remove FT2_FLAGS

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_destroy_delayed): Remove obsolete
	check.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 561713 – crash on font cache cleanup

	* src/vtepangocairo.c (font_info_reference), (font_info_destroy):
	Remove destroy timeout when resurrecting a font info.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_cache_ascii),
	(font_info_allocate), (font_info_free),
	(font_info_find_for_context):
	Make profiling messages print the info pointer.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in:  Remove more cruft.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560819 – Remove obsolete backends

	* configure.in:
	* src/Makefile.am:
	* src/vtebg.c (vte_bg_get_pixmap):
	* src/vtebg.h:
	* src/vtedraw.c:
	* src/vtefc.c:
	* src/vtefc.h:
	* src/vteft2.c:
	* src/vteft2.h:
	* src/vtegl.c:
	* src/vtegl.h:
	* src/vteglyph.c:
	* src/vteglyph.h:
	* src/vterdb.c:
	* src/vterdb.h:
	* src/vtergb.c:
	* src/vtergb.h:
	* src/vtexft.c:
	* src/vtexft.h:
	Remove all backends except for pangocairo.  Saves so much code.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560819 – Remove obsolete backends

	* src/Makefile.am:
	* src/vtedraw.c:
	* src/vtepango.c:
	* src/vtepango.h:
	Remove pango backend.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560819 – Remove obsolete backends

	* configure.in:
	* src/Makefile.am:
	* src/vtedraw.c:
	* src/vtepangox.c:
	* src/vtepangox.h:
	Remove pangox backend.

2008-11-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560818 – pangocairo backend doesn't share font cache across
	widgets

	* src/vtepangocairo.c (font_info_cache_ascii),
	(font_info_allocate), (font_info_free), (font_info_register),
	(font_info_unregister), (font_info_reference),
	(font_info_destroy_delayed), (font_info_destroy), (context_hash),
	(context_equal), (font_info_find_for_context),
	(font_info_create_for_context), (font_info_create_for_screen),
	(font_info_get_unichar_info): Cache font info and use it for multiple
	widgets.

2008-11-19  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_create_for_screen),
	(font_info_destroy): Remove unused PangoCoverage.

2008-11-19  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_find_unichar_info),
	(font_info_cache_ascii), (font_info_measure_font),
	(font_info_get_unichar_info): Cache ASCII characters when building
	font.

2008-11-18  Christian Persch  <chpe@gnome.org>

	Remove glib usage from gnome-pty-helper. Bug #560977.

	* gnome-pty-helper/Makefile.am: Remove GLIB CFLAGS/LIBS.
	* gnome-pty-helper/configure.in: Remove glib check, and do some auto*
	modernisation.
	* gnome-pty-helper/gnome-pty-helper.c: (open_ptys), (exit_handler),
	(main): Use alloca instead of g_alloca, and use int instead of
	gboolean.

2008-11-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtepangocairo.c (font_info_create_for_screen),
	(font_info_destroy): Remove copy of font desc and antialias from font
	info object as they were not used.

2008-11-18  Behdad Esfahbod  <behdad@gnome.org>

	Bug 561185 – pangocairo backend sets antialias incorrectly

	* src/vtepangocairo.c (font_info_create_for_screen): Handle
	FORCE_ENABLE correctly.

2008-11-16  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560817 – pagocairo backend doesn't have correct opacity support	

	* src/vtepangocairo.c (_vte_pangocairo_clear),
	(_vte_pangocairo_draw_text), (_vte_pangocairo_draw_rectangle),
	(_vte_pangocairo_fill_rectangle): Fix opacity support by using
	SOURCE operator.

2008-11-16  Behdad Esfahbod  <behdad@gnome.org>

	Bug 560991 – Unsetting background doesn't work

	* src/vte.c (vte_terminal_set_background_image): Correctly unset
	background if image==NULL.

2008-11-14 Christian Persch <chpe@gnome.org>

	* src/vteskel.c: Fix missing prototype warning.

2008-11-14  Behdad Esfahbod  <behdad@gnome.org>

	Bug 395599 – Add pangocairo backend

	* configure.in:
	Require pango >= 1.22.0

	* src/Makefile.am:
	* src/vtedraw.c:
	* src/vtepangocairo.c:
	* src/vtepangocairo.h:
	Add a pangocairo drawing backend.  Use it by default.  This is as fast
	as the xft backend.  Doesn't share font caches across widgets yet.
	Also, the transparent background stuff doesn't match xft backend's
	yet.

2008-11-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_ensure_font):
	* src/vtedraw.c (_vte_draw_new), (_vte_draw_free),
	(_vte_draw_set_background_opacity),
	(_vte_draw_set_background_color), (_vte_draw_set_text_font),
	(_vte_draw_get_text_metrics), (_vte_draw_get_char_width),
	(_vte_draw_char), (_vte_draw_draw_rectangle),
	(_vte_draw_set_scroll):
	* src/vtedraw.h:
	* src/vteft2.c (_vte_ft2_destroy), (_vte_ft2_start),
	(_vte_ft2_end), (_vte_ft2_set_background_image), (_vte_ft2_clear),
	(_vte_ft2_set_text_font), (_vte_ft2_get_text_metrics),
	(_vte_ft2_get_char_width), (_vte_ft2_draw_text),
	(_vte_ft2_draw_has_char), (_vte_ft2_draw_rectangle),
	(_vte_ft2_fill_rectangle):
	* src/vtegl.c (_vte_gl_destroy), (_vte_gl_get_visual),
	(_vte_gl_start), (_vte_gl_end), (_vte_gl_set_background_image),
	(_vte_gl_clear), (_vte_gl_set_text_font),
	(_vte_gl_get_text_metrics), (_vte_gl_get_char_width),
	(_vte_gl_draw_text), (_vte_gl_draw_has_char), (_vte_gl_rectangle):
	* src/vtepango.c (_vte_pango_set_text_font),
	(_vte_pango_get_text_metrics):
	* src/vtepangox.c (_vte_pangox_create), (_vte_pangox_destroy),
	(_vte_pangox_start), (_vte_pangox_end),
	(_vte_pangox_set_background_image), (_vte_pangox_clip),
	(_vte_pangox_clear), (_vte_pangox_set_text_font),
	(_vte_pangox_get_text_metrics), (_vte_pangox_get_using_fontconfig),
	(_vte_pangox_draw_text), (_vte_pangox_draw_has_char),
	(_vte_pangox_draw_rectangle), (_vte_pangox_fill_rectangle):
	* src/vtepangox.h:
	* src/vteskel.c (_vte_skel_clear), (_vte_skel_get_text_metrics),
	(_vte_skel_draw_text), (_vte_skel_fill_rectangle):
	* src/vtexft.c (_vte_xft_set_text_font),
	(_vte_xft_get_text_metrics), (_vte_xft_draw_text):
	Remove unneeded draw methods.

2008-11-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtedraw.c (_vte_draw_get_char_width): Minor fix.

	* src/vtepangox.c (_vte_pango_x_create), (_vte_pango_x_start),
	(_vte_pango_x_clear): Cleanup here too.

2008-11-13  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in:
	* src/vte-private.h:
	Undo previous change instead of cleanly fix it for now.

2008-11-13  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in:
	* src/vte-private.h:
	Why do we let people configure random things?

2008-11-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_background_update):
	* src/vtedraw.c (_vte_draw_update_requires_clear), (_vte_draw_new),
	(_vte_draw_set_background_opacity),
	(_vte_draw_set_background_color), (_vte_draw_set_background_image),
	(_vte_draw_char), (_vte_draw_set_scroll):
	* src/vtedraw.h:
	* src/vteft2.c (_vte_ft2_set_background_image), (_vte_ft2_clear),
	(_vte_ft2_get_char_width):
	* src/vtegl.c (_vte_gl_create), (_vte_gl_clear),
	(_vte_gl_get_char_width), (_vte_gl_draw_text):
	* src/vtepango.c (_vte_pango_create), (_vte_pango_start),
	(_vte_pango_set_background_image), (_vte_pango_clear):
	* src/vtexft.c (_vte_xft_create), (_vte_xft_set_background_image),
	(_vte_xft_clear), (_vte_xft_get_char_width):
	Simplify backends by relying more on defaults.

2008-11-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtedraw.c (_vte_draw_init_user), (_vte_draw_init_default):
	Accept draw impl if impl->check is NULL.

2008-11-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtedraw.h:
	* src/vtedraw.c (_vte_draw_new), (_vte_draw_get_visual),
	(_vte_draw_get_colormap), (_vte_draw_start), (_vte_draw_end),
	(_vte_draw_set_background_color), (_vte_draw_set_background_image),
	(_vte_draw_requires_repaint), (_vte_draw_clip), (_vte_draw_clear),
	(_vte_draw_set_text_font), (_vte_draw_get_text_width),
	(_vte_draw_get_text_height), (_vte_draw_get_text_ascent),
	(_vte_draw_get_char_width), (_vte_draw_get_using_fontconfig),
	(_vte_draw_text), (_vte_draw_char), (_vte_draw_has_char),
	(_vte_draw_fill_rectangle), (_vte_draw_draw_rectangle),
	(_vte_draw_set_scroll):
	Use sensical defaults instead of g_return_if_fail'ing when backend
	functions are not implemented.

2008-10-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 557375 – >=vte-0.16.14 breaks highlighting on activity

	* src/vte.c (vte_terminal_deselect_all):
	Preserve the copy of the selection until it is replace by a new
	selection, so that we can perform asynchronous copies from the
	clipboard.

2008-10-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 557375 – >=vte-0.16.14 breaks highlighting on activity

	* src/vte.c (vte_terminal_deselect_all),
	(vte_terminal_extend_selection):
	After the user modifies the selection, copy it to PRIMARY and store
	it on the terminal. This ensures that after a screen redraw, we
	compare the contents of the selected region with the current
	selection, instead of stale data.

2008-10-23  Christian Persch  <chpe@gnome.org>

        * configure.in:
        * src/Makefile.am: Use glib-genmarshal --internal directly instead
        of checking the glib version, since we now depend on a glib version
        that provides this.

2008-10-23  Christian Persch  <chpe@gnome.org>

        Bug 556398 – maybe deprecate vte_terminal_get_char_ascent/descent

        * src/vte.[ch]: Deprecate vte_terminal_get_char_ascent/descent.

2008-10-23  Christian Persch  <chpe@gnome.org>

        Bug 339819 – LibVTE terminals in GLADE

        A glade/*:
        * Makefile.am
        * configure.in: Add glade catalogue.

2008-10-23  Christian Persch  <chpe@gnome.org>

        Bug 399364 – Implement properties

        * src/vte.c: Add gobject properties.

2008-10-19  Christian Persch  <chpe@gnome.org>

        Bug 556328 – Document set-scroll-adjustment parameters

        * src/vte.c: Document the set-scroll-adjustments signal.

2008-10-15  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/Makefile.am:
	* doc/reference/check-doc-coverage.sh:
	* doc/reference/check.docs:
	Update doc coverage test from cairo.

2008-10-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_set_cursor_shape):
	Invalidate cursor upon shape change.

2008-10-15  Christian Persch  <chpe@gnome.org>

	* python/vte.defs: Add new API to the binding.

2008-10-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_draw_line), (vte_terminal_paint_cursor):
	Remove VTE_CURSOR_OUTLINE in favor of VTE_LINE_WIDTH.

2008-10-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_paint_cursor):
	Supposedly handle reverse video during cursor drawing.

2008-10-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_paint_im_preedit_string),
	(vte_terminal_paint):
	Move IM preedit string drawing into its own function for code
	clarity.

2008-10-14  Behdad Esfahbod  <behdad@gnome.org>

	Bug 549835 – Feature Request: Configurable cursor appearance

	* src/vte.h:
	New public api:

		VteTerminalCursorShape
		vte_terminal_set_cursor_shape
		vte_terminal_get_cursor_shape

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_insert_char), (vte_terminal_init),
	(vte_terminal_paint_cursor), (vte_terminal_paint),
	(vte_terminal_set_cursor_shape), (vte_terminal_get_cursor_shape):
	Implement new API.  Also clean up cursor drawing in general.

	* doc/reference/Makefile.am:
	* doc/reference/tmpl/reaper.sgml:
	* doc/reference/tmpl/vte-unused.sgml:
	* doc/reference/tmpl/vte.sgml:
	* doc/reference/vte-sections.txt:
	Doc new symbols.  Also add some missing docs.

2008-10-13  Christian Persch  <chpe@gnome.org>

	* src/vte.c: Add gobject property infrastructure.

2008-10-13  Christian Persch  <chpe@gnome.org>

	* src/Makefile.am: Fix missing prototypes compiler warning in
	marshal.c.

2008-10-06  Christian Persch  <chpe@gnome.org>

	* src/vteconv.c: (_vte_conv_open): Fix compiler warning.

2008-10-06  Christian Persch  <chpe@gnome.org>

        Bug 509204 – child-exited signal does not provide exit code

	* python/vte.defs: Add the new function to the bindings.

2008-10-06  Christian Persch  <chpe@gnome.org>

        Bug 539130 – building g-t fails due to GtkType etc. deprecation

        * src/vte.h: Deprecate useless macros.

2008-10-06  Christian Persch  <chpe@gnome.org>

        Bug 509204 – child-exited signal does not provide exit code

        * src/vte-private.h:
        * src/vte.h:
        * src/vte.c: Add function to get the child's exit status.

2008-10-06  Christian Persch  <chpe@gnome.org>

	* configure.in: Bump version to 0.17.5.

2008-09-08  Christian Persch  <chpe@gnome.org>

        Release 0.17.3.

        * NEWS:
	* configure.in: Updated.

2008-09-07  Christian Persch  <chpe@gnome.org>

	* python/vte.defs: Update python bindings.

2008-08-20  Sébastien Granjoux  <seb.sfo@free.fr>

	Bug 538344 – Anjuta hangs when program is executed in terminal

	* src/vte.c: Ensure the output channel exists when we need to write.

2008-08-20  Christian Persch  <chpe@gnome.org>

	* src/vte.c: (vte_terminal_match_check_internal_gregex): Plug a mem
	leak.

2008-08-15  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_set_pty):
	fcntl(2) specifies that the flags argument is a long. Make it so.

2008-08-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h:
	* src/vte.c (vte_terminal_match_check_internal_vte),
	(vte_terminal_ensure_cursor), (vte_terminal_set_colors),
	(_vte_terminal_insert_char), (vte_terminal_feed),
	(vte_terminal_key_press), (vte_terminal_match_hilite_update),
	(vte_terminal_extend_selection):
	* src/vteseq.c (vte_terminal_find_charcell),
	(vte_sequence_handler_set_title_internal),
	(vte_sequence_handler_decset_internal), (vte_sequence_handler_cb),
	(vte_sequence_handler_cd), (vte_sequence_handler_ce),
	(vte_sequence_handler_ec), (vte_sequence_handler_ta),
	(vte_sequence_handler_set_mode),
	(vte_sequence_handler_window_manipulation):
	Fix all "signed vs unsigned comparison" warnings.

2008-08-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (regex_match_clear_cursor),
	(vte_terminal_set_cursor_from_regex_match):
	Fix uninitialized cursor warning.  Setting to NULL sounds
	right to me.  ChPe?

2008-08-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Remove useless "inline" decorators.  Gcc has been
	rightfully complaining.

2008-08-13  Behdad Esfahbod  <behdad@gnome.org>

	Bug 546940 – Crash when selecting text

	* src/vte.c (vte_terminal_extend_selection): Fix crash with 64-bit
	systems.  Note to self:

		unsigned int len = 0;
		long i = len - 1;
		assert (i < 0);

	fails on 64-bit systems.

2008-08-05  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.17.1.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.17.1.
	Bumped libtool version to 12:0:3.

2008-08-05  Behdad Esfahbod  <behdad@gnome.org>

	Bug 546366 – hard to select last tab char on a line

	* src/vte.c (vte_terminal_extend_selection):
	* src/vteseq.c (vte_sequence_handler_ta):
	Handle fragment cells.

2008-08-05  Behdad Esfahbod  <behdad@gnome.org>

	Bug 545924 – tab characters not handled correctly after ncurses clear	
	Patch from Patryk Zawadzki

	* src/vteseq.c (vte_sequence_handler_ta): Ignore empty cells at end of
	line.

2008-07-14  Behdad Esfahbod  <behdad@gnome.org>

	Bug 542795 – VTE_CJK_WIDTH don't work

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Fix VTE_CJK_WIDTH env
	handling.

2008-06-27  Christian Persch  <chpe@gnome.org>

        Bug 399744 – Hide more font-aa implementation details

        * src/vtexft.c: Disable antialiasing if using the default antialias
        setting and the XRender extension is not available.

2008-06-27  Christian Persch  <chpe@gnome.org>

        Bug 510903 – use gtk-cursor-blink setting

        * doc/reference/tmpl/vte.sgml:
        * doc/reference/vte-sections.txt:
        * src/vte-private.h:
        * src/vte.c:
        * src/vte.h: Make the cursor blinking follow the gtk setting by
        default, with a possible override.

2008-06-26  Christian Persch  <chpe@gnome.org>

	* src/vte.h: Remove the enum type declarations that are now in
        vtetypebuiltins.h.

2008-06-26  Christian Persch  <chpe@gnome.org>

        * Makefile.am:
        * autogen.sh: Fix the build from svn and make dist when using
        intltool 0.40.0. Tarball builds still only require 0.35.0.

2008-06-26  Christian Persch  <chpe@gnome.org>

	* src/vteversion.h.in: Disallow direct inclusion of the new
	vteversion.h file.

2008-06-26  Christian Persch  <chpe@gnome.org>

	* configure.in:
	* src/Makefile.am:
	* src/vte.c:
	* src/vte.h:
	* src/vtetypebuiltins.c.template:
	* src/vtetypebuiltins.h.template: Use glib-mkenums to generate the
	enum types; makes it easier to add more enum types.

2008-06-26  Christian Persch  <chpe@gnome.org>

        Bug 539130 – building g-t fails due to GtkType etc. deprecation

        * src/reaper.h:
        * src/vte.c:
        * src/vteaccess.[ch]: 
        * src/vtebg.h: Also remove the deprecated GtkType macros from here.

2008-06-25  Christian Persch  <chpe@gnome.org>

	Bug 540182 – crash in geany with vte trunk

	* src/vte.c: Make sure that match_attributes always exist even if
	there haven't been any matches added.

2008-06-23  Christian Persch  <chpe@gnome.org>

	Bug 535552 – vte_terminal_set_allow_bold doesn't queue redraw

	* src/vte.c: Invalidate all when changing the allow-bold property.

2008-06-23  Christian Persch  <chpe@gnome.org>

        Bug 535469 – support named cursors on matches

        * src/vte-private.h
        * src/vte.c
        * src/vte.h: Implement named cursors on matches.

2008-06-23  Christian Persch  <chpe@gnome.org>

        Bug 418918 – Switch to GRegex

        * src/vte-private.h
        * src/vte.c
        * src/vte.h: Implement GRegex matching, to be used alternatively
        to the old vteregex matching.

2008-06-23  Christian Persch  <chpe@gnome.org>

        Bug 535467 – implement set-scroll-adjustments signal

        * src/vte.c: Add set-scroll-adjustments signal, needed to allow
        adding a VteTerminal into a GtkScrolledWindow.

2008-06-23  Christian Persch  <chpe@gnome.org>

        Bug 535468 – need version check macros

        * configure.in
        * doc/reference/tmpl/vteversion.sgml
        * doc/reference/vte-sections.txt
        * doc/reference/vte.types
        * src/Makefile.am
        * src/vte.h
        A src/vteversion.h.in: Add version check macro.

2008-06-21  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vte.h: Don't use GTK_CHECK* macros.

2008-06-04  Christian Persch  <chpe@gnome.org>

	Bug 515972 – Bold black is black in vte's default palette

	* src/vte.c: (vte_terminal_set_colors): Correctly set the value of
	'bold black' in the palette. Patch by Santtu Lakkala.

2008-06-04  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.14.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.14.
	Bumped libtool version to 11:18:2.

2008-06-04  Behdad Esfahbod  <behdad@gnome.org>

	Bug 536632 – vte build failure in ring.c:210: error: expected
	expression before 'do'

	* src/debug.h:
	* src/ring.c:
	* src/ring.h:
	With latest glib (after bug #519026), g_error is expanding to
	"do {...} while(0)" instead of "{...}".  This breaks build in
	debugging mode.  Use g_critical instead.  Also add some
	G_STMT_START/END to some macros.

2008-05-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/pty.c (merge_environ): Replace previous commit with the
	better patch by Christian Persch.

2008-05-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/pty.c (merge_environ): Fix bug in patch to use g_listenv()
	as it only returns the variable name and we need to use g_getenv()
	to retrieve its value.

2008-05-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Oops.  Fix thinko
	in last commit.

2008-05-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 535022 – ambiguous width in utf8 locale

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Recognize
	env var settings VTE_CJK_WIDTH=narrow and VTE_CJK_WIDTH=wide.
	Any other value means "auto" based on locale, as it was doing
	previously.

2008-05-21  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/pty.c (merge_environ): Silence compiler warning about using
	environ as a local variable name.

2008-05-21  Richard Hult  <richard@imendio.com>

	Bug 534148 – Use g_listenv() instead of environ

	* src/pty.c: (merge_environ): Use g_listenv() instead of
	non-portable environ extern.

2008-05-19  Kjartan Maraas  <kmaraas@gnome.org>

	* configure.in: automake doesn't like to substitute more
	than one variable at a time.
	* src/vtedraw.c: (_vte_draw_get_using_fontconfig):
	* src/vtetc.c: (_vte_termcap_find_boolean):
	Fix two compiler warnings.

2008-05-09  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtedraw.c (_vte_draw_text):
	    Add the text to draw to the debug output.

2008-05-09  Chris Wilson  <chris@chris-wilson.co.uk>

	Fix "GLib-CRITICAL **: g_io_add_watch_full: assertion
	                       `channel != NULL' failed"

	* src/debug.c (_vte_debug_parse_string):
	* src/debug.h:
	* src/vte-private.h:
	* src/vte.c (vte_terminal_emit_adjustment_changed),
	(_vte_terminal_adjust_adjustments_full),
	(vte_terminal_scroll_lines), (vte_terminal_maybe_scroll_to_bottom),
	(_vte_terminal_insert_char), (vte_terminal_catch_child_exited),
	(mark_input_source_invalid), (_vte_terminal_connect_pty_read),
	(mark_output_source_invalid), (_vte_terminal_connect_pty_write),
	(_vte_terminal_disconnect_pty_read),
	(_vte_terminal_disconnect_pty_write), (_vte_terminal_fork_basic),
	(vte_terminal_eof), (_vte_terminal_enable_input_source),
	(vte_terminal_io_read), (vte_terminal_handle_scroll),
	(vte_terminal_finalize), (vte_terminal_class_init),
	(vte_terminal_set_pty), (process_timeout), (update_repeat_timeout),
	(update_timeout):
	It was possible for _vte_terminal_enable_input_source() to be called
	after the input closed with G_IO_HUP. The minimal change would just
	have been to add a guard to check the pty_master was still valid
	before reattaching the source. Instead I removed the redundant
	duplication of the input and output channels and added lots of
	debugging.

2008-05-08  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 516869 – vte displays nothing on GTK+/DirectFB

	Original patch by Jérémy Bobbio.

	* src/vte.c (vte_terminal_class_init), (update_regions),
	(update_repeat_timeout), (update_timeout):
	gdk_window_process_all_updates() is ineffective on the gtk+-directfb
	and gtk+-quartz backends, so in order to process updates immediately
	one must call gdk_window_process_updates() on the desired GdkWindows
	instead.

2008-03-10  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.13.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.13.
	Bumped libtool version to 11:17:2.

2008-02-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 517709 – VTE's pty.c makes 4096 getrlimit calls when it only needs
	one

	* src/pty.c (_vte_pty_start_helper): Only close fds 0, 1, and 2.
	gnome-pty-helper closes all fds anyway.

2008-02-08  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c:
	* src/vteapp.c:
	* src/vtergb.c:
	Remove unneeded #include <fontconfig/fontconfig.h>

2008-01-09  Behdad Esfahbod  <behdad@gnome.org>

	Bug 449131 – Wrong gettext domain

	* src/pty.c:
	* src/reaper.c (vte_reaper_class_init):
	* src/trie.c:
	* src/vtebg.c (vte_bg_class_init):
	* src/vteglyph.c:
	Oops.  Fix all remaining ones too.

2008-01-07  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.12.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.12.
	Bumped libtool version to 11:16:2.
.
2007-12-21  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 503164 – Drawing problems for VTE with gtk+-quartz

	* src/vte.c (vte_terminal_realize):
	Continuing the saga, remove the fiddling with visibility state
	during realize.

2007-12-18  Behdad Esfahbod  <behdad@gnome.org>

	Bug 449131 – Wrong gettext domain

	* src/vte.c (vte_terminal_class_init): Use GETTEXT_DOMAIN in
	bind_textdomain_codeset().

2007-12-17  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.11.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.11.
	Bumped libtool version to 11:15:2.
.
2007-12-17  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 503164 – Drawing problems for VTE with gtk+-quartz

	* src/vte.c (vte_terminal_init):
	GdkQuartz does not generate GdkVisibilityNotify events and
	so the terminal was never marked as unobscured, causing all
	redraws to be discarded. Resolve this by initially setting the
	terminal to be unobscured.

2007-12-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 319687 – Pasting of text containing characters not in the
	terminal's encoding silently fails

	* src/vteconv.c (_vte_conv_open): Try to open converter with
	transliteration.  Supported by GNU iconv and GLibc.

2007-12-03  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.10.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.10.
	Bumped libtool version to 11:14:2.
.
2007-12-03  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 497246 – Kill vte_iso2022_fragment_input

	* src/iso2022.c (process_block), (_vte_iso2022_process):
	Avoid the temporary allocation of the GArray holding the fragments
	by processing each fragment as it is decyphered. This array is
	allocated and grown for every single input chunk and is currently the
	most frequent allocation made by vte.

2007-12-03  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/keymap.c: Make is_cursor_key static.

2007-11-28  Behdad Esfahbod  <behdad@gnome.org>

	Bug 412435 – Invalid variable name in Makefile.am

	* Makefile.am:
	* configure.in:
	* vte.spec.in:
	Remove spec file and old convenience cvs make targets.

2007-11-28  Behdad Esfahbod  <behdad@gnome.org>

	Bug 416561 – Rendering issue in VtePango

	* src/vtepango.c (_vte_pango_draw_rectangle):
	* src/vtepangox.c (_vte_pango_x_draw_rectangle):
	gdk_draw_rectangle has slightly different semantics when
	filling vs outlining.  Fix for that.

2007-11-28  Behdad Esfahbod  <behdad@gnome.org>

	Bug 416558 – Rendering errors in VteFT2

	* src/vteft2.c (_vte_ft2_create): Disable Gtk+ double-buffering.

2007-11-28  Behdad Esfahbod  <behdad@gnome.org>

	Bug 403217 – Outdated README

	* README: Rewrite.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 118967 – single line scrolling with "Ctrl+Shift+ArrowUp/ArrowDown"
	Patch from Mauricio and Mariano Suárez-Alvarez

	* src/vte.c (vte_terminal_scroll_lines),
	(vte_terminal_scroll_pages), (vte_terminal_key_press):
	Implement single-line scroll.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 353610 – Don't convert tab characters upon copying

	* src/vte-private.h:
	* src/vteseq.c (vte_sequence_handler_ta):
	Smart tab handling to try to preserve tab character upong copying.
	Also makes such smart tabs all-or-none selectable.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 499892 – strikethrough line is too high

	* src/vte-private.h:
	* src/vte.c (vte_terminal_apply_metrics), (vte_terminal_init),
	(vte_terminal_draw_cells): Adjust underline/strikethrough thickness
	and position based on pangofc's heuristics.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtedraw.c (_vte_draw_init_user): Make VTE_BACKEND=list list
	available backends to stderr.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 499891 – vte with opacity set, shows invisible chars

	* src/vte.c (vte_terminal_draw_rows): Don't draw invisible chars.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 499896 – Alternate charset isn't an attribute, though we treat it
	as one.

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_set_default_attributes),
	(_vte_terminal_insert_char), (vte_terminal_reset):
	* src/vteseq.c (vte_sequence_handler_ae),
	(vte_sequence_handler_as):
	Move cell.attr.alternate to screen->alternate_charset.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 499893 – cell.attr.protect is unused

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_set_default_attributes):
	* src/vteseq.c (vte_sequence_handler_mp):
	Comment out cell.attr.protect which is unused.

2007-11-27  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_invalidate_cell), (_vte_invalidate_cursor_once):
	Minor optimization, if one can call it that.

2007-11-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Fix doc syntax.

2007-11-26  Behdad Esfahbod  <behdad@gnome.org>

	Revert previous change.  For reason, see bug.
	Bug 491832 – vte_terminal_get_text_range_maybe_wrapped always includes
	trailing spaces

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped):
	Don't trim space characters, just the empty space after lines,
	like we used to.

2007-11-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 491832 – vte_terminal_get_text_range_maybe_wrapped always includes
	trailing spaces

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped):
	Trim trailing space characters if asked to.

2007-11-23  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/Makefile.am:
	* doc/reference/check.docs:
	Add script to check doc coverage is 100% on "make check".

2007-11-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 499287 – Fix doc coverage regression

	* doc/reference/tmpl/vte.sgml:
	* doc/reference/vte-sections.txt:
	Document undocumented symbols.

2007-11-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_io_read), (vte_terminal_init),
	(process_timeout), (update_repeat_timeout), (update_timeout):
	    Tweak to read across chunk boundaries whilst still maintaining
	    fairness between multiple terminals and refresh rate targets.

2007-11-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/ring.c (_vte_ring_insert_preserve):
	    Use stack allocation to hold small numbers of temporary
	    gpointers.

2007-11-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c (_vte_free_row_data), (vte_terminal_reset_rowdata),
	(vte_terminal_finalize), (vte_terminal_reset):
	    Export _vte_row_data_free.

	* src/vteseq.c (vte_remove_line_internal):
	    Cache the removed VteRowData - fixes the continual reallocation
	    of row data during the vim scrolling benchmark.

2007-11-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (release_chunk), (prune_chunks),
	(remove_from_active_list), (process_timeout),
	(update_repeat_timeout):
	    Delay pruning the chunks freelist until we finished processing
	    all the incoming data. We were discarding the freelist far too
	    early and reduced the efficacy of the cache.

2007-11-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vterdb.h:
	* src/vterdb.c (_vte_rdb_get), (_vte_rdb_search), (_vte_rdb_quark),
	(_vte_rdb_get_rgba), (_vte_rdb_get_hintstyle), (_vte_rdb_release):
	    Remove redundant queries and cache the XRequest on the root
	    window (saves a few round-trips during terminal construction).
	    Add a new function to free the cache.

	* src/vtefc.c (_vte_fc_defaults_from_rdb):
	    Release the cache after retrieving settings.

2007-11-15  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_focus_out):
	    Similar for the leave notify, disable the match updating after
	    hiding the cursor after the loss of focus.
	    However, do we really want to disable the hilighting whilst the
	    pointer may still be within the terminal?

2007-11-15  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_enter):
	    Don't automatically reshow the hilight on receiving an enter
	    event, but wait for the motion notify to update the cursor
	    co-ordinates, otherwise we may hilight something quite distant
	    from the cursor.

2007-11-15  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_leave):
	    Mark the cursor as invisible on leaving the terminal as this
	    stops the hilight matcher running whilst the cursor is absent.

2007-11-06  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_set_font_from_string_full): Allow NULL
	font argument.  Can be used to set antialias without setting font.

	* src/vteapp.c (main): Fix antialias handling which was borked when
	moving to GOption.

2007-11-06  Behdad Esfahbod  <behdad@gnome.org>

	Bug 142640 – FcConfigSubstitute in place of _vte_fc_defaults_from_gtk
	to get antialias and hinting value

	* src/vtefc.c (_vte_fc_defaults_from_gtk),
	(_vte_fc_defaults_from_rdb): Replace _vte_fc_defaults_from_gtk() with
	gtk_default_substitute() from Gtk+-2.6.  It's essentially the same
	thing, but not overriding elements of the pattern already present.
	Also remove a couple redundant calls.

2007-10-11  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 439384 – gnome-terminal on feisty crashes when giving wrong locale environment

	* src/vte.c (vte_terminal_set_encoding):
	    Fallback to using UTF-8 as the locale encoding. This prevents
	    subsequent crashes but may display gibberish in the output.

2007-10-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 483642 – vte_terminal_feed crash when 8190 characters passed

	* src/vte.c (vte_terminal_feed):
	    Break the feed data into chunks.

2007-09-30  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c (_vte_xft_set_background_image):
		Skip retrieving the VteBg if the source is VTE_BG_SOURCE_NONE
		as we neither need it to listen for changes to the background
		nor require it to load the pixmap (which is a no-op).

2007-09-30  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c (_vte_xft_destroy):
		Ensure the GdkPixmap is destroyed along with the VteXft
		context.

2007-09-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 480735 – Underlining whitespace not reliable

	Original patch by Steven Skovran.

	I really must remember to run vttest more often. (And to work within
	git-svn.)

	* src/vte.c (vte_terminal_draw_rows):
	    Do not skip spaces.

2007-09-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 480735 – Underlining whitespace not reliable

	Original one-liner by Steven Skovran.

	* src/vte.c (vte_terminal_draw_rows):
	    Do not try to over zealously skip whitespace. The goal is
	    to maintain the current run whilst avoiding adding spaces to
	    the glyph sequence - so check the cell fully for attribute
	    breaks and simply do not add it to the glyphs if it contains a
	    space.

2007-09-17  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.9.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.9.
	Bumped libtool version to 11:13:2.

2007-09-05  Behdad Esfahbod  <behdad@gnome.org>

	* perf/vim.sh: Wait for keypress when done, so one can do
	"vte -c ./vim.sh" and not lose the final numbers.

	* src/vtepango.c (_vte_pango_destroy), (_vte_pango_start),
	(_vte_pango_end), (_vte_pango_set_background_color),
	(_vte_pango_set_background_image), (_vte_pango_clear),
	(_vte_pango_set_text_font), (_vte_pango_get_using_fontconfig),
	(_vte_pango_draw_text), (_vte_pango_draw_has_char),
	(_vte_pango_draw_rectangle), (_vte_pango_fill_rectangle),
	(_vte_pango_set_scroll):  General cleanup.  Also implement
	_vte_pango_draw_has_char() using
	pango_layout_get_unknown_glyphs_count() when available.

2007-09-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 469862 – Handling of wrapped links in gnome-terminal is broken

	* src/vteseq.c (vte_sequence_handler_ce): Reset soft_wrapped.

2007-09-01  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 469862 – Handling of wrapped links in gnome-terminal is broken

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped):
	    Revert the last character is in last column check as that
	    behaviour is required to handle terminal resizing where the
	    screen contents are not reconstructed (e.g. bash).

2007-08-30  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 471901 – troubles with pad

	* src/vte-private.h:
	* src/vte.c (_vte_invalidate_cells), (vte_terminal_draw_rows),
	(vte_terminal_paint): Don't abuse VTE_PAD_WIDTH.

2007-08-30  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 469862 – Handling of wrapped links in gnome-terminal is broken

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped):
	    Check that the last character is in the last column before
	    adding a newline for autowrapped lines.

2007-08-30  Chris Wilson  <chris@chris-wilson.co.uk>

	* MAINTAINERS: Add myself to the list, as Behdad had suggested some
	time ago.

2007-08-30  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 153265 – Handle Sun Cut, Copy, Paste keys
	Patch by Brian Cameron.

	* doc/reference/tmpl/vte.sgml:
	* src/vte.c (vte_terminal_class_init),
	(vte_terminal_real_copy_clipboard), (vte_terminal_copy_clipboard),
	(vte_terminal_real_paste_clipboard),
	(vte_terminal_paste_clipboard):
	* src/vte.h:
	    Add key bindings for the special function keys.

2007-08-30  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_draw_rows): Bad manipulation of patches
	whilst attempting to apply the fix for Bug 434230 - net result was
	that the correct code was being circumvented.

2007-08-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 471484 – vteapp resize weirdness

	* src/vteapp.c (main): Distinguish between setting the geometry and
	disabling the use of geometry hints. A regression when converting to
	GOption based arguments.

2007-08-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 470690 – Typo at src/vtexft.c "appropiate" should be "appropriate"

	* src/vtexft.c (_vte_xft_open_font_for_char): Fix typo.

2007-08-07  Behdad Esfahbod  <behdad@gnome.org>

	* MAINTAINERS: Add Userid field, remove Guilherme.

2007-08-03  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 434230 – Spaces are not underlined
	Original patch by Santtu Lakkala.

	* src/vte.c (vte_terminal_draw_rows): Only skip cells if we do not
	need to draw on top.

2007-08-03  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 450069 – vte crash on removing a terminal tab

	* src/vte.c (vte_terminal_emit_eof), (vte_terminal_queue_eof),
	(vte_terminal_eof): Move the EOF emission to an idle handler so that
	the source is inactive whilst the VteTerminal is finalized.

2007-07-30  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.8.

	Quick followup release with no code changes, to fix missing
	documentation index in the tarball.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.8.
	Bumped libtool version to 11:12:2.

2007-07-27  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.7.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.7.
	Bumped libtool version to 11:11:2.

2007-07-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 337252 – ALT + Arrow keys don't work in irssi through gnome-terminal
	Patch by James Bowes

	* src/keymap.c (_vte_keymap_map), (is_cursor_key),
	(_vte_keymap_key_add_key_modifiers):
	* src/keymap.h:
	* src/vte.c (vte_terminal_key_press):
	Only switch to CSI for some cursor keys when in cursor app mode.

2007-06-25  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 448259 – Mapping for Ctrl-_
	Patch by Andrey Melnikov.

	* src/keymap.c: Add mapping for Ctrl-Minus.

2007-06-25  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 449809 – use python-config to get python includes
	Patch by Sebastien Bacher.

	* acinclude.m4: prefer python-config where available.

2007-06-25  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 450745 – VTE's response to CSI 2 1 t incorrectly formatted
	Patch by Dale Sedivec.

	* src/vteseq.c (vte_sequence_handler_window_manipulation): Restore
	the missing 'L'.

2007-06-21  Christian Persch  <chpe@gnome.org>

	* configure.in:
	* src/Makefile.am: Move libtool versioning to configure so you just
	have to update one file for releasing. See bug #396265 comment 17.

2007-06-18  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.6.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.6.

	* src/Makefile.am: Bumped libtool version to 11:10:2.

2007-06-12  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_set_size): Call gtk_widget_queue_resize()
	after updating row/column count.

2007-06-11  Behdad Esfahbod  <behdad@gnome.org>

	Bug 372743 – vte_terminal_set_colors doesn't work as advertised

	* src/vte.c (vte_terminal_set_colors): Allow 24-color palettes.

2007-06-09  Behdad Esfahbod  <behdad@gnome.org>

	Bug 445620 – Some characters shows different in different locales.
	Patch from Zealot

	* src/iso2022.c (_vte_iso2022_state_set_codeset): Update ambiguous
	width.

2007-06-04  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.5.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.5.

	* src/Makefile.am: Bumped libtool version to 11:9:2.

2007-05-30  Chris Wilson  <chris@chris-wilson.co.uk>

	fcrozat pointed out 'some strange "underline" line where cursor is
	located and blinking'.

	Also reported in bug 442688.

	* src/vte.c (vte_terminal_draw_rows):
	    Continuation of the previous commit: catch a couple more locations
	    where we need to skip past the end of the line. The problem in
	    this case was we tried to use some uninitialised variables whilst
	    trying to draw the cell attributes.

2007-05-28  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.4.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.4.

	* src/Makefile.am: Bumped libtool version to 11:8:2.

2007-05-28  Chris Wilson  <chris@chris-wilson.co.uk>

	uws noted on IRC that 'vte trunk does strange thingies with colors'

	* src/vte.c (vte_terminal_draw_rows):
	    When reaching the end-of-row be careful not to reset the
	    current text attributes (color, underlining, etc).

2007-05-25  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_expand_region),
	(vte_terminal_paint_area):
	    Only add the borders to the clear area.

2007-05-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 429278 – Cursor drawn strangely in joe

	* src/vte.c (vte_terminal_expand_region),
	(vte_terminal_paint_area):
	    Ensure the expanded regions are cell aligned.

2007-05-23  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 439247 – scrolling vim in full screen is painfully slow and takes up 100% of the cpu

	* src/vte.c (vte_terminal_draw_rows):
	    Fix up the unwanted break of Glyph runs at the end-of-lines.

2007-05-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 440475 – Display glitch with transparent backgroud

	* src/vte.c (vte_terminal_paint_area):
	    Apply the band-aid fix to clear the area that's about to be
	    repainted. The full solution will to be ensure that the regions
	    after expansion are cell-aligned.

2007-05-22  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 375112 – ctrl-key combinations yielding just key
	Original patch by <samo@altern.org> and refactored by Loïc Minier.

	* src/vte.c (vte_translate_national_ctrlkeys),
	(vte_terminal_key_press):
	    When cooking a string to pass through to the client obtain the
	    "raw" keyval.

2007-05-22  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 440377 – gnome-terminal cannot refresh terminal when accessibility enabled
	Original patch by Li Yuan.

	* src/vteaccess.c (vte_terminal_accessible_focus_in),
	(vte_terminal_accessible_focus_out),
	(vte_terminal_accessible_visibility_notify):
	    Return FALSE rather than void...

2007-05-17  Chris Wilson  <chris@chris-wilson.co.uk>

	* perf/scroll.vim:
	* perf/vim.sh:
	    Measure full screen scrolling performance.

2007-05-15  Chris Wilson  <chris@chris-wilson.co.uk>

	kmaraas reported an issue on IRC where the scrollback was not being
	updated correctly in the first tab when the terminal was resized via
	a second tab.

	* src/vte.c (vte_terminal_size_allocate): Check whether we need to
	recompute the visible lines due to a change in layout geometry.

2007-04-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 433776 – gnome-terminal crashes when open preedit area
	Take 2.

	* src/vte.c (vte_terminal_paint): The preedit_cursor is returned by
	the input modules in characters not in bytes as assumed by the
	validation.

2007-04-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 433776 – gnome-terminal crashes when open preedit area

	* src/vte.c (vte_terminal_paint): Use the validated cursor index.

2007-04-27  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.3.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.3.

	* src/Makefile.am: Bumped libtool version to 11:7:2.

2007-04-24  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 429189 – Vte-WARNING's

	* src/vtexft.c (_vte_xft_open_font_for_char):
		Convert the warning into a DEBUG.

2007-04-24  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 415044 – Use --enable-debug rather than --enable-debugging

	As noted on Bug 414716, the convention is to use --enable-debug
	to enable extra debugging code.

	* configure.in:
		s/debugging/debug/

2007-04-24  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 414716 – Refresh issue after changing workspaces

	* src/vte.c (vte_terminal_hierarchy_changed):
		Do not respond to toplevel mapping events.

2007-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.2.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.2.

	* src/Makefile.am: Bumped libtool version to 11:6:2.

2007-04-23  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 431799 – Regex highlighting is broken

	* src/vte.c (vte_terminal_emit_contents_changed),
	(vte_terminal_match_hilite_update), (process_timeout),
	(update_repeat_timeout), (update_timeout):
		Always emit any pending updates before redrawing. This
		ensures for example that the match contents are updated
		after a simple scroll event.

2007-04-20  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c (_vte_xft_start), (_vte_xft_clip):
		Optimise away the use of a clip mask for the common case
		of redrawing the whole terminal.

2007-04-17  Behdad Esfahbod  <behdad@gnome.org>

	* src/iso2022.c (_vte_iso2022_ambiguous_width): Consider
	ambiguous-width chars if VTE_CJK_WIDTH env var is set and we are
	under a CJK locale.

2007-03-12  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.1.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.1.

	* src/Makefile.am: Bumped libtool version to 11:5:2.

2007-04-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 426870 – vte often passes NUL to functions requiring valid unichar

	* src/vte.c (_vte_invalidate_cell), (_vte_invalidate_cursor_once),
	(vte_terminal_paint):
		Consistently guard against cell->c == '\0' before calling
		_vte_draw_get_char_width.

2007-04-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 419644 – Links do not get highlighted anymore
	Also see Bug 404757 – URL matching doesn't work with PCRE

	* configure.in:
		Kill --with-pcre as it changes the semantics of the API
		and only causes confusion.

2007-04-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 426541 – crash on IRM escape code

	* src/vte.c (vte_terminal_ensure_cursor),
	(_vte_terminal_insert_char):
		Mishandled insertion - we always extended the row for
		inserts even though the row would automagically extend
		for the inserted cells. This lead to referencing
		uninitialised cells at the end of the row during painting.
	* src/vte.c (vte_terminal_draw_rows):
		Retrieve the cell before inspecting it.

2007-04-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 424184 – Make scroll wheel send Page Up/Down when it makes sense

	Original patch by Shaun McCance and refined by Baris Cicek.

	* src/vte.c (vte_terminal_scroll):
		Send cursor keypress instead of trying to scroll the
		alternate screen in vain.

2007-04-03  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 425767 – vte_terminal_set_color_highlight should test for
	NULL before _vte_debug_print

	* src/vte.c (vte_terminal_set_color_cursor),
	(vte_terminal_set_color_highlight):
		Differentiate between set/unset paths.

2007-03-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 422385 – vte appears at the top of the root window even when
	packed at the bottom of it

	Patch by Dodji Seketeli.

	* src/vte.c (vte_terminal_size_allocate), (vte_terminal_realize):
		Honour the allocated position when realizing the widget.

2007-03-22  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c (_vte_xft_draw_text):
		Insert spaces into the Xft glyph stream to avoid the
		overhead of restarting a glyph sequence for every word.

2007-03-21  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 420935 – glyph can be cropped with not fitting in a cell

	* src/vte.c (vte_terminal_paint):
		Don't redraw the invisible cursor 
		- avoids nasty artifacts like clipping extra wide glyphs.

2007-03-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_scroll_pages):
		Leave 'contents-change' to the scroll handler.

2007-03-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_extend_selection),
	(vte_terminal_draw_rows):
		Accidentally inverted an is-empty? check during the 
		elimination of the empty bitfield.

2007-03-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 420067 – Does not handle expose events whilst processing
	unseen incoming data

	* src/vte.c (vte_terminal_expose):
		Handle the expose immediately if we are only processing
		incoming data (ie no redraws pending).

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c (vte_sequence_handler_cursor_character_absolute):
		Remove a chunk of code that was tried as a mutt band-aid
		long ago and was completely wrong.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 415381 – Improve performance of vte_terminal_insert_char()

	The bulk of the work to remove redundant reads and conditionals
	from the code. In particular, gcc was emitting bit-by-bit copies
	for transferring the bitfield since we modified a member immediately
	afterwards - overcome this by using an explicit memcpy of the
	bitfields.

	* src/vte-private.h:
	* src/vte.c (vte_g_array_fill), (vte_terminal_ensure_cursor),
	(_vte_terminal_insert_char), (vte_terminal_process_incoming),
	(vte_terminal_send):
	* src/vteseq.c (vte_sequence_handler_ic):

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 415381 – Improve performance of vte_terminal_insert_char()

	* src/vte-private.h: Use a simple boolean rather than counter for
	text changed style flags.
	* src/vte.c: And update users.
	* src/vteseq.c:

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 415381 – Improve performance of vte_terminal_insert_char()

	* src/vte-private.h: Embed bitfield into struct
	* src/vte.c:  And update users.
	* src/vteseq.c:

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Need to trigger update timeout rather than process timeout
	otherwise the background is not updated.

	* src/vte.c (vte_terminal_queue_adjustment_changed),
	(vte_terminal_queue_adjustment_value_changed):

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c (_vte_xft_create), (_vte_xft_destroy),
	(_vte_xft_start), (_vte_xft_end), (_vte_xft_clip),
	(_vte_xft_clear): Avoid some allocations.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 418073 – Opacity ignored for vtexft

	* src/vte.c:
	* src/vtedraw.c (_vte_draw_requires_clear):
	* src/vtedraw.h:
	* src/vteft2.c (_vte_ft2_set_background_image):
	* src/vtegl.c (_vte_gl_create), (_vte_gl_set_background_image):
	* src/vtepango.c (_vte_pango_set_background_image):
	* src/vtepangox.c (_vte_pango_x_set_background_image):
	* src/vtexft.c (_vte_xft_set_background_color),
	(_vte_xft_set_background_image):
		Flood fill the backing pixmap if we need to change it's
		opacity as well.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 418910 – Asymmetric scrolling with mouse wheel

	* configure.in:
	* src/vte.c: Round-up the delta before applying to ensure consistency
	between up and down.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_catch_child_exited), (vte_terminal_eof),
	(vte_terminal_process_incoming): Refactor some common code.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 416634 – Rendering glitch as autowrapped chars are outside invalidated bbox

	* src/vte.c (_vte_terminal_insert_char),
	(vte_terminal_process_incoming): Correctly update bbox after
	autowrapping.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 416635 – Rendering glitch: double draw of line below exposed region

	* src/vte.c (vte_terminal_expand_region),
	(vte_terminal_paint_area): Kill a couple of off-by-ones.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 418588 – Invalid read when drawing preedit cursor

	* src/vte.c (vte_terminal_paint):
		No need to read what is drawn and furthermore isn't allocated.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 417652 – Scrolling bug exposed by nvi

	* src/vte.c (vte_terminal_insert_rows), (_vte_terminal_ensure_row),
	(vte_terminal_ensure_cursor), (_vte_terminal_update_insert_delta):
		Ensure the rows before updating the insert delta and refactor
		the common code.

2007-03-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 417301 – Terminal widgets don't respond to DPI changes

	* src/vte.c (vte_terminal_fc_settings_changed): Force a font reload
	after XFT settings have changed.

2007-03-12  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.16.0.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.16.0.

	* src/Makefile.am: Bumped libtool version to 11:4:2.

2007-03-06  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c (vte_sequence_handler_cm), (vte_sequence_handler_sf):
		More work to match mutt's behaviour under xterm.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_io_read):
		Use the process estimate to load balance between multiple
		active terminals.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c (vte_sequence_handler_cm),
	(vte_sequence_handler_dc), (vte_sequence_handler_sf),
	(vte_sequence_handler_cursor_character_absolute):
		Tweak the fill of painted cells to match mutt's behaviour
		under xterm.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 414716 – gnome-terminal-2.17.92: terminal window dies...

	* src/vte.c (vte_terminal_map_toplevel),
	(vte_terminal_hierarchy_changed):
		Force the visibility state to unobscured after the toplevel is
		remapped.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_size_allocate):
		Note to self: Never try to optimize away the redraw.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (_vte_terminal_insert_char):
	* src/vtedraw.c (_vte_draw_text), (_vte_draw_char),
	(_vte_draw_fill_rectangle), (_vte_draw_draw_rectangle):
		Touch up whitespace in debug output.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (_vte_invalidate_cells), (vte_terminal_set_visibility),
	(vte_terminal_paint_area), (vte_terminal_expose):
		Make sure the invalidated_all flag is cleared in the expose
		event if we handle it immediately.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c (vte_sequence_handler_ce),
	(vte_sequence_handler_clear_current_line):
		Fixup invalidation to end-of-line.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 414586 – Terminal screen blinks when menu is opened for the first time

	* src/vte.c (vte_terminal_draw_rows), (vte_terminal_expand_region):
		Include the window padding when painting the cell backgrounds.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 414586 – Terminal screen blinks when menu is opened for the first time

	Avoid resetting the window background colour when the style is reset.
	Avoid clearing the window if we are using a simple color and double
	bufferring (i.e when we know we are using a pre-cleared pixmap).

	* src/vte-private.h:
	* src/vte.c (vte_terminal_init), (vte_terminal_size_allocate),
	(vte_terminal_unrealize), (vte_terminal_realize),
	(vte_terminal_paint_area), (vte_terminal_expose),
	(vte_terminal_class_init), (vte_terminal_background_update):
	* src/vtedraw.c (_vte_draw_has_background_image):
	* src/vtedraw.h:
	* src/vteft2.c (_vte_ft2_set_background_image):
	* src/vtegl.c (_vte_gl_set_background_image):
	* src/vtepango.c (_vte_pango_set_background_image):
	* src/vtepangox.c (_vte_pango_x_set_background_image):
	* src/vtexft.c (_vte_xft_set_background_image):

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 414586 – Terminal screen blinks when menu is opened for the first time

	* src/vte.c (_vte_invalidate_cells), (_vte_invalidate_all),
	(vte_terminal_expose), (add_update_timeout):
		Juggle the handling of external exposes/invalidates to avoid
		delays in refreshing the display when we are idle.

2007-03-05  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 414586 – Terminal screen blinks when menu is opened for the first time

	* src/vte.c (_vte_invalidate_cells), (vte_terminal_init),
	(vte_terminal_expand_region), (vte_terminal_paint_area):
		After enlarging the expand region make sure the dirty area
		includes the border for edge cells.

2007-03-04  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 414586 – Terminal screen blinks when menu is opened for the first time

	Distinguish between internal update requests and external. If we
	need to update due to a user action (such as adjusting the background
	or color palette) do not impose a futher delay.

	Tidy the color palette modification code to not trigger invalidates if
	we do not actually modify the palette.

	* src/vte-private.h:
	* src/vte.c (vte_terminal_set_color_internal),
	(vte_terminal_set_color_bold), (vte_terminal_set_color_dim),
	(vte_terminal_set_color_foreground),
	(vte_terminal_set_color_background),
	(vte_terminal_set_color_cursor),
	(vte_terminal_set_color_highlight), (vte_terminal_set_colors),
	(root_pixmap_changed_cb), (vte_terminal_set_background_saturation),
	(vte_terminal_set_background_tint_color), (add_update_timeout):
	* src/vteseq.c (vte_sequence_handler_ce),
	(vte_sequence_handler_clear_current_line),
	(vte_sequence_handler_clear_above_current):

2007-03-02  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413068 – new line added to tab when opened

	* src/vte.c (vte_terminal_size_allocate):
		Replace the ill-conceived attempt (delta could not be
		negative, so insert_delta or scroll_delta would not become
		negative either) by only considering changes wrt to the number
		of visible lines.

2007-03-02  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413068 – new line added to tab when opened

	* src/vte.c (_vte_terminal_insert_char):
		Improve debug output.
	* src/vte.c (vte_terminal_size_allocate):
		Be careful that we don't force insert_delta or scroll_delta
		to become negative.

2007-03-01  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.6.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.6.

	* src/Makefile.am: Bumped libtool version to 11:3:2.

2007-03-01  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (vte_terminal_draw_cells), (vte_terminal_draw_rows),
	(vte_terminal_paint):
		Tweak the clear widths to include the pixel widening due to
		psuedo-bold.

2007-03-01  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_ensure_row),
	(vte_terminal_ensure_cursor), (_vte_terminal_insert_char):
	* src/vteseq.c (vte_sequence_handler_ta):
		Be more careful when filling in gaps.

2007-03-01  Chris Wilson  <chris@chris-wilson.co.uk>

	Fix X11 headers / libraries detection on bi-arch systems.
	Patch by Frederic Crozat.

	* configure.in:
		Check for x_includes before ac_x_includes, and similary for
		ac_x_libraries.

2007-03-01  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410534 – Slow content scrolling, takes 100% of CPU.

	* src/vtexft.c:
		Further reduce the cap to 80 after more testing on the
		broken fglrx driver.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413068 – new line added to tab when opened

	* src/vte.c (vte_terminal_ensure_font), (vte_terminal_realize):
		Beware when no font is set before the first request...
		Make sure that at least the default font is set.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413262 – Incorrectly coloured tabs

	* src/vte-private.h:
	* src/vte.c (vte_terminal_ensure_cursor),
	(_vte_terminal_ensure_cursor), (_vte_terminal_insert_char),
	(_vte_terminal_feed_chunks), (vte_terminal_set_scrollback_lines):
	* src/vteseq.c (vte_sequence_handler_ta),
	(vte_sequence_handler_request_terminal_parameters),
	(vte_sequence_handler_return_terminal_status),
	(vte_sequence_handler_send_primary_device_attributes):
		Fill the tab in the current color, else it will be filled at
		the time of writing the next character.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413102 – Incorrect highlighting in vim

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_ensure_row),
	(_vte_terminal_insert_char):
	* src/vteseq.c(vte_sequence_handler_cb),
	(vte_sequence_handler_ce), (vte_sequence_handler_cr),
	(vte_sequence_handler_ec), (vte_sequence_handler_sf):
		Paint the row background when scrolling, this more closely
		matches xterm's behaviour.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413158 – Cursor trails

	* src/vte.c (_vte_invalidate_cell):
		_vte_invalidate_cell() can be called to invalidate any visible
		cell so issue the invalidate even for blank cells.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c (_vte_terminal_insert_char):
		Correct the OBO in the number of columns ensured.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 413078 – Crash during opening a new tab whilst scrolling
	
	During input processing it was possible to both remove the timeout and
	then add a new one. The currently running timeout would believe that
	it was to continue since the terminal was still active, and so *two*
	timeouts would be scheduled. Occasionally the second timeout would be
	called after the first had finished all the work, resulting in the
	second timeout trying to access a NULL active_terminal list.

	* src/vte.c (add_update_timeout), (remove_from_active_list),
	(vte_terminal_add_process_timeout), (need_processing),
	(process_timeout), (update_repeat_timeout), (update_timeout):
		Watch for recursive g_source_remove() from within timeouts.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410534 – Slow content scrolling, takes 100% of CPU.

	Submitting long glyph runs was causing a dramatic (10x) slow down
	in the fglrx xserver.

	* src/vtedraw.h:
	* src/vtexft.c(_vte_xft_draw_text):
		Cap the max glyph run length to 300.

2007-02-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 412717 – Crash when opening a new tab with window maximized

	* src/vte.c (vte_terminal_size_allocate):
		We didn't carefully check the values we were clamping the
		cursor to and ended up setting it to -1...  Don't do that!

2007-02-27  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteaccess.c (vte_terminal_accessible_text_scrolled):
		Consistently guard against the snapshot being NULL.

2007-02-27  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.5.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.5.

	* src/Makefile.am: Bumped libtool version to 11:2:2.

2007-02-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 412562 – Crash in vte_terminal_match_hilite_update

	* src/vte.c (vte_terminal_match_check_internal),
	(vte_terminal_process_incoming), (_vte_terminal_feed_chunks),
	(vte_terminal_paste_cb), (vte_terminal_match_hilite_update),
	(vte_terminal_copy_cb):
		Fixup a few 64bit-isms, notably format strings and an
		undesired unsigned integer promotion causing this crash.

2007-02-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410986 – Fails to build with -z defs

	If you link the vtemodule.so to libpython, then programs importing
	vte will have the symbols twice in memory: one set from python and
	the other from libpython.

	* configure.in:
	* python/Makefile.am:
		Remove PYTHON_LIBS from linking vtemodule.so.
		Convert unresolved symbol errors into warnings so that
		building with -Wl,-z,defs continues to work. This is a 
		*hack* as it hides real errors if you are updating
		vte.{def,override}.
		
2007-02-27  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c	(_vte_xft_open_font_for_char),
	(_vte_xft_font_for_char), (_vte_xft_compute_char_width),
	(_vte_xft_char_width), (_vte_xft_start), (_vte_xft_get_char_width),
	(_vte_xft_draw_text):
		Avoid some computations whilst drawing text.

2007-02-26  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.4.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.4.

	* src/Makefile.am: Bumped libtool version to 11:1:2.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410986 – Fails to build with -z defs

	The forgotten half - the python module also fails to link.

	* acinclude.m4:
	* python/Makefile.am:
		Add PYTHON_LIBS pointing to the customary location and
		remember to include them when compiling vtemodule.so.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 412361 – Yet another mouse selection regression...
	Part 2.

	* src/vte.c: (vte_terminal_queue_adjustment_value_changed),
	(_vte_terminal_adjust_adjustments_full),
	(vte_terminal_scroll_pages), (vte_terminal_autoscroll),
	(vte_terminal_size_allocate), (vte_terminal_scroll):
		We implicitly used a bit of sanity checking when setting the
		adjustment value. Ensure the value really is within the
		adjustment range before updating scroll_delta.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 412361 – Yet another mouse selection regression...
	Part 1.

	* src/vte.c: (vte_terminal_draw_rows):
		Restore drawing of the selection below the text.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_class_init), (time_process_incoming),
	(process_timeout), (update_repeat_timeout), (update_timeout):
		Update max number of processable bytes each time we call
		vte_terminal_process_incoming().

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_emit_adjustment_changed),
	(_vte_terminal_adjust_adjustments_full):
		Refactor the common code.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Push a couple of NULL checks to the callers so to be able to move them
	outside of the inner-most loops.

	* src/vte.c: (_vte_row_data_find_charcell), (_vte_invalidate_cell),
	(_vte_terminal_adjust_adjustments),
	(vte_terminal_get_text_range_maybe_wrapped), (find_start_column),
	(find_end_column), (vte_terminal_draw_rows):

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Some applications, such as cat, dump as much data to the terminal as
	possible. In these scenarios it is likely that we will read data from
	the child much faster than we can process it and the refresh will
	stutter.

	The ideal solution would be to speed up the data processing so that
	this overrun was impossible. However, the approach taken here is to
	estimate how much data we can actually process in our time slice and
	to stop reading once we have sufficient data.

	* src/vte-private.h:
	* src/vte.c: (_vte_invalidate_all),
	(vte_terminal_emit_contents_changed),
	(vte_terminal_match_contents_clear),
	(vte_terminal_match_contents_refresh),
	(vte_terminal_emit_adjustment_changed),
	(_vte_terminal_adjust_adjustments), (vte_terminal_scroll_pages),
	(vte_terminal_catch_child_exited), (vte_terminal_eof),
	(vte_terminal_process_incoming), (vte_terminal_io_read),
	(vte_terminal_handle_scroll), (vte_terminal_init),
	(vte_terminal_size_allocate), (need_processing), (process_timeout),
	(update_repeat_timeout), (update_timeout):
	* src/vteseq.c: (vte_sequence_handler_decset_internal):

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 411000 – Orca repeats old text in gnome-terminal

	The deferred handling of the window scrolling had the unfortunate
	side-effect of postponing the accessibility 'text-scrolled' signal
	until after the 'text-inserted' signal. This caused vteaccess to
	determine that the whole window had been modified and cause orca to
	reread the entire screen.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_emit_contents_changed),
	(_vte_terminal_queue_contents_changed),
	(vte_terminal_emit_cursor_moved),
	(vte_terminal_queue_cursor_moved), (vte_terminal_scroll_pages),
	(vte_terminal_eof), (vte_terminal_emit_pending_text_signals),
	(vte_terminal_process_incoming), (vte_terminal_handle_scroll),
	(vte_terminal_size_allocate), (vte_terminal_unrealize),
	(vte_terminal_emit_pending_signals):
	* src/vteaccess.c: (emit_text_caret_moved),
	(emit_text_changed_insert), (emit_text_changed_delete):
	* src/vteseq.c: (vte_sequence_handler_decset_internal):
		Restore the order of the ally signals. However, Bug 372777
		remains unresolved.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_io_read):
		Eeek, correctly compute the buffer length when we no longer
		aim to fill it.

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Use a separate debug flag for the ally interface.

	* src/debug.c: (_vte_debug_parse_string):
	* src/debug.h:
	* src/vteaccess.c:
	(vte_terminal_accessible_update_private_data_if_needed),
	(vte_terminal_accessible_invalidate_cursor),
	(vte_terminal_accessible_finalize),
	(vte_terminal_accessible_get_text),
	(vte_terminal_accessible_get_text_somewhere),
	(vte_terminal_accessible_text_init),
	(vte_terminal_accessible_component_init),
	(vte_terminal_accessible_action_init),
	(vte_terminal_accessible_factory_new):

2007-02-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_io_read):
		And finally clamp the maximum number of bytes transferred in
		a single chunk.

2007-02-24  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c:
		Hint that the compiler should inline
		vte_terminal_determine_colors().

2007-02-24  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 410534 – Slow content scrolling, takes 100% of CPU.
	cf Bug 410463 – Poor interactive performance with multiple terminals

	* src/vte.c: (vte_terminal_io_read):
		Do not loop whilst reading in a backlog of child data - should
		help prevent monopolisation of vte by a single child and make
		vte more responsive to user input on slower computers.

2007-02-24  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 159078 – slow highlight

	Do not update the match hilite during a selection-drag.
	Record unsuccesful regex matches, so we can quickly determine whether
	the cursor is still inside the blank region.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_match_check_internal),
	(rowcol_inside_match), (vte_terminal_match_check),
	(_vte_terminal_set_pointer_visible),
	(vte_terminal_match_hilite_clear),
	(vte_terminal_match_hilite_show), (vte_terminal_match_hilite_hide),
	(vte_terminal_match_hilite_update), (vte_terminal_match_hilite),
	(vte_terminal_motion_notify), (vte_terminal_button_press),
	(vte_terminal_focus_in), (vte_terminal_focus_out),
	(vte_terminal_enter), (vte_terminal_leave), (vte_terminal_init),
	(vte_terminal_unrealize), (vte_terminal_draw_rows),
	(vte_terminal_paint):

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	A couple of compiler warnings and avoid unnecessary arithmetic.

	* src/vte.c: (_vte_terminal_set_default_attributes),
	(find_start_column), (find_end_column),
	(vte_terminal_start_selection), (vte_terminal_extend_selection),
	(vte_terminal_draw_rows), (vte_terminal_paint):
	* src/vtexft.c: (_vte_xft_font_open), (_vte_xft_font_for_char),
	(_vte_xft_char_width), (_vte_xft_unlock_fonts), (_vte_xft_start),
	(_vte_xft_clip), (_vte_xft_set_text_font), (_vte_xft_draw_text):

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 411276 – SVN trunk compilation error
	Part 2.

	* configure.in:
		Check that the header file defines FcStrFree before checking
		for the availability of the function. Complete hack, but
		appears to work.

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 411276 – SVN trunk compilation error

	* configure.in:
		Ubuntu Edgy appears to have a broken fontconfig-dev package
		where the function is exported from the library but is missing
		the corresponding prototypes.
		So we reorder the determination of the compilation flags
		before checking for available functions in the hope that the
		tests will then match the results at compile time.

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_io_read):
		Prevent a deadlock on recursively grabbing the gdk_mutex.

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Heuristic to avoid a read when it's likely to just return EAGAIN.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_io_read), (process_timeout),
	(update_repeat_timeout), (update_timeout):

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Add a new debug flag to monitor draw operations.
	Don't issue individual glyphs for is_local_graphic() in the middle of
	a run.

	* src/debug.c: (_vte_debug_parse_string):
	* src/debug.h:
	* src/vte.c: (vte_terminal_unichar_is_local_graphic),
	(vte_terminal_draw_rows), (vte_terminal_paint):
	* src/vtedraw.c: (_vte_draw_init_user), (_vte_draw_init_default),
	(_vte_draw_new), (_vte_draw_free), (_vte_draw_get_visual),
	(_vte_draw_get_colormap), (_vte_draw_start), (_vte_draw_end),
	(_vte_draw_set_background_color), (_vte_draw_set_background_image),
	(_vte_draw_requires_repaint), (_vte_draw_clip), (_vte_draw_clear),
	(_vte_draw_set_text_font), (_vte_draw_get_text_width),
	(_vte_draw_get_text_height), (_vte_draw_get_text_ascent),
	(_vte_draw_get_char_width), (_vte_draw_get_using_fontconfig),
	(_vte_draw_text), (_vte_draw_char), (_vte_draw_has_char),
	(_vte_draw_fill_rectangle), (_vte_draw_draw_rectangle),
	(_vte_draw_set_scroll):
	* src/vtedraw.h:
	* src/vteft2.c: (_vte_ft2_draw_has_char):
	* src/vtegl.c: (_vte_gl_draw_has_char):
	* src/vtepango.c: (_vte_pango_draw_has_char):
	* src/vtepangox.c: (_vte_pango_x_draw_has_char):
	* src/vteskel.c: (_vte_skel_draw_has_char):
	* src/vtexft.c: (_vte_xft_draw_has_char):

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_rows):
		Don't break a glyph run for a graphic, issue the draw
		and continue.

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Cache the font metrics on the vte_xft_font, avoids having to remeasure
	when opening a new terminal.

	* src/vtexft.c: (_vte_xft_font_open), (_vte_xft_set_text_font):

2007-02-23  Chris Wilson  <chris@chris-wilson.co.uk>

	Share XftFonts between terminal backends and preserve faces from the
	previous draw - helps prevents font cache thrashing inside libXft.

	* src/vtexft.c: (_vte_xft_font_hash), (_vte_xft_font_equal),
	(_vte_xft_font_open), (_vte_xft_font_close),
	(_vte_xft_font_for_char), (_vte_xft_unlock_fonts),
	(_vte_xft_destroy), (_vte_xft_start), (_vte_xft_end),
	(ptr_array_zeroed_new), (_vte_xft_set_text_font),
	(_vte_xft_get_char_width), (_vte_xft_draw_text),
	(_vte_xft_draw_char):

2007-02-22  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410986 – Fails to build with -z defs
	Patch by Loïc Minier.

	* src/Makefile.am:
		Add FreeType to the libs.

2007-02-22  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_send):
		Return in the face of error as we appear to hit this in the
		wild.

2007-02-22  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410819 – slider not correctly positioned after calling less

	* src/vte.c: (_vte_terminal_adjust_adjustments),
	(_vte_terminal_adjust_adjustments_full),
	(vte_terminal_maybe_scroll_to_top), (vte_terminal_size_allocate),
	(vte_terminal_set_scrollback_lines):
	* src/vteseq.c: (vte_sequence_handler_decset_internal):
		Fixup a lot of issues with changing the number of scrollback
		lines, such as missing value_changed signals for the
		scrollbar and a couple of missing CLAMPs.

2007-02-22  Chris Wilson  <chris@chris-wilson.co.uk>

	After adjusting the current profile, the last line gets chomped.

	* src/vte.c: (vte_terminal_set_scrollback_lines):

2007-02-21  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 410534 – Slow content scrolling, takes 100% of CPU.

	* src/vte.c: (vte_terminal_scroll),
	(vte_terminal_set_scrollback_lines):
		Operate on scroll delta directly as adjustment->value updates
		are not instantaneous and we may have several scroll events
		before the next update.

2007-02-21  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 410463 – Poor interactive performance with multiple terminals

	* src/vte.c: (vte_terminal_io_read), (process_timeout),
	(update_repeat_timeout):
		When multiple terminals are active, poll the IO sources
		from within the process/display timeout (akin to 
		interrupt mitigation).
		Return to normal interrupts when we only have a single active
		terminal - so we don't sacrifice high performance.

2007-02-21  Chris Wilson  <chris@chris-wilson.co.uk>

	A small bit of callgrinding, avoid the modulus inside
	vte_terminal_ensure_cursor() by caching the last row_data.

	* src/iso2022.c: (process_cdata):
	* src/ring.c: (_vte_ring_new), (_vte_ring_insert),
	(_vte_ring_insert_preserve), (_vte_ring_remove):
	* src/ring.h:
	* src/table.c: (_vte_table_match):
	* src/vte.c: (_vte_terminal_ensure_cursor),
	(_vte_terminal_insert_char), (vte_terminal_process_incoming):

2007-02-21  Chris Wilson  <chris@chris-wilson.co.uk>

	Callgrind strikes again...
	Inserting a char is a rare operation (especially in the scrolling
	benchmark!) so only read the old cell during an insert. This wins
	about 5% during a hexdump.

	* src/iso2022.c: (_vte_iso2022_find_nextctl),
	(_vte_iso2022_fragment_input), (process_cdata):
	* src/vte.c: (_vte_terminal_insert_char):
	* src/vteseq.c: (vte_sequence_handler_sf):

2007-02-21  Chris Wilson  <chris@chris-wilson.co.uk>

	RedHat Bug 113195: First line displayed incorrectly if prompt changes background color

	e.g. PS1='\e[46m[\u@\h:\w]\e[m \e[45m'
	The issue is when we insert a char on a new row and the background is
	not the default, we fill the entire row with the *current* colour.
	This behaviour is incorrect, and the fix is to fill to the end of the
	line on a carriage return.

	* src/vte-private.h:
	* src/vte.c: (_vte_terminal_ensure_cursor),
	(_vte_terminal_insert_char), (vte_terminal_process_incoming),
	(vte_terminal_send):
	* src/vteseq.c: (vte_sequence_handler_ce),
	(vte_sequence_handler_cr), (vte_sequence_handler_cs),
	(vte_sequence_handler_cS),
	(vte_sequence_handler_cursor_lower_left),
	(vte_sequence_handler_dc), (vte_sequence_handler_ic),
	(vte_sequence_handler_sf):

2007-02-20  Chris Wilson  <chris@chris-wilson.co.uk>

	 RedHat Bug 123845: gnome-terminal not parsing cursor position escape sequence properly

	* src/caps.c:
	* src/vteseq.c: (vte_sequence_handler_cm):
		Add 'ESC [ Pn H' to cursor-position and provide default
		values.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 409055 – Terminal stays blank

	Due to GTK+ coallescing of XExposeEvents it was possible for our
	GdkExposeEvent to arrive before the GdkVisibilityEvent associated with
	the mapping of our toplevel and so we discarded the event as we
	believed we were still unviewable.

	* src/vte.c: (_vte_invalidate_cells), (vte_terminal_expose),
	(reset_update_regions):
		Assume that all GdkExposeEvents have been checked for
		suitability before delivery. We know this true for locally
		generated expose events which are extensively checked during
		invalidation, and we presume that X will not generate expose
		events on unmapped or otherwise unviewable windows.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_terminal_adjust_adjustments),
	(_vte_terminal_adjust_adjustments_full):
		Dead code elimination.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* perf/random.sh:
		A simple script to dump a fixed amount of random data to the
		terminal.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	A few more trivial incremental improvements.

	* src/Makefile.am:
	* src/iso2022.c: (_vte_iso2022_map_get):
		Switch to a VteTree.
	* src/vte.c: (_vte_terminal_update_insert_delta),
	(_vte_terminal_insert_char):
		No need to ensure the cursor when scrolling, only before
		insertions.
	* src/vtexft.c: (_vte_xft_font_open), (_vte_xft_font_close),
	(_vte_xft_font_for_char), (_vte_xft_end):
		Lock the face over the entire expose.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Improve handling of parallel 'cat /dev/urandom' - notably a crasher
	in the table matcher, repeated g_getenv processing and wasted time
	in g_tree_lookup.

	* src/iso2022.c: (_vte_iso2022_ambiguous_width_guess),
	(_vte_iso2022_map_init), (_vte_iso2022_map_get),
	(process_8_bit_sequence), (process_cdata),
	(_vte_iso2022_process_single), (_vte_iso2022_process):
	* src/table.c: (_vte_table_match):
	* src/vte-private.h:

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (update_timeout):
		In conjunction with the previous fix, since the terminal
		can be removed from the active list by
		vte_terminal_process_incoming() we need to be careful whilst
		iterating along the active list.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	<fcrozat> ickle: hi.. our kernel hacker just found a nice reproducible
		crash in vte :)
	<ickle> oh, joy
	<fcrozat> very easy to reproduce
		cat /dev/urandom
	 	wait 2 or 3S
	 	then press Ctrl-Shift-T to open a new tab
	 	=> crash

	* src/vte.c: (process_timeout), (update_repeat_timeout):
		vte_terminal_process_incoming() can trigger a terminal reset
		which will remove the terminal from the active list, and then
		we attempt to remove it again after handling the incoming
		data. The fix is simple - don't delete the link if the the
		terminal is no longer active.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	As noticed on bug 409055, we do not receive a visibility-notify
	event when we switch workspaces (or even when the window is iconified).
	The workaround for this is to watch for our toplevel being unmapped
	and set the fully-obscured flag.

	* src/vte.c: (vte_terminal_configure_toplevel),
	(vte_terminal_unmap_toplevel), (vte_terminal_hierarchy_changed),
	(vte_terminal_set_visibility), (vte_terminal_visibility_notify):

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (visibility_state_str),
	(vte_terminal_visibility_notify), (vte_terminal_init),
	(vte_terminal_realize):
		Add the visibility state to the debug output.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* configure.in:
		Add the configuration details to config.log as well.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 409241 – gnome-terminal crashed with SIGSEGV in vte_terminal_draw_graphic()

	* src/vte.c: (vte_terminal_paint):
		Lookup fore/back colours before attempting to draw the graphic
		character behind the unfocused cursor.

2007-02-19  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_visibility_notify):
		Add VTE_DEBUG_EVENT info.

2007-02-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 407945 – "GNOME" Terminal" regression after "vte" update when using "csh"

	When passing multiple versions of the same environment
	variable to execve (i.e g_spawn) the result is undefined.
	So we solve the ambiguity by using the application passed env to
	override values from the current environment.
	
	* src/pty.c: (collect_variables), (merge_environ),
	(_vte_pty_run_on_pty):

2007-02-16  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 408536 – trouble compiling vte 0.15.3

	* configure.in:
	* src/vtefc.c: (_vte_fc_patterns_from_pango_font_desc):
		Check for availability of FcStrFree() - only used for
		debugging purposes so we can live without it.

2007-02-15  Chris Wilson  <chris@chris-wilson.co.uk>

	Guard against a missing default number of rows or columns
	inside the termcap.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_set_emulation), (vte_terminal_init):

2007-02-15  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 408040 – vte automagic hyperlinks
	Patch by Gilles Dartiguelongue.

	* src/vteapp.c:
		Correct the typo in the nntp protocol matcher.

2007-02-14  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 407839 – Use of environ breaks build on Solaris
	Original patch by Damien Carbery.

	* src/pty.c:
		extern char **environ - glibc was 'conveniently' declaring
		it for us...

2007-02-13  Chris Wilson  <chris@chris-wilson.co.uk>

	uws reported that scrolling inside screen with a status line was
	broken. Indeed any scrolling inside an alternative screen was broken,
	e.g. plain vim would not always update the topmost line. The issue was
	the interaction with the deferred value-changed signal emission and
	failing to correctly maintain the current scroll_delta. The fix is
	that we always now apply changes to the scroll_delta and swap
	scroll_delta with adjustment->value before the deferred signal
	emission to correctly trigger the handle_scroll().

	* src/vte-private.h:
	* src/vte.c: (_vte_invalidate_cells),
	(vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_value_changed),
	(_vte_terminal_adjust_adjustments),
	(_vte_terminal_adjust_adjustments_full),
	(vte_terminal_maybe_scroll_to_bottom),
	(vte_terminal_process_incoming), (vte_terminal_extend_selection),
	(vte_terminal_handle_scroll), (vte_terminal_set_scrollback_lines):
	* src/vteseq.c: (vte_sequence_handler_sf):

2007-02-13  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 407358 – regression in mouse selection

	* src/vte.c: (vte_terminal_motion_notify):
		When outside the terminal we used an uninitialised variable to
		determine the mouse tracking mode.

2007-02-12  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.3.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.3.

	* src/Makefile.am: Bumped libtool version to 11:0:2.

2007-02-12  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_extend_selection),
	(vte_terminal_motion_notify):
		Restore autoscroll behaviour.

2007-02-12  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_start_selection):
		Invalidate the selected region when starting in
		select-word or select-line mode.

2007-02-12  Chris Wilson  <chris@chris-wilson.co.uk>

	Restore double-click to select word behaviour, broken by r1671 as
	the second click occurs in the same place as the first (obviously!).

	* src/vte.c: (vte_terminal_extend_selection),
	(vte_terminal_autoscroll), (vte_terminal_motion_notify),
	(vte_terminal_button_press):

2007-02-12  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 407091 – vte_terminal_fork_command() env argument changed semantic in 0.15.2
	Original patch by Michael Vogt.

	* src/pty.c: (_vte_pty_run_on_pty):
		Copy the current environment into the child's.

2007-02-11  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 323393 – Hyper-sensitive selection

	* src/vte.c: (vte_terminal_extend_selection):
		Don't start (or update) the selection until you
		move off the current cell (character).

2007-02-11  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 406763 – Selecting double-wide characters

	* src/vte.c: (start_column), (end_column),
	(vte_terminal_start_selection), (vte_terminal_extend_selection),
	(vte_terminal_draw_rows):
		Extend selection to include fragment cells i.e. double-wide
		characters.

2007-02-10  Chris Wilson  <chris@chris-wilson.co.uk>

	Have a separate adjust_adjustments for when we know that the page
	size and step lengths may have changed.

	* src/vte.c: (_vte_terminal_adjust_adjustments),
	(_vte_terminal_adjust_adjustments_full),
	(vte_terminal_set_scrollback_lines), (vte_terminal_reset):

2007-02-10  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_terminal_adjust_adjustments),
	(vte_terminal_size_allocate), (vte_terminal_set_scrollback_lines):
		Prevent the display of garbage after resizing and switching
		between alternate screens.
		However, instead of displaying garbage after the cursor, we
		lose some data above the current scroll delta, should we have
		a full history.  Bizarre.

2007-02-09  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_terminal_adjust_adjustments):
		Do not allow to scroll past the last line after reducing
		scrollback lines.
	* src/vtexft.c: (_vte_xft_set_text_font):
		Ensure a fallback height is set.

2007-02-09  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_get_text_range_maybe_wrapped):
		Reuse VteRowData whilst in the row.

2007-02-09  Chris Wilson  <chris@chris-wilson.co.uk>

	Rework to reduce number of times mutex is taken and shorten the hold.

	* src/vte.c: (vte_terminal_queue_adjustment_changed),
	(vte_terminal_queue_adjustment_value_changed),
	(vte_terminal_io_read), (vte_terminal_paint),
	(vte_terminal_add_process_timeout), (vte_terminal_is_processing),
	(vte_terminal_start_processing):

2007-02-09  Chris Wilson  <chris@chris-wilson.co.uk>

	A number of small bug fixes...
	- do not override the user setting of scrollback lines with the
	terminal size.
	- only set the current screen rather than both and so reset the
	scrollback lines when we switch between normal and alternate.
	- do not invalidate inside set_scrollback lines as setting does not
	actually modify the on-screen contents.
	- push the scroll-adjustment to the post-processing emission.
	- queue timeouts on value change (should be a no-op)
	- reorder emission so that scrolling occurs before invalidating the
	window (ie so that the scroll happens this cycle, not next).

	Still unsolved: the clamping of the cursor when switching between
	alternate screens.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_changed),
	(vte_terminal_queue_adjustment_value_changed),
	(_vte_terminal_adjust_adjustments), (vte_terminal_scroll_pages),
	(vte_terminal_maybe_scroll_to_top),
	(vte_terminal_maybe_scroll_to_bottom),
	(_vte_terminal_ensure_cursor), (_vte_terminal_update_insert_delta),
	(vte_terminal_process_incoming), (vte_terminal_extend_selection),
	(vte_terminal_autoscroll), (vte_terminal_handle_scroll),
	(vte_terminal_size_allocate), (vte_terminal_scroll),
	(vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_set_scrollback_lines), (vte_terminal_reset),
	(add_process_timeout), (vte_terminal_add_process_timeout),
	(vte_terminal_start_processing), (update_repeat_timeout),
	(update_timeout):
	* src/vteseq.c: (vte_sequence_handler_scroll_up_or_down),
	(vte_sequence_handler_decset_internal), (vte_sequence_handler_al),
	(vte_sequence_handler_dl), (vte_sequence_handler_sf),
	(vte_sequence_handler_sr), (vte_sequence_handler_clear_screen),
	(vte_sequence_handler_cursor_character_absolute),
	(vte_sequence_handler_insert_lines),
	(vte_sequence_handler_delete_lines),
	(vte_sequence_handler_screen_alignment_test):

2007-02-08  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteapp.c: (main): whitespace

2007-02-08  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 363597 – Scrollback in profile dialog doesn't work

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_init),
		Only use SCROLLBACK_MIN during initialisation, so rename it
		to SCROLLBACK_INIT.
	(vte_terminal_set_scrollback_lines):
		Remove MAX(lines, SCROLLBACK_MIN) and update code comments
		to reduce confusion.

2007-02-08  Mariano Suárez-Alvarez  <mariano@gnome.org>

	* src/vteapp.c(main): do something useful with --geometry.

2007-02-08  Chris Wilson  <chris@chris-wilson.co.uk>

	Use gtk_widget_get_(screen|display) which will itself return a default
	if not currently attached.

	* src/vtedraw.c: (_vte_draw_get_colormap):
	* src/vtefc.c: (_vte_fc_defaults_from_gtk):
	* src/vtegl.c: (_vte_gl_check), (_vte_gl_create),
	(_vte_gl_destroy), (_vte_gl_start), (_vte_gl_end), (_vte_gl_clear),
	(_vte_gl_draw_text), (_vte_gl_rectangle):
	* src/vterdb.c: (_vte_rdb_get):
	* src/vteseq.c: (vte_sequence_handler_window_manipulation):

2007-02-08  Chris Wilson  <chris@chris-wilson.co.uk>

	Some more callgrinding - kill a little bit of overhead.

	* src/iso2022.c: (_vte_iso2022_sequence_length),
	(_vte_iso2022_fragment_input), (process_control):
	* src/matcher.c: (_vte_matcher_free_params_array):
	* src/vteconv.c: (_vte_conv):

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	Actually return whether or not we found the char in
	_vte_xft_font_for_char - saves having to double check afterwards!

	* src/vtexft.c: (_vte_xft_font_for_char), (_vte_xft_set_text_font),
	(_vte_xft_draw_text):

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	As spotted perusing roxterm, we fail to redraw after changing the text
	colour.

	* src/vte.c: (vte_terminal_set_color_internal):
		Remember to invalidate all!

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_match_check_internal):
		Scan for newlines before and after the current row
		to find the entire line in case of soft-wrapping.

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 345344 – Pattern matching is inefficient
	Bug 324246 – Performance degredation with large numbers of highlighted addresses/URLs

	* src/vte.c: (vte_terminal_match_check_internal):
		Trim the searched string down to the row containing the
		pointer. During a mutt session this drops the time consumed by
		regexec from ~30% to ~2%.
		Note: multi-line regexes are now unsupported!

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c: (_vte_sequence_get_handler):
		Avoid the strlen when possible.

2007-02-07  Chris Wilson  <chris@chris-wilson.co.uk>

	Some cleanups and a bug...

	vte_terminal_match_hilite() compared the current cell to the last
	mouse position without a floor().

	* src/vte.c: (vte_terminal_process_incoming),
	(vte_terminal_match_hilite), (vte_terminal_select_all),
	(vte_terminal_select_none), (vte_terminal_motion_notify),
	(vte_terminal_button_press):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 86119 – "select all" feature
	Original patch by Simone Gotti.

	* src/vte.c: (vte_terminal_select_all), (vte_terminal_select_none):
	* src/vte.h:
		Add 2 new API entry points to select the entire contents
		and clear the current selection.

2007-02-06  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 342059 – ASCII escape sequences don't work as expected
	Correction by Mariano Suárez-Alvarez.

	* src/vteseq.c: (vte_sequence_handler_cursor_character_absolute):
		OBO on the parameter.

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 342059 – ASCII escape sequences don't work as expected
	Patch by Mariano Suárez-Alvarez.

	* src/vteseq.c: (vte_sequence_handler_cursor_character_absolute):
		Provide a default value.

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	And finally as noted on bug 324246#c8 hide the hilite when the mouse
	leaves the terminal (show again when it enters and let motion-notify
	correct it later).

	* src/vte.c: (vte_terminal_enter), (vte_terminal_leave),
	(vte_terminal_realize), (vte_terminal_class_init):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	As noted on bug 324246#c8, hide the hilite when the focus disappears.
	On focus restore the match for the last mouse coordinates and let
	motion-notify take care of the rest.

	* src/vte.c: (vte_terminal_match_hilite_update),
	(vte_terminal_match_hilite), (vte_terminal_focus_in):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Convert the exposed rectangles to cells and remerge them.

	* src/vte.c: (vte_terminal_expand_region),
	(vte_terminal_paint_area), (vte_terminal_paint):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	As noted on Bug 401052#c13, vte fails to completely clear the cell's
	previous contents.

	* src/vte.c: (_vte_invalidate_cells):
		Grow the invalidate region by a single pixel to accomodate
		antialiased pseudo-bold characters.

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Move status_line_changed to post-processing emission.

	* src/vte-private.h:
	* src/vte.c: (_vte_terminal_insert_char), (vte_terminal_reset),
	(vte_terminal_emit_pending_signals):
	* src/vteseq.c: (vte_sequence_handler_ts):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	Clamp down on needless invalidates during selection.

	As commented on in Bug 401052#c10

	* src/vte.c: (_vte_invalidate_region), (vte_terminal_deselect_all),
	(vte_terminal_match_hilite_clear), (vte_terminal_start_selection),
	(vte_terminal_extend_selection):

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_rows):
		Don't needlessly break the text run on a space if we are
		not drawing cell attributes.

2007-02-06  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/iso2022.c: (_vte_iso2022_is_ambiguous_ht):
		One more G_UNLIKELY
	* src/vte.c: (vte_terminal_match_hilite),
	(vte_terminal_motion_notify):
		Avoid expensive hiliting if the pointer is not in the window.
	* src/vteregex.c: (_vte_regex_exec):
		Prefer g_new(x,n) over g_malloc(sizeof(x)*n)

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 404757 – URL matching doesn't work with PCRE

	* configure.in:
		mention the inconsistency in the help string and default to no.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_rows):
		Don't draw cell attributes across spaces.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_terminal_insert_char):
		A couple more G_LIKELYs.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 403028 – decset mode 12 = blinking cursor

	* src/vteseq.c: (vte_sequence_handler_decset_internal):
		Following convention, disallow the application's control
		over the blinking cursor in favour of the user's setting.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Some more small callgrind tweaks - well into the law of diminishing
	returns.

	* src/iso2022.c: (_vte_iso2022_is_ambiguous_ht),
	(_vte_iso2022_is_ambiguous), (process_8_bit_sequence),
	(process_cdata), (_vte_iso2022_unichar_width):
	* src/matcher.c: (_vte_matcher_free_params_array):
	* src/vte.c: (vte_terminal_process_incoming):

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	Beware the trivial change. Handle reuse of GValueArray correctly.

	* src/matcher.c: (_vte_matcher_match):
	* src/table.c: (_vte_table_match):
	* src/trie.c: (_vte_trie_match):
	* src/vte.c: (vte_terminal_process_incoming):

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/table.c: (_vte_table_match):
		And kill the leak as vte_table_match erroneously cleared
		its output arguments.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	The continual reallocation of GValueArray is the last trivially
	avoidable g_realloc.

	* src/interpret.c: (main):
	* src/matcher.c: (_vte_matcher_create), (_vte_matcher_destroy),
	(_vte_matcher_match), (_vte_matcher_free_params_array):
	* src/matcher.h:
	* src/table.c: (_vte_table_extract_string):
	* src/trie.c: (_vte_trie_matchx), (_vte_trie_match), (main):
	* src/vte.c: (vte_terminal_process_incoming):

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/ring.c: (_vte_ring_insert):
		Missed an important compiler warning.

2007-02-05  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 342338 – suffers from memory fragmentation

	Reuse the last VteRowData instead of immediately freeing it. Avoids
	recreating and *regrowing* a new GArray on the heap.

	In the simple scrolling benchmarks this can boost performance by as
	much as 10%!

	* src/ring.c: (_vte_ring_insert), (_vte_ring_insert_preserve),
	(_vte_ring_remove), (_vte_ring_append):
	* src/ring.h:
	* src/vte-private.h:
	* src/vte.c: (_vte_reset_row_data), (_vte_terminal_ensure_cursor),
	(_vte_terminal_insert_char), (vte_terminal_reset_rowdata):
	* src/vteseq.c: (vte_insert_line_internal),
	(vte_sequence_handler_scroll_up_or_down),
	(vte_sequence_handler_cd), (vte_sequence_handler_sf),
	(vte_sequence_handler_clear_screen),
	(vte_sequence_handler_screen_alignment_test):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	A few more compiler warnings.

	* src/buffer.c: (_vte_buffer_peek_gstring):
	* src/iso2022.c: (process_control):
	* src/vteft2.c: (_vte_ft2_set_text_font):
	* src/vteseq.c: (vte_sequence_handler_set_title_internal):
	* src/vtetc.c: (_vte_termcap_parse_file):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 106618 – CJK 'fixed width' font and 's p a c e d o u t' issue

	* src/vtedraw.h:
	* src/vteglyph.c: (_vte_glyph_cache_set_font_description):
	* src/vtepango.c: (_vte_pango_set_text_font):
	* src/vtepangox.c: (_vte_pango_x_set_text_font):
	* src/vtexft.c: (_vte_xft_set_text_font):
		Detect a change in font between wide-chars and recheck for a
		fixed-width estimate.

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Micro-opts.

	* src/table.c: (_vte_table_match):
		No need set to NULL.
	* src/vte.c: (_vte_terminal_ensure_cursor):
		If we have added some rows, the last is the current.

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Move window/icon title changed to the post-processing emission - helps
	with the artificial benchmark of replaying a recorded jhbuild script.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_finalize),
	(vte_terminal_emit_icon_title_changed),
	(vte_terminal_emit_window_title_changed),
	(vte_terminal_emit_pending_signals):
	* src/vteseq.c: (vte_sequence_handler_set_title_internal):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Broke clear-to-end-of-line by lowering the number of cells appended,
	instead of the number of cells invalidated.

	* src/vte.c: (vte_terminal_draw_rows):
	* src/vteseq.c: (vte_sequence_handler_ce):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 83285 – Treacle-slow scrolling in gnome-terminal on unaccelerated X server

	Another chunk of performance improvements - the majority focusing on
	reducing the amount of work down per interrupt (input data from
	child).

	To handle reads without addition copies VTE_INPUT_CHUNK_SIZE chunks
	are allocated on demand and filled from read with no further copy -
	previously the read was into a local buffer and then immediately
	copied into a _vte_buffer.
	_vte_iso2022_process() is then adjusted to use a ptr+length, rather
	than a _vte_buffer and is called for every input chunk (taking special
	care over the boundary cases).

	* src/interpret.c: (main):
	* src/iso2022.c: (_vte_iso2022_fragment_input),
	(process_8_bit_sequence), (process_cdata), (_vte_iso2022_process):
	* src/iso2022.h:
	* src/vte-private.h:
	* src/vte.c: (get_chunk), (release_chunk), (prune_chunks),
	(_vte_incoming_chunks_release), (_vte_incoming_chunks_length),
	(_vte_incoming_chunks_count), (_vte_incoming_chunks_reverse),
	(vte_terminal_match_check_internal), (_vte_terminal_ensure_cursor),
	(vte_terminal_set_colors), (_vte_terminal_insert_char),
	(vte_terminal_catch_child_exited), (vte_terminal_eof),
	(vte_terminal_process_incoming), (_vte_terminal_feed_chunks),
	(vte_terminal_io_read), (vte_terminal_feed), (vte_terminal_send),
	(vte_terminal_init), (vte_terminal_finalize), (vte_terminal_reset),
	(remove_from_active_list), (need_processing), (update_regions),
	(update_repeat_timeout):
	* src/vte.h:
	* src/vteseq.c: (vte_sequence_handler_cb),
	(vte_sequence_handler_ce), (vte_sequence_handler_ec):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Store whether the codeset is ambiguous in a state variable,
	rather than recomputing the ambiguous width every processing loop.

	* src/iso2022.c: (_vte_iso2022_is_ambiguous),
	(_vte_iso2022_state_new), (_vte_iso2022_find_nextctl):

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c: (_vte_xft_create), (_vte_xft_destroy):
		Remove zero-initialisers after g_slice_new0().
	* src/vtexft.c :(_vte_xft_set_text_font):
		Print out the width range.

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	* configure.in:
		Missing space between -Wflags.

2007-02-04  Chris Wilson  <chris@chris-wilson.co.uk>

	Eliminate the temporary g_sliced parameter list,
	in favour of an on-stack list.

	* src/table.c: (_vte_table_arginfo_head_init),
	(_vte_table_arginfo_alloc), (_vte_table_arginfo_head_revert),
	(_vte_table_arginfo_head_reverse),
	(_vte_table_arginfo_head_finalize), (_vte_table_addi),
	(_vte_table_matchi), (_vte_table_extract_string),
	(_vte_table_match):

2007-02-02  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtefc.c: (_vte_fc_patterns_from_pango_font_desc):
		Dump the chosen fonts to VTE_DEBUG_MISC.
	* src/vteft2.c: (_vte_ft2_set_text_font):
		Print out the font metrics ala vtexft.c

2007-02-02  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 322241 – Please switch to pkg-config to check for freetype

	* configure.in:
		Prefer to use the freetype2.pc if available.

2007-02-02  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 322240 – Usage of pkg-config privates header

	* vte.pc.in:
		Move @FT2_LIBS@ to Libs.private.

2007-02-01  Chris Wilson  <chris@chris-wilson.co.uk>

	cf Bug 403275 – crash in Terminal: I was typing reset on th...

	Not the crash, just a freeze found whilst trying to reproduce the
	bug on trunk.

	* src/vte.c: (remove_from_active_list):
		Don't remove the terminal from the active list if it still
		has pending redraws.
	
	* src/vte.c: (process_timeout), (update_timeout):
		Reorder the loop to remove the terminal from the active list
		if it no longer needs processing.

2007-02-01  Chris Wilson  <chris@chris-wilson.co.uk>

	* perf/scroll.vim:
		Extract the bits the test needs out of debian.vim.

2007-02-01  Chris Wilson  <chris@chris-wilson.co.uk>

	As spotted on bug 399617c8, we convert an array of unichars to a
	string and then iterate over the string interpreting bytes as
	unichars.

	* src/table.c: (_vte_table_extract_numbers):
		Dispense with the temporary string and process the unichar
		array directly.

2007-02-01  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 403159 – XftDrawSetClipRectangles() silently fails on ppc->i386

	* src/vtexft.c: (_vte_xft_clip):
		Precompute clip offsets.

2007-02-01  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 382245 – __PyGtk_API multiply defined in python module

	* configure.in:
		Add -fno-common to MAYBE_WARN in order to catch future
		errors of this type.
	* python/vte.override:
		Define PYGTK_NO_IMPORT.

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 155687 – Scroll region \E[NN;MMr should set cursor to home

	Patch originally by Michele Baldessari.

	* src/vteseq.c: (vte_sequence_handler_cs):
		Move the cursor to (0,0) rather than clamping the cursor to 
		be inside the scroll region.

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	In a few places the contents of a GValue were being used without
	checking that they were of the expected type.

	cf Bug 117945 which mentions stack corruption inside
	vte_sequence_handler_delete_lines() - one of the corrected instances.

	* src/vteseq.c: (vte_sequence_handler_al),
	(vte_sequence_handler_cs), (vte_sequence_handler_cS),
	(vte_sequence_handler_dl),
	(vte_sequence_handler_character_attributes),
	(vte_sequence_handler_insert_lines),
	(vte_sequence_handler_delete_lines),
	(vte_sequence_handler_device_status_report),
	(vte_sequence_handler_dec_device_status_report):
		Check that the GValue holds a long before dereference.

2007-01-31  Chris Wilson <chris@chris-wilson.co.uk>

	Back to the old-style io loop as _vte_buffer_append() is too slow - on
	a slow system the read can fill before the data is copied (even more
	apparent under valgrind).

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_io_read):

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Use the display stashed inside the font and not the default display!

	* src/vtexft.c: (_vte_xft_char_exists), (_vte_xft_text_extents),
	(_vte_xft_font_open), (_vte_xft_font_close),
	(_vte_xft_font_for_char), (_vte_xft_draw_text):

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	A mixed bag of cleanups.

	* configure.in:
	* src/pty.c: (_vte_pty_set_utf8):
		Test for existence of tc[sg]etattr.
	* src/vte-private.h:
	* src/vte.c: (vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_changed),
	(vte_terminal_set_color_internal), (vte_terminal_handle_sequence),
	(_vte_terminal_enable_input_source), (vte_terminal_io_read),
	(vte_terminal_init), (vte_terminal_unrealize),
	(vte_terminal_finalize), (vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_emit_pending_signals), (process_timeout),
	(update_repeat_timeout), (update_timeout):
		Move idle signal emission to display handlers.
	* src/vtedraw.h:
		Add '&' to the single width characters.
	* src/vteseq.c: (_vte_sequence_get_handler):
	* src/vteseq.h:
		Drop the extraneous GQuark parameter.
	* src/vtexft.c: (_vte_xft_set_text_font):
		Avoid use of strlen for a compile-time fixed length string.

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 147784 – cursor unvisible under mouse highlight

	Original patch by Chris Health

	* src/vte.c: (vte_terminal_paint):
		Reverse cursor color if it is in the selected region and draw
		it as an outline.

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 368894 – crash in Terminal: I started gnome-terminal...

	* src/vtebg.c: (vte_bg_cache_search), (vte_bg_get_pixmap),
	(vte_bg_get_pixbuf):
		When retrieving a cached pixmap check that the visual
		matches the current request.

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Use gdk_error_trap_{push,pop} around raw Xft calls - about a
	path outside of vte_draw_{begin,end}.

	* src/vtexft.c: (_vte_xft_set_text_font):

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Use gdk_error_trap_{push,pop} around raw X11 and Xft calls.
	cf Bug 368894.

	* src/vtexft.c: (_vte_xft_font_for_char), (_vte_xft_start),
	(_vte_xft_end):

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Use gperf to calculate a more optimal vte_sequence_get_handler().
	This reduces vte_sequence_get_handler() from ~13% of the runtime
	during 'seq 1 1e6' to ~.5% (cumulative).

	* src/Makefile.am:
	* src/vteseq-2.c: (vteseq_2_hash), (vteseq_2_lookup):
	* src/vteseq-2.gperf:
	* src/vteseq-n.c: (vteseq_n_hash), (vteseq_n_lookup):
	* src/vteseq-n.gperf:
	* src/vteseq.c: (_vte_sequence_get_handler):

2007-01-31  Chris Wilson  <chris@chris-wilson.co.uk>

	Rudimentary vim scrolling benchmark.

	* perf/Makefile.am:
	* perf/UTF-8-demo.txt:
	* perf/scroll.vim:
	* perf/vim.sh:

2007-01-30  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 402329 – Rendering problem with underlines and cursor

	* src/vte.c: (vte_terminal_paint):
		Check hilite state when redrawing character under cursor.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_io_read):
		Clean up the read IO loop.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	NULL return from pcre_study() does not necessarily mean an error
	occurred.

	* src/vteregex.c: (_vte_regex_compile), (_vte_regex_exec):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_terminal_set_pointer_visible),
	(_vte_terminal_fudge_pango_colors):
		Kill a couple more compiler warnings.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 336105 – gnome-terminal crashes when termcap not found

	* src/matcher.c: (_vte_matcher_init):
	* src/vte-private.h:
	* src/vte.c: (vte_terminal_set_default_tabstops),
	(vte_terminal_key_press), (vte_terminal_set_emulation),
	(_vte_terminal_inline_error_message), (vte_terminal_set_termcap),
	(vte_terminal_init), (vte_terminal_finalize),
	(vte_terminal_draw_cells):
		Detect and issue an inline warning when we fail
		to load a termcap.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Tighten the invalidated cells.

	* src/vte.c: (_vte_terminal_select_text):
	* src/vteseq.c: (vte_sequence_handler_cb):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	More compiler warnings.

	* src/vtepangox.c: (_vte_pango_x_set_text_font),
	(_vte_pango_x_draw_text):
	* src/vteregex.c: (_vte_regex_exec):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Detect availability of PCRE.

	* configure.in:
	* src/Makefile.am:

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Improve handling of multi-row clears.

	* src/vte.c: (vte_terminal_draw_cells), (vte_terminal_draw_rows),
	(vte_terminal_paint):

2007-01-29  Chris Wilson <chris@chris-wilson.co.uk>

	Add debugging flags for printing out cells contents and attributes as
	they are rendered.

	* src/debug.c: (_vte_debug_parse_string):
	* src/debug.h:
	* src/vte.c: (vte_terminal_draw_cells):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_rows):
		Don't issue glyph items for blank cells.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* configure.in:
		Add -Wshadow to MAYBE_WARN
	* src/ring.c: (_vte_ring_remove):
	* src/table.c: (_vte_table_matchi):
	* src/vtedraw.c: (_vte_draw_clip):
	* src/vteskel.c:
		Clean up some compiler warnings.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteskel.c:
		Add the NULL clip func to the skeleton function table.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Update match hilite before showing the pointer as the choice of
	cursor depends on whether the pointer is above a matched region.

	* src/vte.c: (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	Only update the matched region if we move the pointer outside of the
	currently matched region.
	And only invalidate the cells underneath the matched region.

	* src/vte.c: (_vte_invalidate_region),
	(vte_terminal_match_hilite_clear), (cursor_inside_match),
	(vte_terminal_match_hilite), (vte_terminal_draw_rows):

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/table.c: (_vte_table_free):
		Fix a memleak.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	==26147== 2,895 (352 direct, 2,543 indirect) bytes in 22 blocks are definitely lost in loss record 107 of 170
	==26147==    at 0x4021380: malloc (vg_replace_malloc.c:149)
	==26147==    by 0x4E85965: g_malloc (gmem.c:131)
	==26147==    by 0x4E95537: g_slice_alloc (gslice.c:777)
	==26147==    by 0x4E7C255: g_list_prepend (glist.c:95)
	==26147==    by 0x428B887: vte_terminal_feed (vte.c:10991)
	==26147==    by 0x429DD20: vte_terminal_io_read (vte.c:3214)
	==26147==    by 0x4EA7A8C: g_io_unix_dispatch (giounix.c:162)
	==26147==    by 0x4E7E481: g_main_context_dispatch (gmain.c:2045)
	==26147==    by 0x4E8145E: g_main_context_iterate (gmain.c:2677)
	==26147==    by 0x4E81808: g_main_loop_run (gmain.c:2881)
	==26147==    by 0x45BA503: gtk_main (gtkmain.c:1148)
	==26147==    by 0x805F7A3: main (terminal.c:1773)

	* src/vte.c: (remove_from_active_list), (process_timeout),
	(update_repeat_timeout):
		g_list_delete_link() is the one that actually frees the link.
		s/g_list_remove_link/g_list_delete_link/.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	==26147== Conditional jump or move depends on uninitialised value(s)
	==26147==    at 0x42AB9F7: _vte_rdb_search (vterdb.c:95)
	==26147==    by 0x42ABB40: _vte_rdb_quark (vterdb.c:201)
	==26147==    by 0x42ABB9F: _vte_rdb_get_hintstyle (vterdb.c:241)
	==26147==    by 0x42A7952: _vte_fc_patterns_from_pango_font_desc (vtefc.c:302)
	==26147==    by 0x42B4E9B: _vte_xft_set_text_font (vtexft.c:103)
	==26147==    by 0x42A6BE5: _vte_draw_set_text_font (vtedraw.c:258)
	==26147==    by 0x428C62B: vte_terminal_ensure_font (vte.c:5963)
	==26147==    by 0x4290295: vte_terminal_size_request (vte.c:6613)
	==26147==    by 0x4E25228: g_cclosure_marshal_VOID__BOXED (gmarshal.c:566)
	==26147==    by 0x4E17038: g_type_class_meta_marshal (gclosure.c:567)
	==26147==    by 0x4E188FC: g_closure_invoke (gclosure.c:490)
	==26147==    by 0x4E29779: signal_emit_unlocked_R (gsignal.c:2370)
	==26147== 

	* src/vterdb.c: (_vte_rdb_get):
		Check the result of the get_property_string before using the
		returned values.

2007-01-29  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_cells), (vte_terminal_draw_rows):
		Merge draw_cells() with the background clear, as generating
		items for many rows and then splitting again in draw cells is
		simply inefficient.

2007-01-28  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 401215 – Multi-pass renderering

	* src/vte.c: (vte_terminal_draw_cells), (vte_terminal_clear_cells),
	(vte_terminal_draw_cells_with_attributes),
	(vte_terminal_draw_rows), (vte_terminal_paint):
		Break the draw_rows() loop into two passes - first clear the
		background and second render the text.
		Add another function based on draw_cells() that just clears the
		background and make clearing the background optional in
		draw_cells() - updating callers accordingly.
		Adventurous souls are required to clean up draw_rows().

2007-01-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Fix compilation *with* debugging enabled.
	Grrr.

	* src/keymap.c: (_vte_keysym_print):

2007-01-27  Chris Wilson  <chris@chris-wilson.co.uk>

	Fix compilation without debugging enabled.

	* src/keymap.c: (_vte_keysym_print), (_vte_keymap_map):
	* src/vte.c: (display_control_sequence):
	* src/vteapp.c: (main):

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/debug.h:
		Provide a safe fallback for non-C99 compilers (well actually
		anything that isn't a recent gcc at the moment).

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 157267 – _vte_terminal_fudge_pango_colors() breaks Japanese input style

	Patch by ynakai@redhat.com.

	* src/vte.c: (_vte_terminal_fudge_pango_colors):
		Check the attributes for each cell rather than assuming the
		pango attributes (and cell attributes) are the same for the
		whole string.

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vteseq.c: (vte_sequence_handler_vb):
		Iterating over all queued exposures and drawing on top of the
		flash does not sense. Simply flush the draw.

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	s/_VTE_DEBUG_ON/_VTE_DEBUG_IF/ and don't include
	the code block inside the macro.

	* src/debug.h:
	* src/iso2022.c: (process_control), (_vte_iso2022_process):
	* src/keymap.c: (_vte_keymap_map):
	* src/matcher.c: (_vte_matcher_init):
	* src/pty.c: (_vte_pty_run_on_pty):
	* src/table.c: (_vte_table_addi), (_vte_table_matchi),
	(_vte_table_extract_numbers), (_vte_table_match):
	* src/trie.c: (_vte_trie_addx):
	* src/vte.c: (vte_terminal_match_check_internal),
	(vte_terminal_match_check), (vte_terminal_handle_sequence),
	(vte_terminal_catch_child_exited), (vte_terminal_process_incoming),
	(vte_terminal_io_write), (vte_terminal_send),
	(vte_terminal_key_press), (vte_terminal_copy_cb),
	(vte_terminal_set_font_full), (vte_terminal_realize),
	(vte_terminal_paint), (vte_terminal_scroll):
	* src/vteapp.c: (main):
	* src/vtebg.c: (vte_bg_root_pixmap):

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 400834 – Use a global display/process timeout

	Currently each terminal uses it own display timeout. Given that
	typical usage is several active terminals, there is an immediate
	advantage (context switches, fairness, smoothness) to using a single
	common timeout.

	* src/debug.c: (_vte_debug_parse_string):
	* src/debug.h:
		Add VTE_DEBUG_TIMEOUT
	* src/vte-private.h:
	* src/vte.c: (update_regions), (_vte_invalidate_cells),
	(_vte_invalidate_all), (vte_terminal_init),
	(vte_terminal_class_init), (add_update_timeout),
	(remove_from_active_list), (remove_update_timeout),
	(add_process_timeout), (vte_terminal_stop_processing),
	(vte_terminal_is_processing), (process_timeout),
	(update_repeat_timeout), (update_timeout):
		Modify to use a global timeout rather than individual
		private timeouts.

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Unable to set background scrolling mode from cmdline due to variable
	name confusion.

	* src/vteapp.c: (main):
		--scroll should set scroll=TRUE rather than cursor=TRUE!

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 401082 – double-draw issue

	The main cause of this bug was not expanding the cleared area to cover
	all the cells affected by the draw and forgetting to offset the clear
	by VTE_PAD_WIDTH.

	To counter the performance hit due to the expanded repaint area, each
	backend is presented with the opportunity to apply a clip to the
	exposed region before painting.

	This also fixes bug 333157,

	* src/vte.c: (_vte_invalidate_cells), (vte_terminal_paint_area),
	(vte_terminal_paint):
	* src/vtedraw.c: (_vte_draw_clip):
	* src/vtedraw.h:
	* src/vteft2.c: (_vte_ft2_end), (_vte_ft2_clip):
	* src/vtegl.c:
	* src/vtepango.c: (_vte_pango_clip):
	* src/vtepangox.c: (_vte_pango_x_clip):
	* src/vtexft.c: (_vte_xft_clip), (_vte_xft_draw_text):

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_match_hilite):
	* src/vteseq.c: (vte_sequence_handler_ce),
	(vte_sequence_handler_dc), (vte_sequence_handler_ec):
		Tighten the _vte_invalidate_cells() to only those that
		we potentially modify.

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	* src/vtexft.c: (_vte_xft_set_text_font):
		Remove the additional pixel inter-character spacing.
		Compactness over clarity ;)

2007-01-26  Chris Wilson  <chris@chris-wilson.co.uk>

	Apply a one pixel fudge to the Xft character position and width.
	This greatly improves text appearance and hides the misrendering of
	pseudo-bold characters.
	cf bugs 317691, 333157.

	* src/vte.c: (vte_terminal_paint):
		Increase the cursor size to fit around the cell.
	* src/vtexft.c: (_vte_xft_set_text_font), (_vte_xft_draw_text):
		Fudge the Xft font positioning.

2007-01-26  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 318307 – Cursor colour changes to foreground when unfocused

	Whilst setting the colour, tweak the position of the rectangle, and
	extended the invalidate region to account for the OBO nature of bold
	font.

	* src/vte.c: (_vte_invalidate_cells):
		Include the padding to accomodate cell effects.
	* src/vte.c: (vte_terminal_paint):
		Use the cursor color for the rectangle when unfocused.

2007-01-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_visibility_notify): Correctly handle
	visibility events: set invalidated_all to FALSE, and invalidate_all
	if fully unobscured.

2007-01-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_visibility_notify): Make sure we redraw
	after becoming unobscured.  There still is a bug that I've not found,
	but after obscuring the widget and coming back, a first redraw
	happens, but no update after that.

2007-01-26  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_draw_area):
		Occasionally we generate an exposed area which is computed
		as 0x0 cells. Discard early, before we spend an infinity
		drawing nothing.

2007-01-26  Chris Wilson <chris@chris-wilson.co.uk>

	Janitorial work - near elimination of #ifdef VTE_DEBUG from within
	functions, trimming a thousand lines of code.

	We introduce a _vte_debug_print macro to cover the more common
	occurrence of printing a message at a certain debug level.
	And a _VTE_DEBUG_ON for a conditional code block.

	src/debug.h     |   11 
	src/iso2022.c   |  201 ++-------
	src/keymap.c    |   41 -
	src/matcher.c   |   24 -
	src/pty.c       |  134 +-----
	src/reaper.c    |   21 
	src/ring.c      |   78 +--
	src/table.c     |   11 
	src/trie.c      |   19 
	src/vte.c       | 1187 ++++++++++---------------------------------------
	src/vteaccess.c |  198 +++------
	src/vteapp.c    |   21 
	src/vtebg.c     |   43 --
	src/vteconv.c   |   60 +-
	src/vteconv.h   |   12 
	src/vtedraw.c   |    6 
	src/vtefc.c     |    4 
	src/vteft2.c    |    5 
	src/vteglyph.c  |   27 -
	src/vtepango.c  |   11 
	src/vtepangox.c |    7 
	src/vteregex.c  |    2 
	src/vteseq.c    |  385 +++++-------------
	src/vtexft.c    |   26 -
	24 files changed, 789 insertions(+), 1745 deletions(-)

	* src/debug.h:
	* src/iso2022.c: (_vte_iso2022_ambiguous_width_guess),
	(_vte_iso2022_state_new), (_vte_iso2022_state_set_codeset),
	(process_8_bit_sequence), (process_cdata), (process_control),
	(_vte_iso2022_process):
	* src/keymap.c: (_vte_keymap_map):
	* src/matcher.c: (_vte_matcher_init), (_vte_matcher_create),
	(_vte_matcher_destroy):
	* src/pty.c: (vte_pty_child_setup), (_vte_pty_run_on_pty),
	(_vte_pty_set_size), (_vte_pty_get_size), (_vte_pty_ptsname),
	(_vte_pty_open_unix98), (_vte_pty_open_with_helper),
	(_vte_pty_open):
	* src/reaper.c: (vte_reaper_emit_signal),
	(vte_reaper_child_watch_cb), (vte_reaper_init),
	(vte_reaper_finalize):
	* src/ring.c: (_vte_ring_insert), (_vte_ring_insert_preserve),
	(_vte_ring_remove):
	* src/table.c: (_vte_table_addi):
	* src/trie.c: (char_class_string_extract), (_vte_trie_addx),
	(_vte_trie_add):
	* src/vte.c: (update_regions), (_vte_invalidate_cells),
	(_vte_invalidate_all), (_vte_invalidate_cell),
	(_vte_invalidate_cursor_once),
	(vte_terminal_emit_selection_changed), (vte_terminal_emit_commit),
	(vte_terminal_emit_emulation_changed),
	(vte_terminal_emit_encoding_changed),
	(vte_terminal_emit_child_exited),
	(_vte_terminal_emit_contents_changed),
	(vte_terminal_emit_cursor_moved), (vte_terminal_emit_eof),
	(vte_terminal_emit_char_size_changed),
	(_vte_terminal_emit_status_line_changed),
	(vte_terminal_emit_increase_font_size),
	(vte_terminal_emit_decrease_font_size),
	(_vte_terminal_emit_text_inserted),
	(_vte_terminal_emit_text_deleted),
	(vte_terminal_emit_text_modified),
	(vte_terminal_emit_text_scrolled), (vte_terminal_deselect_all),
	(vte_terminal_match_check_internal), (vte_terminal_match_check),
	(vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_changed),
	(_vte_terminal_adjust_adjustments), (vte_terminal_scroll_pages),
	(vte_terminal_maybe_scroll_to_bottom), (vte_terminal_set_encoding),
	(_vte_terminal_set_pointer_visible), (vte_terminal_new),
	(vte_terminal_generate_bold), (_vte_terminal_insert_char),
	(vte_terminal_handle_sequence), (vte_terminal_catch_child_exited),
	(vte_terminal_fork_command),
	(vte_terminal_emit_pending_text_signals),
	(vte_terminal_process_incoming), (vte_terminal_io_read),
	(vte_terminal_io_write), (vte_terminal_send),
	(vte_terminal_im_commit), (vte_terminal_im_preedit_start),
	(vte_terminal_im_preedit_end), (vte_terminal_im_preedit_changed),
	(vte_terminal_configure_toplevel),
	(vte_terminal_hierarchy_changed), (vte_terminal_style_changed),
	(vte_terminal_key_press), (vte_terminal_paste_cb),
	(vte_terminal_match_hilite_clear), (vte_terminal_match_hilite),
	(vte_terminal_clear_cb), (vte_terminal_copy_cb),
	(vte_terminal_copy), (vte_terminal_paste),
	(vte_terminal_start_selection), (vte_terminal_extend_selection),
	(vte_terminal_autoscroll), (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release),
	(vte_terminal_focus_in), (vte_terminal_focus_out),
	(vte_terminal_set_font_full), (vte_terminal_set_size),
	(vte_terminal_handle_scroll), (vte_terminal_set_emulation),
	(vte_terminal_set_termcap), (vte_terminal_reset_rowdata),
	(vte_terminal_fc_settings_changed), (vte_terminal_init),
	(vte_terminal_size_request), (vte_terminal_size_allocate),
	(vte_terminal_unrealize), (vte_terminal_finalize),
	(vte_terminal_realize), (vte_terminal_draw_cells),
	(_vte_terminal_map_pango_color), (vte_terminal_draw_area),
	(vte_terminal_paint), (vte_terminal_expose), (vte_terminal_scroll),
	(vte_terminal_class_init), (vte_terminal_copy_clipboard),
	(vte_terminal_paste_clipboard), (vte_terminal_copy_primary),
	(vte_terminal_paste_primary), (vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_set_background_saturation),
	(vte_terminal_set_background_tint_color),
	(vte_terminal_set_background_transparent),
	(vte_terminal_set_background_image),
	(vte_terminal_set_background_image_file),
	(vte_terminal_set_word_chars), (process_timeout),
	(update_repeat_timeout), (update_timeout):
	* src/vteaccess.c: (xy_from_offset), (emit_text_caret_moved),
	(emit_text_changed_insert), (emit_text_changed_delete),
	(vte_terminal_accessible_update_private_data_if_needed),
	(vte_terminal_accessible_text_modified),
	(vte_terminal_accessible_text_scrolled),
	(vte_terminal_accessible_invalidate_cursor),
	(vte_terminal_accessible_finalize),
	(vte_terminal_accessible_get_text),
	(vte_terminal_accessible_get_text_somewhere),
	(vte_terminal_accessible_get_run_attributes),
	(vte_terminal_accessible_text_init),
	(vte_terminal_accessible_component_init),
	(vte_terminal_accessible_action_init),
	(vte_terminal_accessible_factory_new):
	* src/vteapp.c: (destroy_and_quit_eof), (destroy_and_quit_exited),
	(take_xconsole_ownership), (main):
	* src/vtebg.c: (vte_bg_root_pixmap), (vte_bg_set_root_pixmap),
	(_vte_bg_resize_pixbuf):
	* src/vteconv.c: (_vte_conv_utf8_utf8), (_vte_conv_open),
	(_vte_conv), (_vte_conv_cu), (_vte_conv_uu), (_vte_conv_uc):
	* src/vteconv.h:
	* src/vtedraw.c: (_vte_draw_new):
	* src/vtefc.c: (_vte_fc_transcribe_from_pango_font_description):
	* src/vteft2.c: (_vte_ft2_draw_text):
	* src/vteglyph.c: (_vte_glyph_cache_free),
	(_vte_glyph_cache_set_font_description):
	* src/vtepango.c: (_vte_pango_set_text_font),
	(_vte_pango_draw_text):
	* src/vtepangox.c: (_vte_pango_x_set_text_font):
	* src/vteregex.c: (_vte_regex_exec):
	* src/vteseq.c: (vte_terminal_emit_deiconify_window),
	(vte_terminal_emit_iconify_window),
	(vte_terminal_emit_icon_title_changed),
	(vte_terminal_emit_window_title_changed),
	(vte_terminal_emit_raise_window), (vte_terminal_emit_lower_window),
	(vte_terminal_emit_maximize_window),
	(vte_terminal_emit_refresh_window),
	(vte_terminal_emit_restore_window),
	(vte_terminal_emit_move_window), (vte_terminal_emit_resize_window),
	(vte_sequence_handler_set_title_internal),
	(vte_sequence_handler_decset_internal), (vte_sequence_handler_bt),
	(vte_sequence_handler_application_keypad),
	(vte_sequence_handler_normal_keypad),
	(vte_sequence_handler_reset_mode), (vte_sequence_handler_decset),
	(vte_sequence_handler_decreset),
	(vte_sequence_handler_erase_in_display),
	(vte_sequence_handler_erase_in_line),
	(vte_sequence_handler_restore_mode),
	(vte_sequence_handler_save_mode),
	(vte_sequence_handler_window_manipulation):
	* src/vtexft.c: (_vte_xft_set_text_font):

2007-01-26  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 317449 – The cursor disappears when clicking on windows above gnome-terminal

	Enter a command that causes partial obscuration of the terminal,
	though it must cover the cursor. Close the new window, observe the
	pointer disappears.

	The issue is that we hide the pointer whilst typing and show it after
	receiving a mouse movement. However in this case we steal the pointer
	away from the terminal without any mouse events and the cursor remains
	invisible.

	* src/vte.c: (vte_terminal_focus_in):
		Ensure the mouse pointer is visible on focus-in.

2007-01-26  Chris Wilson <chris@chris-wilson.co.uk>

	Spend half an hour a day killing warnings...

	* configure.in:
		Remove -Wswitch-enum from MAYBE_WARN. I am that lazy.
	* src/buffer.c:
	* src/iso2022.c: (_vte_iso2022_is_ambiguous),
	(_vte_iso2022_ambiguous_width), (_vte_iso2022_map_get),
	(_vte_iso2022_find_nextctl), (_vte_iso2022_sequence_length),
	(_vte_iso2022_fragment_input), (process_8_bit_sequence),
	(process_cdata), (_vte_iso2022_process_single), (process_control),
	(_vte_iso2022_process):
	* src/keymap.c: (_vte_keymap_map):
	* src/table.c:
	* src/trie.c: (char_class_none_extract),
	(char_class_digit_extract), (char_class_multi_extract),
	(char_class_any_extract), (unichar_snlen), (unichar_sncmp),
	(char_class_string_extract), (_vte_trie_addx), (_vte_trie_add),
	(_vte_trie_matchx), (_vte_trie_match), (_vte_trie_printx),
	(_vte_trie_print), (convert_mbstowcs), (main):
	* src/vte-private.h:
	* src/vte.c: (vte_terminal_find_charcell),
	(_vte_row_data_find_charcell), (vte_terminal_emit_commit),
	(vte_terminal_match_clear_all), (vte_terminal_match_remove),
	(vte_terminal_match_add), (vte_terminal_match_set_cursor),
	(vte_terminal_match_check_internal), (vte_terminal_set_colors),
	(vte_terminal_emit_pending_text_signals),
	(vte_terminal_is_word_char), (vte_terminal_finalize),
	(vte_terminal_realize), (_vte_terminal_map_pango_color),
	(_vte_terminal_apply_pango_attr),
	(_vte_terminal_translate_pango_cells),
	(vte_terminal_set_scrollback_lines):
	* src/vteseq.c: (vte_sequence_handler_decset_internal):
		Fixup compiler warnings, mostly of the type mixing signed and
		unsigned compares and pointers.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (mark_input_source_invalid),
	(_vte_terminal_connect_pty_read), (mark_output_source_invalid),
	(_vte_terminal_connect_pty_write):
		Use the GDestroyNotify to mark the source as invalid.
	* src/vte.c: (vte_terminal_ensure_font):
		Protect ensure fonts against the VteDraw being destroyed.
	* src/vte.c: (vte_terminal_realize):
	 	Reorder code to setup the style before the fonts.
	* src/vte.c: (vte_terminal_class_init):
		The ->show() handler was redundant.

2007-01-25  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_terminal_set_default_attributes),
	(_vte_invalidate_cells), (_vte_invalidate_all),
	(_vte_invalidate_cell), (_vte_invalidate_cursor_once),
	(vte_terminal_visibility_notify), (vte_terminal_handle_scroll):
	Replace most of checks for terminal->pvt->visibility_state ==
	GDK_VISIBILITY_FULLY_OBSCURED by terminal->pvt->invalidated_all, and
	adapt.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400759 – update problem with vte trunk

	Otherwise known as the I can't count bug.

	The number of rows and columns to paint were not properly taking
	account of the discrete nature of the cells ie although the floor(x)
	moved the start to the left by one, the extra cell was not being added
	to the width.

	Also since the howmany() macro is pulled from <sys/param.h>, it can
	not be guarranteed to exist on all platforms. So in that case, provide
	a local copy.

	* src/vte.c: (vte_terminal_draw_area):
		Calculate the width as the distance between the explicity
		calculated start and end cells.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400671 – crash in Terminal: detaching of tabs

	The fontdirty flag needed to be set on unrealize to ensure the fonts
	get set on the VteDraw should the terminal be realized again (e.g
	drag'n'dropping).

	* src/vte.c: (vte_terminal_unrealize):
		Set the fontdirty flag to TRUE.
	* src/vtexft.c: (_vte_xft_set_text_font),
	(_vte_xft_get_char_width), (_vte_xft_draw_text),
	(_vte_xft_draw_char):
		Add safe guards to avoid dereferencing a NULL font as it
		is possible for _vte_xft_font_open() to fail.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 399137 – UTF-8 problem in VteAccess

	Improve the UTF-8 string handling within vteaccess.c
	A long and fraught history to this apparently simple change.
	Many thanks to Joanmarie Diggs and Rich Burridge for testing the
	patches and ensuring they caused no regressions in the ally interface.

	* src/vteaccess.c: (emit_text_changed_insert),
	(emit_text_changed_delete):
		Use g_utf8_pointer_to_offset() rather than open coding.
	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		Convert the caret into a byte offset before performing the
		ASCII character lookup.
		Iterate backwards over the string using a g_utf8_prev_char,
		and g_utf8_get_char.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400493 – Mouse selection seriously broken

	The rendering of non-text attributes, e.g highlight, backgrounds,
	underlines, was broken by the change to multi-row run of glyphs. This
	was most apparent when selecting regions with a mouse.

	* src/vte.c: (_vte_invalidate_cursor_once),
	(vte_terminal_extend_selection),
	(vte_terminal_draw_rows), (vte_terminal_draw_area),
	(vte_terminal_paint):
		Some janitorial work (a memleak, whitespace, improving debug
		messages, comments).
	* src/vte.c: (vte_terminal_draw_cells):
		Loop over cells and draw attributes for groups of cells on
		each row.

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400438 – _vte_invalidate_all triggered on GDK_VISIBILITY_UNOBSCURED

	* src/vte.c: (vte_terminal_visibility_notify):
		Only force an _vte_invalidate_all if we can trivially detect
		that we have switch from fully obscured to fully unobscured.
		Otherwise, we will just handle the GDK expose in the normal
		manner.
	* src/vte.c: (vte_terminal_expose):
		Check the event area to see if we can use _vte_invalidate_all,
		has a slight benefit of discarding further exposed area
		processing.
		

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	GDK tries to coalesce multiple expose events into a single event.
	This is passed to the application as a large region containing
	multiple rectangles. The unfortunate effect of this is having
	broken the invalidated region into 2 small components for vim,
	the expose event was still operating on a single region covering
	both. The reason the effect was invisible to the eye is due to the
	double buffer - GDK generated a backing pixmap for the exposed event
	and only copied from the pixmap to the window exactly the pixels
	exposed. So we regenerated draw commands for the entire area, and
	only saved on the later blit.

	The improvement to this is only issue draw commands for the individual
	rectangles rather than the region as a whole.

	* src/vte.c: (vte_terminal_draw_area), (vte_terminal_paint),
	(vte_terminal_expose):
		Paint the exposed rectangles not the event clipbox!

2007-01-25  Chris Wilson <chris@chris-wilson.co.uk>

	Print out the painted area for VTE_DEBUG_UPDATES.

	* src/vte.c: (vte_terminal_paint):

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	cf Bug 400072 – Handling of ; in control sequences

	Moral of the story: wait until the morning.
	Revert r1512, the mistaken attempt at parsing '\e[;30m'.

	* src/table.c: (_vte_table_addi), (_vte_table_matchi),
	(_vte_table_match):

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	cf Bug 399617 – Avoid memory allocations during an expose event.

	Currently we cannot generate long glyph runs due to the text
	painting being broken up into single rows and setting a low
	max run cap. The benefit of longer runs is the backends can
	do more caching within a run and potentially generate fewer
	render calls and/or less network traffic.

	In the simple test case, this increased the performance of a
	remote hexdump by 10%.

	* src/vte.c: (vte_terminal_draw_rows), (vte_terminal_paint):
		Scan entired exposed area for glyph runs.
	* src/vtedraw.h:
		Increase VTE_DRAW_MAX_LENGTH
	* src/vtexft.c: (_vte_xft_draw_text):
		Create GlyphSpecs rather than CharFontSpecs, saves a 
		conversion and potential malloc inside libXft, and our
		own malloc.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 147495 – screen flicker when opening new terminal windows

	Last in a series of work to reduce extraneous redraws. I no longer
	see the flicker when opening a white terminal.

	* src/vte.c: (_vte_terminal_scroll_region):
		Detect when we can just invalidate all.
	* src/vte.c: (_vte_terminal_fork_basic):
		Don't force an unnecessary redraw.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_set_emulation):
		Add a missing '\n' to the debug printerr.
	* src/vte.c: (vte_terminal_init):
		Initialize the row count to VTE_MIN_SCROLLBACK (was to 0
		first and then later within the same function to
		VTE_MIN_SCROLLBACK).

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 334755 – Incomplete information from vte_terminal_get_font

	In many situations the font_desc stored in the terminal is incomplete.
	_vte_fc_transcribe_from_pango_font_description() automagically fills
	in default values for the backends but this is hidden from the
	application. By filling in default values up front from the widget
	font description control is returned to the application and theme
	designers.

	Patch by Pedro de Medeiros.
	Also cf bug 335269.

	* src/vte.c: (vte_terminal_set_font_full):
		Pull default font description from widget.
	* src/vtefc.c: (_vte_fc_transcribe_from_pango_font_description):
		Remove default values.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400184 – _vte_pty_open declaration mismatch - breaks on Solaris
	actually revealed a faux-pas in the conversion of the public
	interfaces to GPid - that it broke the ABI.

	However, the intention is to remove the exposed pid_t, cf bug 400333.

	* python/vte.defs:
	* python/vte.override:
	* src/pty.c: (_vte_pty_open):
	* src/pty.h:
	* src/vte.c: (_vte_terminal_fork_basic), (vte_terminal_forkpty):
	* src/vte.h:
		Revert the exposed GPids back to pid_t.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	==25123== Invalid read of size 1
	==25123==    at 0x4055992: vte_terminal_accessible_text_modified (vteaccess.c:497)
	==25123==    by 0x46A1248: g_cclosure_marshal_VOID__VOID (gmarshal.c:77)
	==25123==    by 0x4693EAA: g_closure_invoke (gclosure.c:490)
	==25123==    by 0x46A4972: signal_emit_unlocked_R (gsignal.c:2440)
	==25123==    by 0x46A5E96: g_signal_emit_valist (gsignal.c:2199)
	==25123==    by 0x46A85ED: g_signal_emit_by_name (gsignal.c:2267)
	==25123==    by 0x403E9E2: _vte_terminal_emit_text_inserted (vte.c:863)
	==25123==    by 0x40517EF: vte_terminal_process_incoming (vte.c:3032)
	==25123==    by 0x40522B5: update_repeat_timeout (vte.c:11332)

	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		Check that the caret is inside the old string before
		accessing.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	Revert changes in conjunction with bug 399137 back to r1487,
	which contains Rich Burridge's fix for bug 397724.

	* src/vteaccess.c: (emit_text_changed_insert),
	(emit_text_changed_delete),
	(vte_terminal_accessible_text_modified):

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		Valgrind pointed out a couple of places where we tried to
		access before the start of the string.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 400184 – _vte_pty_open declaration mismatch - breaks on Solaris

	Patch by Damien Carbery.

	* src/pty.h:
		Update prototype to match new definition.

2007-01-24  Chris Wilson <chris@chris-wilson.co.uk>

	<mariano> hm, vte is not matching «ESC [ ; 7 m» :/

	* src/table.c: (_vte_table_addi), (_vte_table_matchi),
	(_vte_table_match):
		s/GList/GSList/
		g_slist_append -> g_slist_reverse(g_slist_prepend)
		And finally add the subtable to handle the leading ';'
		in the variable length parameters.

2007-01-23  Chris Wilson <chris@chris-wilson.co.uk>

	A couple of minor buggets.

	* src/iso2022.c: (_vte_iso2022_state_set_codeset):
		Use g_intern_string() instead of from_quark(to_quark(str))
	* src/vtepango.c: (_vte_pango_create), (_vte_pango_destroy),
	(_vte_pango_start), (_vte_pango_end), (_vte_pango_set_text_font):
		Use the widget pango context (we're guarranteed to have a
		screen by this point) and don't unref it!
		Inspired by Pedro de Medeiros in Bug 335269.

2007-01-23  Chris Wilson <chris@chris-wilson.co.uk>

	Regression on Bug 123591:
		mkdir /tmp/aa; cd /tmp/aa; bash; cd ..; rmdir aa
		Open a new tab in g-t -> Failure.	

	* src/pty.c: (_vte_pty_run_on_pty):
		Check the error return from g_spawn and try again with the
		pwd if it reports that the child could not change directory.

2007-01-23  Chris Wilson <chris@chris-wilson.co.uk>

	* src/pty.c: (_vte_pty_run_on_pty):
		Add all g_spawn parameters to VTE_DEBUG_MISC output.

2007-01-22  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.2.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.2.

	* src/Makefile.am: Bumped libtool version to 10:9:1.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 399137 - continuation.

	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		Classic bug:
			clen = cp - old
		rather than the more correct
			clen = cp - current

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vteapp.c: (char_size_changed), (char_size_realized), (main):
		Don't try to perform gdk operations on unrealized windows.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	* src/pty.c: (_vte_pty_run_on_pty):
		Print out the argument vector for VTE_DEBUG_MISC.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	* src/pty.c: (_vte_pty_run_on_pty):
		Protect against g_strv_length(NULL)

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 399137 - continuation.

	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		After walking back along the UTF-8 string, remember to update
		the string lengths that are used to detect insertions and
		deletions!

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	If the caret is at the end of the buffer, then it set past the
	end of the offset array - do not use this as a lookup!

	* src/vteaccess.c: (vte_terminal_accessible_text_modified):
		If the caret points to past the last character, set the
		offset to the string's NUL terminator.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	* configure.in:
		Earlier configure.in update introduced a trailing ']', pair
		it with its '['
		

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 132316 – terminal widget's context menu posting isn't exposed as an AtkAction

	Original patch by <padraig.obriain@sun.com>

	* src/vteaccess.c: (vte_terminal_accessible_free_private_data),
	(vte_terminal_accessible_component_init),
	(vte_terminal_accessible_do_action),
	(vte_terminal_accessible_get_n_actions),
	(vte_terminal_accessible_action_get_description),
	(vte_terminal_accessible_action_get_name),
	(vte_terminal_accessible_action_get_keybinding),
	(vte_terminal_accessible_action_set_description),
	(vte_terminal_accessible_action_init),
	(vte_terminal_accessible_get_type):
		Remove grab_focus and defer to the parent's implementation.
		Add an AtkAction iface.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 156161 – AccessibleText_getTextAtOffset returns wrong values in gnome-terminal

	The code for ATK_TEXT_BOUNDARY_WORD_START and
	ATK_TEXT_BOUNDARY_WORD_END is the same.

	Patch by <padraig.obriain@sun.com>

	* src/vteaccess.c: (vte_terminal_accessible_get_text_somewhere):
		Actually provide an implementation for
		ATK_TEXT_BOUNDARY_WORD_END.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 399137 – UTF-8 problem in VteAccess

	* src/vteaccess.c: (emit_text_changed_insert),
	(emit_text_changed_delete):
		use g_utf8_pointer_to_offset() instead of open coding
	(vte_terminal_accessible_update_private_data_if_needed):
		add the number of UTF-8 characters to the debug output.
	(vte_terminal_accessible_text_modified):
		iterate backwards over the UTF-8 string using
		g_utf8_prev_char() and convert the caret into a byte offset
		before it as such.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 123591 – vte_terminal_fork_command succeeds even when it does not

	* python/vte.defs:
	* python/vte.override:
	* src/reaper.c: (vte_reaper_child_watch_cb):
	* src/vte-private.h:
	* src/vte.c: (vte_terminal_catch_child_exited),
	(_vte_terminal_fork_basic), (vte_terminal_forkpty):
	* src/vte.h:
	* src/vteapp.c:
		s/pid_t/GPid/ portable variant, no API/ABI implications
	* src/pty.c: (vte_pty_child_setup), (_vte_pty_run_on_pty),
	(_vte_pty_fork_on_pty_name), (_vte_pty_fork_on_pty_fd),
	(_vte_pty_open_unix98), (_vte_pty_pipe_open), (n_read), (n_write),
	(_vte_pty_start_helper), (_vte_pty_open_with_helper),
	(_vte_pty_open), (main):
		Replace custom fork() and pipe based syncrohonisation scheme
		with g_spawn_async_with_pipes() as it actually handles all
		failure modes correctly, and gives us overtures of portability.
		

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Hack'n'slash my way through doing a bit of weeding.

	Fixed:
	- Bug 345514 – -no-undefined doesn't work with latest libtool
	- Bug 162003 – vte configure.in X checking can fail
	             – though this may cause other regressions!
	- Bug 314669 – Please specialize AC_PATH_XTRA

	* configure.in:
		Export LIBTOOL_EXPORT_OPTIONS for -no-undefined on windos.
		Add to rather than override X_CFLAGS, X_LIBS
		AC_PATH_XTRA - Find X11 using XFlush() rather than XtMalloc().
		Print configuration details.
	* src/Makefile.am:
		Conditional compilation of backends.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 389538 – crash in Terminal: nothing

	* src/vteaccess.c: (vte_terminal_accessible_get_text):
		Guard against negative length strings.

2007-01-22  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 161479 – Scroll wheel generates Release events

	 vte sends release events on scroll but xterm doesn't which breaks
	 mc among others.

	 Patch by Benedikt Meurer.

	* src/vte.c: (vte_terminal_scroll):
		Remove the offending release event.

2007-01-20  Chris Wilson <chris@chris-wilson.co.uk>

	<kmaraas> ickle: sparse complains about dubious 1 bit bitfields
		if you use gboolean instead of guint
	<kmaraas> so s/gboolean/guint at line 166 and 174
	<mariano> unless that changes the API, of course...
	<kmaraas> it doesn't
	<mariano> gboolean a:1 is not very correct anyways
	<kmaraas> ickle: we've done the same change in other modules
	<ickle> if I do it quick, behdad might not even notice ;)

	* src/vte.h:
		Convert signed single bit field to unsigned. The code
		was setting it to 1 anyhow (and not -1 as the type indicated).

2007-01-20  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398602 – Build Failure

	* src/vte.c: (vte_terminal_expose):
		Fixup typo. [Grrr. Must get git-svn back into sync]

2006-11-19 Rich Burridge <rich.burridge@sun.com>

        * src/vteaccess.c:
        Fixed bug #397724 - Orca incorrect echo's certain input in 
        gnome-terminal when key echo is set to off (on Ubuntu Feisty).

2007-01-20  Chris Wilson <chris@chris-wilson.co.uk>
	
	* src/vte.c: (vte_terminal_expose):
		Also if the entire terminal is invalidated,
		do not add more GTK+ exposes to it.

2007-01-20  Chris Wilson <chris@chris-wilson.co.uk>

	Track when we have invalidated the entire terminal and skip adding
	new regions when possible.

	* src/vte-private.h:
	* src/vte.c: (update_regions), (_vte_invalidate_cells),
	(_vte_invalidate_all), (vte_terminal_size_allocate),
	(reset_update_regions):

2007-01-20  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398244 – Gnome-terminal opens a huge sized window

	* src/vte.c: (vte_terminal_ensure_font),
	(vte_terminal_set_font_full), (vte_terminal_size_request),
	(vte_terminal_realize), (vte_terminal_get_char_width),
	(vte_terminal_get_char_height), (vte_terminal_get_char_descent),
	(vte_terminal_get_char_ascent):
		Ensure the font metrics are calculated before use.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_process_incoming):
		Do not invalidate the old cursor position if it was not
		visible.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (process_timeout):
		Make sure ->process_timeout is set to VTE_INVALID_SOURCE on
		all paths that remove the timeout.

2007-01-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Add <> to mark boundaries of process_timeout().

	* src/vte.c: (vte_terminal_class_init), (process_timeout):

2007-01-19  Chris Wilson  <chris@chris-wilson.co.uk>

	Add {},[] to mark boundaries of update_timeout() and notice that
	the display limited update_timeout was not dying.

	* src/vte.c: (vte_terminal_class_init), (update_repeat_timeout),
	(update_timeout):

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_realize), (remove_process_timeout):
		Small cleanup:
		 - protect remove_process_timeout against an invalid source.
		 - move static prototypes into common block.
		 - gdk_window_show() is done in map not realize.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_process_incoming):
		Introduce a bit of slack in the bbox check to allow
		for a small of amount of cursor motion e.g. due to line
		scrolling. This turns the long sequence of
		'(?!?!??? ... ????!)'
		during a hexdump into the better behaved 
		'.(?!?!?!??!)-+=.(?!?!??!)-+=........'. Although it is
		puzzling why we now how have a block of IO and then two quick
		display upates...

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (process_timeout), (update_repeat_timeout),
	(update_timeout):
		Repeat _vte_terminal_process_incoming until we have drained
		the incoming buffers or we can handle no more. Fixes a
		problem where the display wouldn't update if we hadn't
		processed enough data (e.g. on startup, displaying the first
		prompt). This bug corresponds with the sequence
		'*-+=..()?!(?!?!?!)-+=' below, which now reads
		'*-+=..()(?!?!?!)-+='

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_invalidate_cursor_once):
		"%ld" for cursor indices.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_invalidate_cells),
	(_vte_invalidate_cursor_once):
		Cursor indices are long.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte-private.h:
	* src/vte.c: (_vte_invalidate_cell):
		Cursor indices are long.
	* src/vte.c: (_vte_terminal_expose):
		Prepend the GTK+ generated expose if we already have an
		display update pending.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	Add a new debug flag to visualize the work flow.
	VTE_DEBUG_FLAGS=work generates output like:
	Debugging work flow (top input to bottom output):
	  .  _vte_terminal_process_incoming
	  (  start _vte_terminal_process_incoming
	  ?  _vte_invalidate_cells (call)
	  !  _vte_invalidate_cells (dirty)
	  *  _vte_invalidate_all
	  )  end _vte_terminal_process_incoming
	  -  gdk_window_process_all_updates
	  +  vte_terminal_expose
	  =  vte_terminal_paint
	*?!**+=*-+=..()?!(?!?!?!)-+=?!-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.().(?!?!?!)-+=.().(?!?!?!)-+=.().().(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!?!)-+=.(?!?!)-+=.............................................................................................................................................................................................................................................................................(?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?!?????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????!??!)-+=.......................................................................

	Which tells me I have two bugs to track:
		1. the initial '..()' is a missing invalidate.
		2. '(?!?!????????????????????!??!)' is not very efficient.

	* src/debug.c: (_vte_debug_parse_string):
	* src/debug.h:
	* src/vte.c: (update_regions), (_vte_invalidate_cells),
	(_vte_invalidate_all), (vte_terminal_process_incoming),
	(vte_terminal_io_read), (vte_terminal_paint),
	(vte_terminal_expose), (vte_terminal_class_init):
		Add VTE_DEBUG_WORK

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398150 – cursor leaves trail behind in vim

	* src/vte-private.h:
	* src/vte.c: (_vte_invalidate_cell),
	(vte_terminal_process_incoming):
	* src/vteseq.c: (vte_sequence_handler_decset_internal):
		Invalidate the old cursor position if we detect the cursor
		moved during the sequence or if the cursor changed state.

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	* src/Makefile.am:
		Missing $(X_CFLAGS)

2007-01-19  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398243 – Crash

	* src/vtebg.c: (vte_bg_cache_prune_int):
		Use the return from g_list_delete_link to maintain the list
		head.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (_vte_invalidate_cells):
		Check that the start of the invalid region is on screen.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398116 – lags behind when widget not visible

	* src/vte.c: (vte_terminal_handle_scroll):
		During the spring clean, I converted a few GTK_WIDGET_REALIZED()
		checks to GTK_WIDGET_DRAWABLE()+visibility check.
		Unfortunately, it broke keeping the scroll delta in sync with
		the insert delta. Sync the pair, then perform the check before
		making updates on the visible area.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	Bug 398083 – background not painted correctly when starting up

	* src/vte.c: (_vte_invalidate_all):
		Compute drawable area in window co-ordinates and not widget
		co-ordinates.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_expose):
		Small bit of logic inversion that would have tried to paint
		on unmapped and invisible widgets.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>
	And the corresponding overrides. [The downsides of losing track of
	which machine you are working on.]

	* python/vte.override:
		Add (get_text_include_trailing_spaces)

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	Add missing export of vte_terminal_get_text_include_trailing_spaces,
	needed for building a simple testcase for Bug 397724.
	vte.defs needs a bit of love...

	* python/vte.defs:
		Add (get_text_include_trailing_spaces)

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vterdb.c: (_vte_rdb_search), (_vte_rdb_boolean):
		Fix a couple of compiler warnings.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	* src/vte.c: (vte_terminal_process_incoming):
		Delete some dead code.

2007-01-18  Chris Wilson <chris@chris-wilson.co.uk>

	* configure.in:
		Restore --enable-debugging. 

2007-01-18  Chris Wilson  <chris@chris-wilson.co.uk>

	Copy Behdad's MAYBE_WARN comprehensive set of warnings from Cairo,
	and fixup the immediate compilation failures.

	* configure.in:
		Iterate over a list of warnings and check that they are valid
		for the compiler.
		
	* src/debug.c: (_vte_debug_on):
		Kill fflush() [redundant with g_printerr].

2007-01-18  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in: Don't call AC_CANONICAL_HOST.  Libtool calls it
	already.

	* src/Makefile.am: Don't build extra, test, programs by default.
	Speeds build up.

2007-01-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/ring.c (_vte_ring_insert_preserve):
	* src/vte.c (vte_terminal_paint):
	Fix loop-optimization warnings.

2007-01-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/ssfe.c (cleanupexit), (barf):
	* src/vtebg.c (vte_bg_cache_prune_int):
	* src/vtetc.c (main):
	Fix more warnings.

2007-01-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/table.c (main):
	* src/trie.c (_vte_trie_addx), (main):
	* src/utf8echo.c (main):
	Fix int vs long int mismatches in printf args.

2007-01-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/iso2022.c (_vte_iso2022_find_nextctl):
	* src/reaper.c (vte_reaper_finalize):
	* src/vte.c (_vte_terminal_insert_char), (vte_terminal_key_press),
	(vte_terminal_init), (vte_terminal_size_allocate):
	* src/vteapp.c (main):
	* src/vtedraw.c (_vte_draw_init_default):
	* src/vteglyph.c (_vte_glyph_cache_free):
	* src/vtergb.c (_vte_rgb_copy):
	* src/vtexft.c (_vte_xft_font_for_char):
	Remove unused variables.

2007-01-18  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 161342 revisited. Reset the box to +-inf and not the current
	cursor otherwise you just reproduce the slow behaviour (an overly
	large invalidation area).

	* src/vte.c: (vte_terminal_process_incoming):
		Reset bbox to +-inf.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	Second breakage: VTE_INVALID_SOURCE !=0 and calling
	vte_terminal_set_scrollback_lines with lines == ->scrollback_lines
	is not a nop.

	* src/vte.c: (vte_terminal_background_update),
	(vte_terminal_queue_background_update):
		VTE_INVALID_SOURCE != 0
	(vte_terminal_set_scrollback_lines):
		reset the rowdata everytime.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 397414 - port vteapp to GOption

	* src/vteapp.c: (main):
		Translation of getopt switch to GOptionEntry[].
		Missing help for --geometry.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	First breakage spotted: the realized flag is set too late in
	the realize handler. Note to self: not everybody uses a black
	background.

	* src/vte.c: (vte_terminal_realize):
		Restore GTK_WIDGET_SET_FLAGS(REALIZED)

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	Bug 395373 - Allow the user to specify backend priorities.

	* src/vtedraw.c: (_vte_draw_init_user), (_vte_draw_init_default),
	(_vte_draw_new):
		Scan $ENV{VTE_BACKEND} for the user's preferred backend
		and failover to the first working backend.
		Discard checking VTE_USE_*

	* src/vtedraw.h:
	* src/vteft2.c:
	* src/vteft2.h:
	* src/vtegl.c:
	* src/vtegl.h:
	* src/vtepango.c:
	* src/vtepango.h:
	* src/vtepangox.c:
	* src/vtepangox.h:
	* src/vteskel.c: (_vte_skel_check), (_vte_skel_create),
	(_vte_skel_destroy), (_vte_skel_start):
	* src/vteskel.h:
	* src/vtexft.c:
	* src/vtexft.h:
		Remove the environment variable field, drop the "Vte" prefix
		from the backend names and make the exported structure const.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/iso2022.c: (_vte_iso2022_is_ambiguous):
	* src/vte-private.h:
	* src/vte.c: (_vte_terminal_set_default_attributes),
	(vte_terminal_set_default_tabstops), (vte_terminal_set_encoding),
	(vte_terminal_set_opacity), (vte_terminal_set_default_colors),
	(vte_terminal_emit_pending_text_signals),
	(vte_terminal_feed_child_using_modes),
	(vte_terminal_hierarchy_changed),
	(vte_terminal_send_mouse_button_internal),
	(vte_terminal_maybe_send_mouse_drag), (vte_terminal_set_font),
	(vte_terminal_set_font_from_string), (vte_terminal_set_size),
	(vte_terminal_handle_scroll), (vte_terminal_set_scroll_adjustment),
	(vte_terminal_set_emulation), (vte_terminal_set_termcap),
	(vte_terminal_init), (vte_terminal_size_allocate),
	(vte_terminal_unrealize), (vte_terminal_finalize),
	(vte_terminal_realize), (vte_terminal_determine_colors),
	(vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_set_background_transparent),
	(vte_terminal_set_cursor_blinks),
	(vte_terminal_set_scrollback_lines), (vte_terminal_reset),
	(vte_terminal_set_pty):
	* src/vteseq.c: (vte_sequence_handler_st),
	(vte_sequence_handler_vb),
	(vte_sequence_handler_device_status_report),
	(vte_sequence_handler_dec_device_status_report),
	(vte_sequence_handler_window_manipulation):
		Janitorial work to improve code readability and small
		micro-optimisations, such as use the length returned by
		g_snprintf rather then calling strlen on the result or just
		using a constant string.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/ring.h:
		Make the debug checks conditional on VTE_DEBUG.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/matcher.c: (_vte_matcher_add), (_vte_matcher_create),
	(_vte_matcher_destroy), (_vte_matcher_new), (_vte_matcher_match),
	(_vte_matcher_print):
	* src/matcher.h:
	* src/table.c: (_vte_table_new):
	* src/table.h:
	* src/trie.c: (_vte_trie_new):
	* src/trie.h:
		_vte_match_match() is called extremely frequently, and the
		switch shows up on the profiles. Replace the switch with a
		function pointer obtained by introducing function tables for
		the matcher implementations.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vte-private.h:
	* src/vte.c: (vte_terminal_set_font_full), (vte_terminal_realize):
		Don't load a font until the terminal is realized.
		Saves decoding 2 or 3 fonts before g-t is mapped.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vteseq.c: (vte_g_array_fill):
		Micro-optimise the loop.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vteft2.c: (_vte_ft2_create), (_vte_ft2_start),
	(_vte_ft2_end), (update_bbox), (_vte_ft2_set_text_font),
	(_vte_ft2_draw_text):
	* src/vtergb.c: (_vte_rgb_buffer_new), (_vte_rgb_buffer_resize),
	(_vte_rgb_draw_color_rgb), (_vte_rgb_copy):
	* src/vtergb.h:
		Reuse converted glyphs within a run.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vteconv.c: (_vte_conv_utf8_strlen), (_vte_conv):
		Micro-optimise the loops.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vteglyph.c: (_vte_glyph_free), (_vte_cached_glyph_free),
	(_vte_glyph_cache_new), (_vte_glyph_cache_free),
	(_vte_glyph_cache_set_font_description),
	(_vte_glyph_cache_has_char), (_vte_glyph_remap_char),
	(_vte_glyph_get_uncached), (_vte_glyph_get), (_vte_glyph_draw):
	* src/vteglyph.h:
		Avoid the double glyph lookup in _vte_glyph_get and
		replace the tree with a hash.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/iso2022.c: (_vte_iso2022_state_new),
	(_vte_iso2022_state_free), (_vte_iso2022_state_set_codeset):
	* src/trie.c: (_vte_trie_add), (convert_mbstowcs):
	* src/utf8echo.c: (main):
	* src/vte.c: (vte_terminal_set_encoding), (vte_terminal_send),
	(vte_terminal_init), (vte_terminal_finalize),
	(vte_terminal_set_word_chars):
	* src/vteconv.c: (_vte_conv_open), (_vte_conv_close), (_vte_conv):
	* src/vteconv.h:
	* src/vteseq.c: (vte_sequence_handler_set_title_internal):
		s/(VteConv)-1/VTE_INVALID_CONV/

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vte.c: (_vte_new_row_data), (_vte_new_row_data_sized),
	(_vte_terminal_find_row_data), (_vte_row_data_find_charcell),
	(vte_line_is_wrappable), (vte_terminal_extend_selection),
	(vte_terminal_draw_row):
		Refactor vte_find_row_data to simplify and improve
		some logic.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vte.c: (vte_g_array_fill), (vte_terminal_emit_commit),
	(_vte_terminal_ensure_cursor), (_vte_terminal_insert_char),
	(_vte_terminal_fork_basic), (vte_terminal_process_incoming),
	(vte_terminal_key_press), (vte_terminal_visibility_notify),
	(vte_terminal_apply_metrics), (vte_terminal_paint),
	(vte_terminal_expose):
		Callgrind driven rewrite of critical loops.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vte-private.h:
	* src/vte.c: (_vte_terminal_connect_pty_write),
	(_vte_terminal_disconnect_pty_write), (vte_terminal_io_read),
	(vte_terminal_feed), (vte_terminal_feed_child_binary),
	(vte_terminal_init), (vte_terminal_unrealize),
	(add_process_timeout), (add_update_timeout),
	(remove_process_timeout), (vte_terminal_stop_processing),
	(vte_terminal_is_processing), (vte_terminal_start_processing),
	(process_timeout), (update_repeat_timeout), (update_timeout):
		The rate-limiting step is the display update - we do not need
		to process input faster than we are displaying it. So use the
		update display timeout to process new input (and dirty some
		more pixels).


2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/interpret.c: (main):
	* src/iso2022.c: (_vte_iso2022_fragment_input),
	(_vte_iso2022_process), (main):
	* src/vte.c: (vte_terminal_match_contents_refresh),
	(vte_terminal_process_incoming), (vte_terminal_init),
	(vte_terminal_set_word_chars):
	* src/vteaccess.c:
	(vte_terminal_accessible_update_private_data_if_needed):
	* src/vtefc.c: (_vte_fc_patterns_from_pango_font_desc):
	* src/vtefc.h:
	* src/vteglyph.c: (_vte_glyph_cache_new), (_vte_glyph_cache_free),
	(_vte_glyph_cache_set_font_description):
	* src/vteglyph.h:
	* src/vteregex.c: (_vte_regex_sort_matches):
	* src/vtexft.c: (_vte_xft_font_open), (_vte_xft_font_close),
	(_vte_xft_font_for_char):
		s/g_array_new(TRUE, TRUE/g_array_new(FALSE, FALSE/
		All uses of GArray respect their lengths and do not
		zero-termination or untouched members to be cleared.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/iso2022.c: (_vte_iso2022_state_free):
	* src/matcher.c: (_vte_matcher_free_params_array):
	* src/ring.c: (_vte_ring_free):
	* src/table.c: (_vte_table_free):
	* src/trie.c: (_vte_trie_match):
	* src/vte.c: (_vte_terminal_match_contents_clear),
	(_vte_terminal_fork_basic),
	(vte_terminal_get_text_range_maybe_wrapped), (vte_terminal_copy),
	(vte_terminal_finalize), (vte_terminal_draw_cells_with_attributes):
	* src/vteaccess.c: (vte_terminal_accessible_free_private_data):
	* src/vtebg.c: (vte_bg_root_pixmap), (vte_bg_cache_item_free):
	* src/vteconv.c: (_vte_conv_close):
	* src/vtedraw.c: (_vte_draw_free):
	* src/vteft2.c: (_vte_ft2_destroy):
	* src/vtegl.c: (_vte_gl_destroy):
	* src/vteglyph.c: (_vte_glyph_cache_free):
	* src/vtepango.c: (_vte_pango_destroy):
	* src/vtepangox.c: (_vte_pango_x_destroy):
	* src/vtergb.c: (_vte_rgb_buffer_new), (_vte_rgb_buffer_free):
	* src/vteseq.c: (vte_sequence_handler_se),
	(vte_sequence_handler_so):
	* src/vteskel.c: (_vte_skel_destroy):
	* src/vtexft.c: (_vte_xft_font_close), (_vte_xft_destroy):
		Do not zero memory in destructors, as glib will zero all
		freed memory if G_DEBUG=gc-friendly.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/reaper.c: (vte_reaper_add_child), (vte_reaper_init),
	(vte_reaper_constructor), (vte_reaper_finalize),
	(vte_reaper_class_init), (vte_reaper_get), (main):
	* src/vte.c: (G_DEFINE_TYPE_WITH_CODE), (_vte_terminal_fork_basic),
	(vte_terminal_key_press), (vte_terminal_init), (vte_terminal_show),
	(vte_terminal_finalize), (vte_terminal_get_accessible),
	(vte_terminal_class_init):
	* src/vteaccess.c: (vte_terminal_initialize),
	(vte_terminal_accessible_finalize),
	(vte_terminal_accessible_class_init),
	(vte_terminal_accessible_get_type),
	(vte_terminal_accessible_factory_init),
	(vte_terminal_accessible_factory_new):
	* src/vtebg.c: (vte_bg_native_new), (vte_bg_finalize),
	(vte_bg_class_init), (vte_bg_init), (vte_bg_get_for_screen),
	(vte_bg_cache_item_free), (vte_bg_cache_prune_int),
	(_vte_bg_resize_pixbuf), (vte_bg_set_root_pixmap),
	(vte_bg_cache_add), (vte_bg_cache_search), (vte_bg_get_pixmap),
	(vte_bg_get_pixbuf):
		Use GObject boiler-plate code (G_DEFINE_TYPE),
		as opposed to open coding.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/vte-private.h:
	* src/vte.c: (vte_free_row_data), (vte_g_array_fill),
	(vte_terminal_find_charcell), (vte_terminal_preedit_width),
	(vte_terminal_preedit_length), (_vte_invalidate_cursor_once),
	(vte_invalidate_cursor_periodic), (vte_terminal_deselect_all),
	(vte_terminal_set_default_tabstops),
	(vte_terminal_match_contents_refresh), (vte_terminal_cursor_new),
	(vte_terminal_match_check_internal),
	(vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_changed),
	(vte_terminal_scroll_pages), (vte_terminal_maybe_scroll_to_top),
	(vte_terminal_maybe_scroll_to_bottom),
	(_vte_terminal_set_pointer_visible), (vte_terminal_new),
	(vte_terminal_set_color_internal), (vte_terminal_set_color_bold),
	(vte_terminal_set_color_dim), (vte_terminal_set_color_foreground),
	(vte_terminal_set_color_background),
	(vte_terminal_set_color_cursor),
	(vte_terminal_set_color_highlight), (vte_terminal_handle_sequence),
	(vte_terminal_catch_child_exited),
	(_vte_terminal_connect_pty_read),
	(_vte_terminal_connect_pty_write), (_vte_terminal_fork_basic),
	(vte_terminal_eof), (vte_terminal_im_reset),
	(vte_terminal_process_incoming), (vte_terminal_io_read),
	(vte_terminal_io_write), (vte_terminal_send),
	(vte_terminal_im_commit), (vte_terminal_im_preedit_start),
	(vte_terminal_im_preedit_end), (vte_terminal_im_preedit_changed),
	(vte_terminal_configure_toplevel),
	(vte_terminal_hierarchy_changed), (vte_terminal_style_changed),
	(add_cursor_timeout), (vte_terminal_key_press), (vte_same_class),
	(vte_line_is_wrappable), (vte_terminal_paste_cb),
	(vte_terminal_send_mouse_button_internal),
	(vte_terminal_maybe_send_mouse_drag), (vte_terminal_clear_cb),
	(vte_terminal_copy_cb),
	(vte_terminal_get_text_range_maybe_wrapped),
	(vte_terminal_clipboard_get), (vte_terminal_copy),
	(vte_terminal_paste), (vte_terminal_autoscroll),
	(vte_terminal_start_autoscroll), (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release),
	(vte_terminal_focus_in), (vte_terminal_focus_out),
	(vte_terminal_visibility_notify), (vte_terminal_apply_metrics),
	(vte_terminal_set_font_full), (vte_terminal_refresh_size),
	(vte_terminal_handle_scroll), (vte_terminal_set_scroll_adjustment),
	(vte_terminal_connect_xft_settings),
	(vte_terminal_disconnect_xft_settings),
	(_vte_terminal_codeset_changed_cb), (vte_terminal_init),
	(vte_terminal_size_request), (vte_terminal_size_allocate),
	(vte_terminal_show), (root_pixmap_changed_cb),
	(vte_terminal_unrealize), (vte_terminal_finalize),
	(vte_terminal_realize), (vte_terminal_determine_colors),
	(vte_terminal_paint), (vte_terminal_expose), (vte_terminal_scroll),
	(vte_terminal_get_accessible), (vte_terminal_im_append_menuitems),
	(vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_set_background_image),
	(vte_terminal_set_background_image_file),
	(vte_terminal_set_cursor_blinks), (vte_terminal_reset),
	(vte_terminal_set_pty):
	* src/vteaccess.c: (vte_terminal_initialize),
	(vte_terminal_accessible_finalize):
	* src/vtedraw.c: (_vte_draw_new), (_vte_draw_free),
	(_vte_draw_start), (_vte_draw_end):
	* src/vtefc.c: (_vte_fc_transcribe_from_pango_font_description),
	(_vte_fc_defaults_from_gtk), (_vte_fc_connect_settings_changes),
	(_vte_fc_disconnect_settings_changes):
	* src/vteft2.c: (_vte_ft2_destroy),
	(_vte_ft2_set_background_image), (_vte_ft2_clear):
	* src/vtegl.c: (_vte_gl_destroy), (_vte_gl_set_background_image),
	(_vte_gl_clear):
	* src/vtepango.c: (_vte_pango_destroy), (_vte_pango_start),
	(_vte_pango_end), (_vte_pango_set_background_image),
	(_vte_pango_set_text_font):
	* src/vtepangox.c: (_vte_pango_x_destroy), (_vte_pango_x_start),
	(_vte_pango_x_end), (_vte_pango_x_set_background_image),
	(_vte_pango_x_set_text_font):
	* src/vterdb.c: (_vte_rdb_get):
	* src/vteseq.c: (vte_sequence_handler_scroll_up_or_down),
	(vte_sequence_handler_set_title_internal), (vte_terminal_beep),
	(vte_sequence_handler_do), (vte_sequence_handler_sf),
	(vte_sequence_handler_sr), (vte_sequence_handler_vb),
	(vte_sequence_handler_window_manipulation):
	* src/vteskel.c: (_vte_skel_destroy):
	* src/vtetree.c: (_vte_tree_new), (_vte_tree_destroy):
	* src/vtexft.c: (_vte_xft_set_background_image), (_vte_xft_clear):
		Remove superfluous checks and run-time checked type casts.

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	As part of Bug 397439.

	* src/debug.c:
	* src/iso2022.c: (_vte_iso2022_ambiguous_width_guess),
	(_vte_iso2022_state_new), (_vte_iso2022_state_set_codeset),
	(process_8_bit_sequence), (process_cdata), (process_control),
	(_vte_iso2022_process):
	* src/keymap.c: (_vte_keymap_map):
	* src/matcher.c: (_vte_matcher_init), (_vte_matcher_create),
	(_vte_matcher_destroy):
	* src/pty.c: (_vte_pty_run_on_pty), (_vte_pty_fork_on_pty_name),
	(_vte_pty_fork_on_pty_fd), (_vte_pty_set_size),
	(_vte_pty_get_size), (_vte_pty_ptsname), (_vte_pty_open_unix98),
	(_vte_pty_open_with_helper), (_vte_pty_open), (main):
	* src/reaper.c: (vte_reaper_emit_signal),
	(vte_reaper_child_watch_cb), (vte_reaper_init),
	(vte_reaper_finalize):
	* src/reflect.c: (text_changed_insert), (text_changed_delete):
	* src/ring.c: (_vte_ring_insert), (_vte_ring_insert_preserve),
	(_vte_ring_remove), (scrolled_off), (main):
	* src/slowcat.c: (main):
	* src/table.c: (_vte_table_printi), (_vte_table_print):
	* src/trie.c: (char_class_string_extract):
	* src/vte.c: (_vte_invalidate_cursor_once),
	(vte_terminal_emit_selection_changed), (vte_terminal_emit_commit),
	(vte_terminal_emit_emulation_changed),
	(vte_terminal_emit_encoding_changed),
	(vte_terminal_emit_child_exited),
	(_vte_terminal_emit_contents_changed),
	(vte_terminal_emit_cursor_moved), (vte_terminal_emit_eof),
	(vte_terminal_emit_char_size_changed),
	(_vte_terminal_emit_status_line_changed),
	(vte_terminal_emit_increase_font_size),
	(vte_terminal_emit_decrease_font_size),
	(_vte_terminal_emit_text_inserted),
	(_vte_terminal_emit_text_deleted),
	(vte_terminal_emit_text_modified),
	(vte_terminal_emit_text_scrolled), (vte_terminal_deselect_all),
	(vte_terminal_match_check_internal), (vte_terminal_match_check),
	(vte_terminal_emit_adjustment_changed),
	(vte_terminal_queue_adjustment_changed),
	(_vte_terminal_adjust_adjustments), (vte_terminal_scroll_pages),
	(vte_terminal_maybe_scroll_to_bottom), (vte_terminal_set_encoding),
	(_vte_terminal_set_pointer_visible), (vte_terminal_new),
	(vte_terminal_generate_bold), (_vte_terminal_insert_char),
	(display_control_sequence), (vte_terminal_fork_command),
	(vte_terminal_emit_pending_text_signals),
	(vte_terminal_process_incoming), (vte_terminal_io_write),
	(vte_terminal_send), (vte_terminal_im_commit),
	(vte_terminal_im_preedit_start), (vte_terminal_im_preedit_end),
	(vte_terminal_im_preedit_changed),
	(vte_terminal_configure_toplevel),
	(vte_terminal_hierarchy_changed), (vte_terminal_style_changed),
	(vte_terminal_key_press), (vte_terminal_paste_cb),
	(vte_terminal_match_hilite_clear), (vte_terminal_match_hilite),
	(vte_terminal_clear_cb), (vte_terminal_copy_cb),
	(vte_terminal_copy), (vte_terminal_paste),
	(vte_terminal_start_selection), (vte_terminal_extend_selection),
	(vte_terminal_autoscroll), (vte_terminal_motion_notify),
	(vte_terminal_button_press), (vte_terminal_button_release),
	(vte_terminal_focus_in), (vte_terminal_focus_out),
	(vte_terminal_set_font_full), (vte_terminal_set_size),
	(vte_terminal_handle_scroll), (vte_terminal_set_emulation),
	(vte_terminal_set_termcap), (vte_terminal_reset_rowdata),
	(vte_terminal_fc_settings_changed), (vte_terminal_init),
	(vte_terminal_size_request), (vte_terminal_size_allocate),
	(vte_terminal_show), (vte_terminal_unrealize),
	(vte_terminal_finalize), (vte_terminal_realize),
	(vte_terminal_draw_cells), (_vte_terminal_map_pango_color),
	(vte_terminal_paint), (vte_terminal_scroll),
	(vte_terminal_class_init), (vte_terminal_get_type),
	(vte_terminal_copy_clipboard), (vte_terminal_paste_clipboard),
	(vte_terminal_copy_primary), (vte_terminal_paste_primary),
	(vte_terminal_background_update),
	(vte_terminal_queue_background_update),
	(vte_terminal_set_background_saturation),
	(vte_terminal_set_background_tint_color),
	(vte_terminal_set_background_transparent),
	(vte_terminal_set_background_image),
	(vte_terminal_set_background_image_file),
	(vte_terminal_set_word_chars):
	* src/vteaccess.c: (emit_text_caret_moved),
	(emit_text_changed_insert), (emit_text_changed_delete),
	(vte_terminal_accessible_update_private_data_if_needed),
	(vte_terminal_accessible_invalidate_cursor),
	(vte_terminal_accessible_finalize),
	(vte_terminal_accessible_get_text),
	(vte_terminal_accessible_get_text_somewhere),
	(vte_terminal_accessible_text_init),
	(vte_terminal_accessible_component_init),
	(vte_terminal_accessible_factory_new):
	* src/vteapp.c: (main):
	* src/vtebg.c: (vte_bg_root_pixmap), (_vte_bg_resize_pixbuf):
	* src/vtedraw.c: (_vte_draw_new):
	* src/vtepango.c: (_vte_pango_set_text_font):
	* src/vtepangox.c: (_vte_pango_x_set_text_font):
	* src/vteseq.c: (vte_terminal_emit_deiconify_window),
	(vte_terminal_emit_iconify_window),
	(vte_terminal_emit_icon_title_changed),
	(vte_terminal_emit_window_title_changed),
	(vte_terminal_emit_raise_window), (vte_terminal_emit_lower_window),
	(vte_terminal_emit_maximize_window),
	(vte_terminal_emit_refresh_window),
	(vte_terminal_emit_restore_window),
	(vte_terminal_emit_move_window), (vte_terminal_emit_resize_window),
	(vte_sequence_handler_set_title_internal),
	(vte_sequence_handler_decset_internal), (vte_sequence_handler_bt),
	(vte_sequence_handler_application_keypad),
	(vte_sequence_handler_normal_keypad),
	(vte_sequence_handler_window_manipulation):
	* src/vtetc.c: (main):
	* src/vtexft.c: (_vte_xft_set_text_font):
		s/fprintf(stderr,/g_printerr(/

2007-01-17  Chris Wilson  <chris@chris-wilson.co.uk>

	Only invalidate groups of inserted chars and not the whole bbox.
	This speeds up applications like vim which maintain a status line
	at the bottom of the screen. Fixes bug 161342.

	* src/vte-private.h:
	* src/vte.c: (update_regions), (_vte_invalidate_cells),
	(_vte_invalidate_all), (_vte_terminal_scroll_region),
	(vte_terminal_process_incoming), (reset_update_regions),
	(remove_update_timeout), (update_repeat_timeout), (update_timeout):

2007-01-15  Behdad Esfahbod  <behdad@gnome.org>

	Bug 387171 – vte fails to install on FreeBSD due to missing header
	Patch from Roy Marples

	* src/vteseq.c: #include <limits.h>

2007-01-15  Behdad Esfahbod  <behdad@gnome.org>

	Bug 396831 – Unable to compile without X
	Patch from Chris Wilson

	* src/vtebg.c (_vte_bg_display_sync), (vte_bg_root_pixmap): Add stubs.

2007-01-09  Ryan Lortie  <desrt@desrt.ca>

	Bug 394890 – Segfault when running vte or gnome-terminal

	* src/vtetc.c (_vte_termcap_find_string): change 'int' to 'gssize' to
	match previous fixup.  Hopefully that does it. :)

2007-01-08  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.1.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.1.

	* src/Makefile.am: Bumped libtool version to 10:8:1.

2006-12-29  Ryan Lortie  <desrt@desrt.ca>

	Small fix to the previous patch.

	* src/vtetc.c (_vte_termcap_find_string_length): 'int' is not the same
	as 'gssize' on 64bit platforms, causing compile errors.

2006-12-27  Ryan Lortie  <desrt@desrt.ca>

	Bug 354061 – Excessive use of strlen by _vte_termcap_create

	* src/vtetc.c: near-complete rewrite to use a GMappedFile rather than
	reading a line at a time with excessive strlen/realloc use.

	* str/matcher.c: this shouldn't be calling the strip code as the
	strings it has are already unescaped.

2006-12-27  Ryan Lortie  <desrt@desrt.ca>

	Bug 387475 – Gtk-Warning spew in gnome-terminal

	Problem introduced by fix to bug 356552.

	* src/vte.c (vte_invalidate_cursor_periodic): Add a temporary backward
	compatibility hack to prevent GObject from spewing warnings about
	missing GtkSettings properties in old GTK versions.

2006-12-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 387482 – Variable modified in signal handler should be volatile
	Patch from Bastien Nocera

	* gnome-pty-helper/gnome-pty-helper.c: Make variable "done" volatile.

2006-12-08  Behdad Esfahbod  <behdad@gnome.org>

	Red Hat Bug 218626: "last -ad" print junk in last column

	* gnome-pty-helper/gnome-utmp.c (write_logout_record),
	(write_login_record): Don't gettimeofday directly into ut.ut_tv.
	That overruns on x86_64.

2006-12-05  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.15.0.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.15.0.

	* src/Makefile.am: Bumped libtool version to 10:7:1.

2006-12-05  Ryan Lortie  <desrt@desrt.ca>

	Bug 356552 – cursor timeout runs all the time

	* src/vte-private.h: Rework how cursor blinking works.
	* src/vte.c: Rework how cursor blinking works.  Only register the
	cursor blink callback when cursor blink is enabled and the window
	is focused.

2006-11-16 Mariano Suárez-Alvarez <mariano@gnome.org>

	Bug 307396 – Mouse scroll mode not controllable

	* src/vte.c(vte_terminal_scroll): make the scrollwheel scroll by tenths of
	a screen (or 1 line, whichever is bigger) instead of half screens.

2006-11-16 Mariano Suárez-Alvarez <mariano@gnome.org>

	Bug 356602 – const cast warning fixes for libvte
	Patch by Ryan Lortie (desrt)

	* src/matcher.h: Use const char * where appropriate.
	* src/matcher.c: Use const char * where appropriate.  Cast g_strdup
	to (GCacheDupFunc) to avoid a warning.
	* src/vtetc.h: Use const char * where appropriate.
	* src/vtetc.c: Use const char * where appropriate.  Cast g_strdup
	to (GCacheDupFunc) to avoid a warning.
	* src/vte.c: Use const char * where appropriate.

2006-11-01 Rich Burridge <rich.burridge@sun.com>

	* src/vteaccess.c:
	Fixed bug #150858 - In gnome-terminal, the deleted character 
	is reported as "space".

2006-10-13  Behdad Esfahbod  <behdad@gnome.org>

	* po/POTFILES.in: Include vteseq.c

2006-10-11  Mariano Suárez-Alvarez  <msuarezalvarez@arnet.com.ar>

	Bug 337252 – ALT + Arrow keys don't work in irssi through gnome-terminal

	* src/keymap.c (_vte_keymap_key_add_key_modifiers): Match the (newer)
	xterm behavior when reporting modifiers to things running in a terminal.

2006-10-02  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.14.1.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.14.1.

	* src/Makefile.am: Bumped libtool version to 10:6:1.

2006-10-02  Behdad Esfahbod  <behdad@gnome.org>

	Bug 358344 – autoscroll only works one way in fullscreen [PATCH]
	Patch by Egmont Koblinger

	* src/vte.c (vte_terminal_autoscroll),
	(vte_terminal_motion_notify): Fix forward autoscrolling in fullscreen
	mode.

2006-09-20  Behdad Esfahbod  <behdad@gnome.org>

	Bug 353756 – font setting cleanup

	* src/vte.c (vte_terminal_set_font_full): Use 'monospace' family if no
	font is set on a terminal widget

	* src/vte.c (vte_terminal_set_font_from_string_full): Don't
	g_return_if_fail(strlen(name) > 0).  An empty string is a perfectly
	valid pango font description string.

	* src/vte.c (vte_terminal_show): Make sure we have a font loaded.

	* src/vteapp.c (main): Don't fallback on "Monospace 12".  Let the
	widget decide what font to use if no font is set.

2006-09-18  Ryan Lortie  <desrt@desrt.ca>

	Bug 356616 – libvte broken with new autotools

	* configure.in:
	* src/Makefile.am: Fix broken variable substitution for newer
	versions of automake.

2006-09-13  Behdad Esfahbod  <behdad@gnome.org>

	Bug 354024 – Suppress multiple warnings for missing control sequence
	handlers
	Patch from Chris Wilson

	* src/vte.c (vte_terminal_handle_sequence): Suppress multiple warnings
	for missing control sequence handlers in non-debugging builds.

2006-09-13  Behdad Esfahbod  <behdad@gnome.org>

	Bug 354620 – vte-0.14.0: undefined C code
	Patch from Ales Nosek

	* src/ssfe.c (inschar), (dokbdchar): Replace "*(tmp+1)=(*tmp--);"
	with something well-defined.

2006-09-08  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am: Define G_LOG_DOMAIN=Vte.

2006-09-04  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.14.0.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.14.0.

	* src/Makefile.am: Bumped libtool version to 10:5:1.

2006-08-31  Behdad Esfahbod  <behdad@gnome.org>

	Bug 340631 – Printed lines containing tab characters are not wrapped 
	correctly

	* src/vteseq.c (vte_sequence_handler_ta): make sure we don't move the 
	cursor back when tabbing past the end of the line.

	* src/pty.c:
	* src/ring.c:
	* src/trie.c:
	* src/vte.c:
	* src/vtebg.c:
	* src/vtetc.c:
	Minor doc syntax update.

2006-08-26  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Followup on
	the fix for bug 350236.  It was causing empty lines not to be copied.

2006-08-24  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.7.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.7.

	* src/Makefile.am: Bumped libtool version to 10:4:1.

2006-08-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 352365 – font caching problem for not-found glyphs

	* src/vtexft.c (_vte_xft_font_for_char): Add caching on a missing
	path.  This only affects the second time a character is looked up.

	* src/vtexft.c (_vte_xft_font_close), (_vte_xft_font_for_char),
	(_vte_xft_char_width): Remove g_assert()'s that are not needed, as
	we will definitely crash pretty soon if the assertion is not true
	anyway.

2006-08-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 350236 – Cannot copy text containing invalid character sequences

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Fix another
	bug in my rewritten selection code, that was assuming that
	last_nonempty character is one byte long.

2006-08-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 352439 – URL highlighting seriously broken

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Followup to
	changes made for bug 350623.  Put back the g_array_set_size(), in the
	correct place this time.

2006-08-22  Behdad Esfahbod  <behdad@gnome.org>

	Bug 351494 – Gnome-terminal doesn't kills bash on tab close
	Patch from Aivars Kalvans

	* src/vte.c (vte_terminal_unrealize): Undo the change from bug 348814.
	Dispose draw in unrealize again, but also set has_fonts to FALSE.

2006-08-20  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.6.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.6.

	* src/Makefile.am: Bumped libtool version to 10:3:1.

2006-08-17  Behdad Esfahbod  <behdad@gnome.org>

	Bug 351696 – crash on Terminal

	* src/vteseq.c (vte_sequence_handler_set_title_internal): Check
	->window is not NULL before setting icon/window title.

2006-08-16  Willie Walker <william.walker@sun.com>

	Bug 350623 – Accessible text getTextAtOffset is broken

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Do not
	resize array before calling vte_g_array_fill since it
	nullifies any effect vte_g_array_fill will have.

2006-08-16  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Make sure
	attr.column is initialized.

2006-07-31  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.5.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.5.

	* src/Makefile.am: Bumped libtool version to 10:2:1.

2006-07-30  Behdad Esfahbod  <behdad@gnome.org>

	Bug 158200 – terminal backspace behavior not set to UTF-8 mode
	Based on patch from Egmont Koblinger

	* src/vte.c (_vte_terminal_setup_utf8),
	(vte_terminal_set_encoding), (_vte_terminal_fork_basic),
	(vte_terminal_set_pty): Make sure UTF-8 state is correctly set
	when pty changes.

2006-07-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 348814 – crash on Terminal
	Patch from Aivars Kalvans

	* src/vte.c (vte_terminal_unrealize): Do not dispose draw in
	unrealize.

2006-07-24  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.4.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.4.

	* src/Makefile.am: Bumped libtool version to 10:1:1.

2006-07-24  Behdad Esfahbod  <behdad@gnome.org>

	Bug 336947 – [patch] Redundant vte_terminal_set_font_full() calls
	Patch from Aivars Kalvans

	* src/vte-private.h:
	* src/vte.c (vte_terminal_set_font_full), (vte_terminal_init),
	(vte_terminal_realize):
	AVoid redundant set_font_full and invalidate_all calls.

2006-07-19  Behdad Esfahbod  <behdad@gnome.org>

	Bug 134800 – gnome-termnal hung up when input by ATOK
	Patch from Yukihiro Nakai  <nakai@gnome.gr.jp>

	* src/vte.c (vte_terminal_unrealize): Delay _vte_draw_free().

2006-07-19  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_extend_selection):  Oops.  Fix selection
	that I broke recently.

2006-07-11  Behdad Esfahbod  <behdad@gnome.org>

	Bug 339983 – gnome-pty-helper should log username
	Patch from Brian Cameron

	* gnome-pty-helper/gnome-pty-helper.c (pty_remove), (shutdown_pty),
	(pty_add), (open_ptys):
	* gnome-pty-helper/gnome-pty.h:
	* gnome-pty-helper/gnome-utmp.c (write_logout_record):
	Log username if system supports it.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.3.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.3.

	* src/Makefile.am: Bumped libtool version to 10:0:1.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 141985 – vte does not respond to 'CSI 2 1 t' or 'CSI 2 0 t' with
	the correct window/icon title
	Patch from Mariano Suárez-Alvarez

	* src/vte.c (vte_terminal_realize), src/vteseq.c
	* (vte_sequence_handler_set_title_internal): Set window/icon titles.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 121904 – copy-paste of empty line
	Bug 25290 – Small UI tweak to select-by-word (only select only letter
	at a time for non-word characters)
	Bug 339986 – Patch to select localized strings exactly

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_set_default_attributes),
	(_vte_terminal_insert_char), (vte_terminal_is_word_char),
	(vte_same_class), (vte_terminal_get_text_range_maybe_wrapped),
	(vte_terminal_extend_selection):
	* src/vteseq.c (vte_sequence_handler_screen_alignment_test):
	Fix a bunch of selection-related issues.  We now recognize explicitly
	put space at the end of lines, and copy/paste it.  The other change is
	that non-wordchar characters are not grouped together.  Also fixes the
	fallback on Unicode properties that I added two commits ago.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 311855 – Race in vte leads to blocking of input.
	Patch from Kalle Raiskila

	* src/vte-private.h:
	* src/vte.c (_vte_terminal_connect_pty_write),
	(_vte_terminal_disconnect_pty_write), (vte_terminal_init):
	Use a mutex for pty_output_source.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 339986 – Patch to select localized strings exactly
	Patch from Takao Fujiwara

	* src/vte.c (vte_terminal_is_word_char): Fall back on Unicode
	properties for non-ASCII characters or when no array is set.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 342396 – Ctrl-space sends " ", not NUL.

	* src/keymap.c (_vte_keymap_map): Fix keymap lookup bug that I
	introduced during the char*->char[] work on 2006-04-18.

2006-07-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 345377 – real transparency
	Patch from Kristian Høgsberg <krh redhat.com>

	* doc/reference/tmpl/vte.sgml:
	* doc/reference/vte-sections.txt:
	* python/vte.defs:
	* src/vte-private.h:
	* src/vte.c (vte_terminal_set_opacity), (vte_terminal_init),
	(vte_terminal_background_update):
	* src/vte.h:
	* src/vteapp.c (main):
	* src/vtedraw.c (_vte_draw_set_background_color):
	* src/vtedraw.h:
	* src/vteft2.c (_vte_ft2_set_background_color):
	* src/vtegl.c (_vte_gl_set_background_color):
	* src/vtepango.c (_vte_pango_set_background_color):
	* src/vtepangox.c (_vte_pango_x_set_background_color):
	* src/vteskel.c (_vte_skel_set_background_color):
	* src/vtexft.c (_vte_xft_create), (_vte_xft_set_background_color),
	(_vte_xft_clear):
	Add vte_terminal_set_opacity().

2006-07-05  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am: Allow _vte_debug_.* into exported symbols.

2006-06-21  Behdad Esfahbod  <behdad@gnome.org>

	Bug 345514 – -no-undefined doesn't work with latest libtool

	* src/Makefile.am: Remove -no-undefined.

2006-06-12  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.2.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.2.

	* src/Makefile.am: Bumped libtool version to 9:2:0.

2006-06-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 344666 – Problems with *_CFLAGS and *_LDFLAGS in makefiles
	Patch from Stepan Kasal <kasal@ucw.cz>.

	* src/Makefile.am (AM_CFLAGS, AM_LDFLAGS, *_CFLAGS, *_LDADD):
	Replace @FOO@ references by $(FOO), remove redundant (or buggy)
	occurences of `@CFLAGS@'.
	* gnome-pty-helper/Makefile.am (AM_CFLAGS, AM_LDFLAGS): Likewise.
	* python/Makefile.am (vtemodule_la_CFLAGS): Likewise.
	* src/Makefile.am (AM_CFLAGS): Add $(FT2_CFLAGS).

2006-06-08  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (remove_display_timeout): Fix typo which may have been
	causing things like crashes.  Reported by muntyan.  Also reordered
	some code around update_timeout for better matching the current
	timeouts in style.

2006-06-07  Behdad Esfahbod  <behdad@gnome.org>

	Bug 339529 – gnome-terminal (vte) crashes when detatched window is
	closed

	* src/vte.c (vte_invalidate_region): Bail out if terminal->window is
	NULL.

2006-05-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 342549 – uninitialized var (coverity)
	Patch from Paolo Borelli.

	* src/vte.c (vte_cell_is_selected): Remove uninitialized var ret.

2006-05-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 342082 – vte_invalidate_region() may check whether terminal is
	realiazed or not
	Patch from Kouhei Sutou.

	* src/vte.c (vte_invalidate_region): Return if not realized.

2006-05-22  Behdad Esfahbod  <behdad@gnome.org>

	Bug 340363 – vte Cygwin build fixes
	Patch from Cygwin Ports maintainer

	* configure.in, src/keymap.c, src/pty.c, src/ssfe.c, src/trie.c,
	src/utf8echo.c, src/vte.c, src/vteseq.c, src/vtetc.c: Check and
	include syslimits.h and ncurses/curses.h

2006-05-22  Behdad Esfahbod  <behdad@gnome.org>

	Bug 341793 – vte.h doesn't need to include X11/Xlib.h
	Patch from Kouhei Sutou

	* src/vte.h: Don't #include <X11/Xlib.h>

2006-05-17  Wouter Bolsterlee  <uws+gnome@xs4all.nl>

	* configure.in: Require intltool 0.35.0 to have
	translations in the dist tarballs.

2006-05-17  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.1.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.1.

	* src/Makefile.am: Bumped libtool version to 9:1:0.

2006-05-14  Behdad Esfahbod  <behdad@gnome.org>

	* NEWS, ChangeLog: Add vim and emacs footers for UTF-8.

2006-04-27  Behdad Esfahbod  <behdad@gnome.org>

	Bug 339980 – nativeecho needs glib in LDADD to build on Solaris
	Patch from Brian Cameron.

	* src/Makefile.am: Fix it.

2006-04-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 331803 – style needs to be attached/detached to the window on
	realize/unrealize
	Patch from Benjamin Berg  <benjamin@sipsolutions.net>.

	* src/vte.c: (vte_terminal_unrealize), (vte_terminal_realize):
	attach and detach the style of the terminal widget.

2006-04-25  Behdad Esfahbod  <behdad@gnome.org>

	* src/Makefile.am: Pass -no-undefined linker flag.

2006-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.13.0.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.13.0.

	* src/Makefile.am: Bumped libtool version to 9:0:0.

2006-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 339448 – selection doesn't respect hard newlines

	* src/vte.c (vte_terminal_get_text_range_maybe_wrapped): Add newline
	to the end of each line that is not soft-wrapped.

2006-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 148720 – Word selection erroneously captures text from next line
	Patch from Chris Heath.

	* src/vteseq.c (vte_sequence_handler_cd), (vte_sequence_handler_ce),
	(vte_sequence_handler_clear_current_line),
	(vte_sequence_handler_clear_above_current): Reset soft_wrapped flag.

2006-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 126376 – Uncoinditional definition of _XOPEN_SOURCE breaks build
	on NetBSD
	Patch from Dan Winship.

	* configure.in:
	* gnome-pty-helper/configure.in: Define XOPEN_SOURCE on solaris only.

2006-04-23  Behdad Esfahbod  <behdad@gnome.org>

	Bug 97719 – Selection: double/triple click doesn't cross line boundaries
	Patch from Chris Heath.

	* src/vte.c (vte_same_class): Fix problem with selecting whitespace
	from adjacent lines, on word selection.

2006-04-22  Behdad Esfahbod  <behdad@gnome.org>

	Bug 160782 – Vte isn't multi-screen safe
	Patch from Benedikt Meurer.

	* src/vte.c (vte_terminal_unrealize), (vte_terminal_realize):
	* src/vtebg.c (vte_bg_native_new), (_vte_bg_display_sync),
	(vte_bg_root_pixmap), (vte_bg_get_for_screen), (vte_bg_init),
	(vte_bg_get_pixmap), (vte_bg_get_pixbuf):
	* src/vtebg.h:
	* src/vteft2.c (_vte_ft2_set_background_image):
	* src/vtegl.c (_vte_gl_set_background_image):
	* src/vtepango.c (_vte_pango_set_background_image):
	* src/vtepangox.c (_vte_pango_x_set_background_image):
	* src/vtexft.c (_vte_xft_set_background_image): Handle per-screen
	backgrounds.

2006-04-22  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_cursor_new), (vte_terminal_clipboard_get):
	* src/vteapp.c (take_xconsole_ownership):
	* src/vtebg.c (vte_bg_native_new), (_vte_bg_display_sync),
	(vte_bg_root_pixmap):
	* src/vtedraw.c (_vte_draw_get_colormap):
	* src/vtefc.c (_vte_fc_transcribe_from_pango_font_description),
	(_vte_fc_defaults_from_gtk):
	* src/vtepango.c (_vte_pango_start), (_vte_pango_set_text_font):
	* src/vtepangox.c (_vte_pango_x_set_text_font):
	* src/vterdb.c (_vte_rdb_get):
	* src/vteseq.c (vte_terminal_beep),
	(vte_sequence_handler_window_manipulation):
	* src/vtexft.c (_vte_xft_char_exists), (_vte_xft_text_extents),
	(_vte_xft_font_open):
	* src/vtegl.c: Remove obsolete #ifde GTK_CHECK_VERSION(2,2,0) checks.

2006-04-22  Behdad Esfahbod  <behdad@gnome.org>

	Bug 330441 – Remove libzvt support
	Patch from Guilherme de S. Pastore  <gpastore@gnome.org>

	* configure.in, src/Makefile.am, src/reflect.c: remove remnants
	from the old, broken, and unmaintained libzvt.

2006-04-21  Behdad Esfahbod  <behdad@gnome.org>

	Bug 328850 – Crash when pasting selection

	* src/vte.c: Protect against passing NULL selection to strcmp.

2006-04-20  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/tmpl/internals.sgml:
	* doc/reference/tmpl/reaper.sgml:
	* doc/reference/tmpl/vte-unused.sgml:
	* doc/reference/tmpl/vte.sgml:
	* doc/reference/tmpl/vteaccess.sgml:
	* doc/reference/vte-sections.txt: Misc fixes and updates.

	* python/vte.defs:
	* python/vte.override: Updates.

	Bug 160134 – mouse events occurring past column 95 are not passed
	through to terminal application
	Based on patch from Sean Estabrooks.

	* src/vte.h:
	* src/vte.c (vte_terminal_feed_child_binary): New public function.

	* src/vte.c (vte_terminal_send_mouse_button_internal),
	(vte_terminal_maybe_send_mouse_drag): Use feed_child_binary.

2006-04-19  Behdad Esfahbod  <behdad@gnome.org>

	Bug 135230 – Feature request to attach VTE to existing pty
	Based on patch from eric@brouhaha.com, John Swensen, and
	Chris Moller  <cmoller@redhat.com>

	* src/vte.c:
	* src/vte.h:
	* python/vte.defs:
	* doc/reference/vte-sections.txt: Added vte_terminal_set_pty().

2006-04-18  Behdad Esfahbod  <behdad@gnome.org>

	Bug 337442 – [patch] Reduce .plt section

	* src/Makefile.am: Pass export-symbols-regex to libtool.

2006-04-18  Behdad Esfahbod  <behdad@gnome.org>

	* src/caps.c (_vte_capability_init), src/caps.h:
	* src/keymap.c (_vte_keymap_map), src/keymap.h: Make some data
	structures const by changing char * to char [].

	* src/vte.c (vte_update_delay_timeout), (vte_update_timeout),
	(vte_terminal_extend_selection), (_vte_terminal_fudge_pango_colors):
	Fix warnings and adapt to above changes.

2006-04-18  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in, po/LINGUAS: Use intltool 0.34.90 format.

2006-04-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 142247 – use of uninitialized value

	* src/pty.c: Initialize the arbitrary byte that we send on the pipe
	to zero.

2006-04-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 149633 – gnome-terminal messes up boxdrawing chars aligment

	* src/vte.c: Try to use the font first for all graphic characters.
	This results in better looking graphics with modern fonts.

2006-04-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 144456 – UK pound currency symbol rendered incorrectly

	* src/vte.c: Offset characters drawn in draw_graphic for padding.

2006-04-12  Behdad Esfahbod  <behdad@gnome.org>

	Bug 307403 – xticker doublefree

	* src/xticker.c: Avoid double free.

2006-04-10  Behdad Esfahbod  <behdad@gnome.org>

	Bug 337877 – Patch to use po/LINGUAS
	Patch from Michiel Sikkes.

	* configure.in, po/LINGUAS: Move list of translations to po/LINGUAS.

2006-04-06  Behdad Esfahbod  <behdad@gnome.org>

	Bug 337552 – Insufficient version requirement for gtk+

	* configure.in: Depend on Gtk+ 2.6.

2006-03-30  Behdad Esfahbod  <behdad@gnome.org>

	Bug 168251 – add support for 256 colors terminals
	Patch from dann@godzilla.ics.uci.edu.

	* src/vte-private.h, src/vte.c, src/vteseq.c: Implement support
	for 256 colors.

2006-03-30  Behdad Esfahbod  <behdad@gnome.org>

	Bug 120276 – Wishlist: Support Rectangular Selection
	Patch from Pedro de Medeiros.

	* src/vte.c, src/vte-private.h: Implement block (rectangular)
	selection using ctrl+mouse.

2006-03-30  Behdad Esfahbod  <behdad@gnome.org>

	Bug 336117 – [patch] Use g_slice API
	Patch from Aivars Kalvans.

	* src/*.c: Use g_slice instead of g_malloc for structs.
	Also, replace g_string_new("") with g_string_new(NULL).

2006-03-30  Behdad Esfahbod  <behdad@gnome.org>

	Branchpoint for vte-0-12.

2006-03-30  Guntupalli Karunakar  <karunakar@indlinux.org>

	* configure.in: Added "dz" (Dzongkha) to ALL_LINGUAS.

2006-03-26  Behdad Esfahbod  <behdad@gnome.org>

	Bug 336128 – vim scrolling issues - emulation errors

	* src/vteseq.c (vte_sequence_handler_sf): Update start and end
	when updating insert_delta.

2006-03-15  Behdad Esfahbod  <behdad@gnome.org>

	Bug 334385 – Use intltool

	* Makefile.am, configure.in: Add intltool support.

	* src/iso2022.c, src/reaper.c, src/vteaccess.c, src/vteapp.c,
	src/vtebg.c, src/vtexft.c, src/vte.c: Include glib/gi18n-lib.h
	instead of #ifdefing gettext stuff.

	* src/vte.c (vte_terminal_class_init): Use GETTEXT_PACKAGE instead
	of PACKAGE in bindgettextdomain.

2006-03-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_size_allocate): More tweaks to the
	previous changes.  Reported by dholbach again.

2006-03-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_size_allocate): Put the stuff changed in
	previous commit in their original order.  Problem reported by
	dholbach.

2006-03-13  Behdad Esfahbod  <behdad@gnome.org>

	Bug 104841 – scrolling doesn't work inside "screen" windows

	* src/vte.c (vte_terminal_size_allocate): Fix restricted scrolling
	region readjustment.  Moreover, do not do unnecessary updates when
	number of rows & columns has not changed.

2006-03-13  Behdad Esfahbod  <behdad@gnome.org>

	Bug 333768 – vteapp debug stuff should be conditional
	Patch from Egmont Koblinger.

	* src/vteapp.c: Make pwd and setting env vars conditional on debug.

2006-03-08  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.12.0.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.12.0.

2006-03-09  Abel Cheung  <maddog@linuxhall.org>

	* configure.in: Readd kn to ALL_LINGUAS and make sure everything
	builds fine.

2006-03-08  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.11.21.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.11.21.

	* configure.in: Removed kn from ALL_LINGUAS, as it was breaking
	the build.

2006-03-08  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c, src/vte-private.h: Fix vte_update_timeout repeat to
	25ms. (bug #333776, Egmont Koblinger)

2006-03-07  Abel Cheung  <maddog@linuxhall.org>

	* configure.in: Added "kn" "zh_HK" to ALL_LINGUAS.

2006-02-28  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte-private.h: Step up COALESCE_TIMEOUT and DISPLAY_TIMEOUT
	from 2ms to 10ms.  This is more compatible with the updated timeout
	that we are doing at around 25ms.

2006-02-27  Behdad Esfahbod  <behdad@gnome.org>

	* MAINTAINERS: Added.

2006-02-25  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.11.20.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.11.20.

2006-02-25  Behdad Esfahbod  <behdad@gnome.org>

	* src/vtexft.c: (_vte_xft_font_for_char): Rever the patch to
	optimize memory usage by releasing fonts that aren't needed early.
	Because that was inserting destroyed fonts into cache. Closes bug
	#332580 and reverts bug #309322.

2006-02-25  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.11.19.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.11.19.

2006-02-17  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Make shift+insert paste PRIMARY and ctrl+shift+insert
	paste CLIPBOARD (switched them. bug #123844)

2006-02-17  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Better update-timeout handling.  Always delay updates
	a bit.  Schedule updates as G_PRIORITY_DEFAULT_IDLE.  And, set delay
	as the number of lines, in milliseconds.

2006-02-14  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq-gen.c (main): Return 0.  (bug #331178)

2006-02-14  Behdad Esfahbod  <behdad@gnome.org>

	* gnome-pty-helper/gnome-pty-helper.c (main): Use getpwnam to
	correctly log multiple users with the same UID. (bug #319564,
	patch from Laszlo (Laca) Peter.

2006-02-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (update_timeout): Only discontinue timer if nothing
	was updated in the last cycle.

2006-02-13  Behdad Esfahbod  <behdad@gnome.org>

	* gnome-pty-helper/gnome-pty-helper.c: Fix race condition when
	shutdown_helper may be called again from the signal handler when
	it's already running. (bug #331056)

2006-02-13  Behdad Esfahbod  <behdad@gnome.org>

	* configure.in: Do not prepend X_LIBS and X_CFLAGS to LIBS and
	CFLAGS. (bug #331021, Sylvain BERTRAND)

2006-02-13  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (vte_terminal_key_press): Handle Ctrl+Shift+Insert to
	paste PRIMARY.

2006-02-11  Behdad Esfahbod  <behdad@gnome.org>

	Released vte-0.11.18.

	* NEWS: Updated.

	* configure.in: Bumped version to 0.11.18.

2006-02-11  Behdad Esfahbod  <behdad@gnome.org>

	* src/iso2022.c: Change INVALID_CODEPOINT from 0xFFFF to 0xFFFD.
	(bug #317235, Egmont Koblinger)

2006-02-11  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_invalidate_cells): Guard more against off values.

2006-02-10  Behdad Esfahbod  <behdad@gnome.org>

	Update the build infrastructure.  make distcheck works now!

	* autogen.sh: Use a generic autogen.sh that uses gnome-common.

	* configure.in: Simplify gtk-doc stuff.  Update to newer syntax.

	* Makefile.am, src/Makefile.am, doc/reference/Makefile.am: Updated.

2006-02-10  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c (_vte_invalidate_cells): Throttle invalidating to at most
	40 times per second, using a timeout.

2006-02-10  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteseq.c: Removed the huge sequence handler table.  Changed to
	use the compact tables in vteseq-table.h.

	* src/vteseq-gen.c: Generator containing the table removed from above,
	that generates compact tables.

	* src/vteseq-table.h: Table generated by above.  Can be regenerated
	using make.

	* src/Makefile.am: Adjusted.

	* src/vteapp.c: Set default font to Monospace instead of Sans.

2006-02-10  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Allocate terminal->pvt using GObject private data.

2006-02-10  Behdad Esfahbod  <behdad@gnome.org>

	Moved all sequence handler codes into a separate file.

	* src/vte.c: Stuff moved to other files.

	* src/vte-private.h: Includes all struct definitions from vte.c.

	* src/vteseq.c, src/vteseq.h, src/vteseq-list.h: The sequence
	handlers are all here now.

2006-02-09  Behdad Esfahbod  <behdad@gnome.org>

	* src/vteapp.c: Make a couple debug messages conditional on
	DEBUG_MISC.

2006-02-03  Behdad Esfahbod  <behdad@gnome.org>

	* src/vte.c: Warning cleanup.  A couple were actually bugs.

	* src/vteapp.c: No need to run $SHELL by default.  Handled
	by vte.c now.  A bug was causing nothing to be run...

2006-02-03  Behdad Esfahbod  <behdad@gnome.org>

	* src/debug.c, src/debug.h, src/matcher.c: Add the debug
	flag TRIE for printing out the trie (previous was using
	MISC.)

	* src/vte.c (vte_invalidate_cells): Update row_count and
	column_count when clamping their respective _start values.

	* src/vte.c (vte_terminal_extend_selection, _vte_terminal_select_text): 
	Pass row_count to vte_invalidate_cells(), instead of row_stop.

	* src/vteapp.c: Run $SHELL by default.

2006-02-01  Behdad Esfahbod  <behdad@gnome.org>

	* doc/reference/tmpl/internals.sgml: Added to CVS.

	* vte/src/vte.c: Fix selection vs. primary that have been
	borked forever. Closes bug #123844.

2006-01-30  Guilherme de S. Pastore  <gpastore@gnome.org>

	* src/trie.c: applied patch from Tomas Mraz to fix a double
	  free. Closes bug #161337.

2006-01-30  Erdal Ronahi  <erdal.ronahi@gmail.com>

	* configure.in: added ku (Kurdish) to ALL_LINGUAS

2006-01-28  Guilherme de S. Pastore  <gpastore@gnome.org>

	* src/Makefile.am: add -DG_DISABLE_ASSERT to CFLAGS.

	* NEWS: updated.

	* vte.spec: bumped version to 0.11.17.

2006-01-28  Guilherme de S. Pastore  <gpastore@gnome.org>

	* src/vte.c: only try to guess the user's shell when actually
	  forking, so we avoid unnecessary work if the application
	  already has to do that itself.
	
2006-01-15  Guilherme de S. Pastore  <gpastore@gnome.org>

	* src/: applied patch from Kjartan Maraas that replaces g_return
	  functions with g_assert. Should give an 8% speed boost.

2006-01-14  Guilherme de S. Pastore  <gpastore@gnome.org>

	* doc/reference/Makefile.am: install more than *.html, based on the
	  patch from Ed Catmur. Closes bug #321909.

2006-01-14  Olav Vitters  <olav@bkor.dhs.org>

	* src/caps.c: Support save and restore cursor position using \033[s
	and \033[u. Reported by Dag Wieers. Fixes bug 170032.

2005-12-31  Olav Vitters  <olav@bkor.dhs.org>

	* vte.pc.in: Backup patch from Steve Langasek. It needs pkg-config
	changes.

2005-12-12  Kjartan Maraas  <kmaraas@gnome.org>

	* vte.pc.in: Cleanups for the pkg-config file.
	Patch from Steve Langasek. Closes bug #322240.

2005-12-12  Kjartan Maraas  <kmaraas@gnome.org>

	* python/vte.override: python-vte seems to have a small bug in
	the override file that prevents the forkpty() method to be generated.
	The attached patch fixes this problem. Patch from Michael Vogt.
	Closes bug #169201.

2005-11-30  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vte.c: (vte_terminal_preedit_length): Remove some
	unused code.
	(vte_terminal_process_incoming): Don't emit signals for every
	character that's output. Patch from Padraig O'Briain. Huge
	performance gain when a11y is activated.

2005-11-16  Timur Jamakeev  <timurj@cvs.gnome.org>

	* confgiure.in: Added 'ky' to ALL_LINGUAS

2005-11-08  Kjartan Maraas  <kmaraas@gnome.org>

	* NEWS: Update.
	* Makefile.am:
	* autogen.sh:
	* configure.in:
	* python/Makefile.am:
	I'm attaching a patch that modernizes the python binding 
	build stuff. Notably, it excludes python/vte.c from the dist.
	Right now as it stands, the file is disted, which means people's 
	builds will not work unless they build against pygtk 2.8, 
	which makes this bug somewhat important. Patch from Manish Sing
	Closes bug #320931.

2005-11-01  Bill Haneman <billh@gnome.org>

	* src/vteaccess.c: 
	(vte_terminal_accessible_get_text):
	Swap offsets if start > end; fixes crasher
	bug #153405.  Patch from padraig o'briain,
	thanks to Kjartan for review.

2005-10-02  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vtebg.c: (_vte_property_get_pixmaps):
	* src/vterdb.c: (_vte_property_get_string):
	Fix gdk warnings. Patch from Michele Baldessari.
	Closes bug #309025.

2005-09-16  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vtexft.c: (_vte_xft_font_for_char): Optimize memory
	usage by releasing fonts that aren't needed early. Patch
	from Mike Hearn. Closes bug #309322.

2005-08-13  Kjartan Maraas  <kmaraas@gnome.org>

	* gnome-pty-helper/gnome-pty-helper.c: (init_msg_pass):
	Make VTE work on NetBSD, OpenBSD (sparc and macppc).
	Reported by Adrian Bunk, patches by Dan Winship and
	Rich Edelman. Closes bug #126554.

2005-08-12  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vtetc.c: (_vte_termcap_destroy): Don't crash
	if there's no termcap file. Michele Baldessari
	Closes bug #312260.

2005-08-12  Kjartan Maraas  <kmaraas@gnome.org>

	* configure.in: Correct test for recvmsg(). Patch from
	Robert Basch. Closes bug #304815 and possibly bug #122055.

2004-08-10  Kjartan Maraas  <kmaraas@gnome.org>

	Patch from: Padraig O'Briain  <padraig.obriain@sun.com>
	Closes bug #113590.

	* src/vte.c, src/vteint.h:
	Add new functions to support accessible text selection:
	_vte_terminal_get_selection, _vte_terminal_get_start_selection,
	_vte_terminal_get_end_selection, _vte_terminal_select_text,
	_vte_terminal_remove_selection
	* src/vteaccess.c:
	(xy_from_offset): Fix for offset being entire text.
	(vte_terminal_accessibility_selection_changed): VteTerminal's
	selection-changed signal handler which emits text-selection-changed
	signal.
	(vte_terminal_accessible_initialize): Connect to VteTerminal's
	selection-changed signal.
	(vte_terminal_accessible_get_n_selections) Add implementation.
	(vte_terminal_accessible_get_selection) Add implementation.
	(vte_terminal_accessible_add_selection) Add implementation.
	(vte_terminal_accessible_remove_selection) Add implementation.
	(vte_terminal_accessible_set_selection) Add implementation.

2005-08-05  Kjartan Maraas  <kmaraas@gnome.org>

	* gnome-pty-helper/gnome-pty-helper.c: (exit_handler), (main):
	Clean up utmp/wtmp under vncserver if things fall apart under
	the terminal. (Dave Lehman). Closes bug #312373

2005-07-26  Michele Baldessari  <michele@pupazzo.org>

	* python/vte.override (_wrap_vte_terminal_set_colors): 
	pyg_boxed_get should be on item not py_palette. 
	Reported with fix by Ethan Glasser-Camp <glasse@rpi.edu>
	Closes bug #311570

2005-07-25  Michele Baldessari  <michele@pupazzo.org>

	* src/vtepango.c (_vte_pango_create): Initialize 
	PangoContext * data->ctx with NULL. Closes bug #126262

2005-07-21  Danilo Šegan  <danilo@gnome.org>

	Fixes #149925.
	
	* src/vte.c (vte_terminal_io_read): Added simple comment for 
	translators.

2005-07-07  Matthias Clasen  <mclasen@redhat.com>

	* src/vte.c (vte_terminal_unrealize): Unset the user data
	on the gdk window. 

2005-06-15  Theppitak Karoonboonyanan  <thep@linux.thai.net>

	* configure.in: Added 'th' (Thai) to ALL_LINGUAS.

2005-06-11  Kjartan Maraas  <kmaraas@gnome.org>

	* NEWS: Update some.
	* doc/reference/tmpl/reaper.sgml:
	* doc/reference/tmpl/vte-unused.sgml:
	* doc/reference/tmpl/vte.sgml:
	* doc/reference/tmpl/vteaccess.sgml: Docs updates.
	* src/vte.c: (vte_terminal_init), (vte_terminal_finalize),
	(vte_terminal_get_accessible), (vte_terminal_class_init):
	Apply patch from Padraig O'Briain <padraig.obriain@sun.com>
	to fix a crash. Closes bug #119913.

2005-06-09  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vte.c: (vte_terminal_style_changed):
	Fix a crash when reparenting. Closes bug #169326.
	Patch from Michele Baldessari.

2005-06-05  Ignacio Casal Quinteiro  <nacho.resa@gmail.com>

	* configure.in: Added 'gl' to ALL_LINGUAS.

2005-04-29  Kjartan Maraas  <kmaraas@gnome.org>

	* src/table.c: (_vte_table_literal_new), (_vte_table_free),
	(_vte_table_addi), (_vte_table_matchi), (_vte_table_match),
	(_vte_table_printi): Final bits of the memory reduction patch
	from Aivars Kalvans. bug #160993 comment #9
	* src/vte.c: (vte_terminal_scroll_region): Patch from Egmont
	Koblinger to fix some scrolling issues. bug #164153
	* vte.spec: Bump version.

2005-04-07  Abduxukur Abdurixit  <abduxukur.abdurixit@t-systems.ch>

	* configure.in: Added "ug" to ALL_LINGUAS.

2005-04-01  Adi Attar  <aattar@cvs.gnome.org>

	* configure.in: Added "xh" to ALL_LINGUAS.

2005-03-31  Steve Murphy  <murf@e-tools.com>

        * configure.in: Added "rw" to ALL_LINGUAS.

2005-03-29  Kjartan Maraas  <kmaraas@gnome.org>

	* autogen.sh: Use head -n 1 instead of head -1 to avoid
	warning about the latter being deprecated in newer versions.
	Reported by Ali Akcaagac. Closes bug #156022.
	* vte.spec: Bump version

2005-03-16  Manish Singh  <yosh@gimp.org>

	* python/vtemodule.c: Remove stray underscores so python module
	works again. Fixes bug #150760.

2005-03-14  Kjartan Maraas  <kmaraas@gnome.org>

	* src/Makefile.am: 
	* src/interpret.c: (main):
	* src/matcher.c: (_vte_matcher_add), (_vte_matcher_init),
	(_vte_matcher_create), (_vte_matcher_destroy), (_vte_matcher_new),
	(_vte_matcher_free):
	* src/matcher.h:
	* src/vte.c: (vte_terminal_set_emulation), (vte_terminal_init):
	* src/vtetc.c: (_vte_termcap_create), (_vte_termcap_destroy),
	(_vte_termcap_new), (_vte_termcap_free):
	* src/vtetc.h: Add patch for excessive memory consumption when
	opening new tabs. This patch makes struct _vte_matcher and
	struct _vte_termcap shared between terminals and should reduce
	memory consumption with multiple tabs a lot. Patch from Aivars
	Kalvans <kalvans at inbox lv>. From bug #160993.

2005-03-14  Kjartan Maraas  <kmaraas@gnome.org>

	* src/vte.c: (vte_terminal_scroll_region),
